VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CycAccessClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents Winsock1 As Winsock
Attribute Winsock1.VB_VarHelpID = -1
Private strDomainName As String
Private blnGotData As Boolean
Private strDataReturned As String


Dim strServ As String
Dim cycPort As Integer
Dim connTimeOut As Long

Dim strTo As String
Dim strFrom As String
Dim strSubj As String
Dim strMsg As String
Dim strStatus As String
'CycSpecific
Dim strMicroTheory As String
Dim strConstant As String
Dim strPred As String
Dim strArgs As String
Dim strFunc As String

Dim strQuery As String
Dim strTime As String
Dim strBackchain As String
Dim strDepth As String
Dim strStrength As String
Dim strDirection As String
Dim strNumber As String
Dim strReconsider_deep As String
Dim strProperties As String
Dim strVerify_supports As String
Dim strCase_sensitiveQ As String
Dim strExternal_id As String

Dim strName_prefix As String
Dim strTerm_ids As String
Dim strArg As String
Dim strPredicate As String

Dim strprojectName As String
Dim strcyclistName As String

Dim MsgIn As String
Dim iCode As Integer
Dim lFalseColor As Long
Dim lTrueColor As Long
Dim sTrueText As String
Dim sFalseText As String
Dim CycBinds As collection
Dim CycVars As collection
Dim RecPtr As Long
Dim bNoMatch As Boolean

Dim GuiC As Control
Dim strCreatedPlans As String

Public Event ConnectCYC()
Attribute ConnectCYC.VB_Description = "Connection to Cyc established."
Public Event SendCYC()
Attribute SendCYC.VB_Description = "Event triggered when message has been sent to Cyc."
Public Event CloseCYC()
Attribute CloseCYC.VB_Description = "Closed connection to cyc event."
Public Event ErrorCYC(ByVal Number As Integer, Description As String)
Attribute ErrorCYC.VB_Description = "Returns when an internal error occurs inside the control."
Public Event ReplyCYC(query As String, Response As String)
Attribute ReplyCYC.VB_Description = "Event is triggered with each answer parsed from Cyc's response."
Public Event PreQueryCyc(query As String)
Attribute PreQueryCyc.VB_Description = "Event triggered before the message is sent to Cyc"
Public Event QueryReplyCYC(query As String, Variable As String, Response As String)
Attribute QueryReplyCYC.VB_Description = "Returns the Last Response returned by Cyc."
Public Event CycAsserted(Asserted As String)

'----------------------Some Common Cyc Constants---------------

Const Comment_const = "#$comment"
Const universalVocabularyMt_const = "#$UniversalVocabularyMt"
Const collection_const = "#$Collection"
Const isa_const = "#$isa"
Const genls_const = "#$genls"
Const genlsPreds_const = "#$genlPreds"
Const genlMt_const = "#$genlMt"
Const conceptuallyRelated_const = "#$conceptuallyRelated"
Const binaryPredicate_const = "#$binaryPredicate"
Const spindleMt_const = "#$SpindleMicrotheory"
Const predicateType_const = "#$predicateType"
Const baseKB_const = "#$BaseKB"

'--------------------------------------------------------------

'Server Side Global Properties --------------------
' Server : the internet name of the CYC server
' Port : the port number (default 3601)
' MicroTheory: the default MT on the server to use
'
'OPTIONS -----------------------------------------
' backchain: NIL, N or T (enables backchaining)
' number : NIL or N (number of bindings to return)
' time : NIL or N (time limit)
' depth: NIL or N (depth to search)
' Conditional-Sentence: NIL or T
'
'Variables --------------------------------------
' Constant: the default constant
'
'Basic Operations--------------------------------
' Direct(Msg$) Sends Message and returns response with no interpertation
' LastReply$   The LastReply Cyc Sent
' KE(KEstring$) one line processed in KE format
'
' assertisa(X)
' assertgenls(X)
' assertgenlmt(X)
' assertpred(P,X)
' assertformula(F)
'
' askisa
' askgenls
' askgenlmt
' askpred(P)
' askformula(F)
'
'
'Collection based Bind listing
' The last response is parsed and stored as a collection of collections
' the first in indexless, and the second keyed by the query variables
'
' BindList : the root collection CycBinds
' BindCount : CycBinds.Count
' BindValue(N,Var$) : CycBinds.Item(N).Item(Var$)
'----------------------------------------------------------------
' The following require special definitions (ADO and MsFlexGrid)
' and are outside the default control set
'----------------------------------------------------------------
'
'ADO DB Recordbased Model
' OpenRecordSet(CycQuery) : returns a record set looking like a table of bindings
' GetOpenRecordSet()      : returns a recordset representing the values of the last bindings
'
'GUI direct
' FillList(Control)
'        will provide default filling for a MsFlexGrid, listbox, combobox and textbox
' FillList(Control,Variable)
'         same as above but limits to only the variable name provided
'


Dim wsTCP 'As oswinsck.TCP

Private WithEvents objWinSock As MSWinsockLib.Winsock
Attribute objWinSock.VB_VarHelpID = -1
Private bConnected As Boolean
Private bContinueData As Boolean
Private bProgress As Boolean
Private strData As String
'*----------------------------------------------------------*
'* Name       : strtok                                      *
'*----------------------------------------------------------*
'* Purpose    : The function tokenizes strVar, using any    *
'*            : delimiters found in delims.                 *
'*            : Similar to the function found in C          *
'*----------------------------------------------------------*
'* Parameters : strVar Required. String to be tokenized.    *
'*            : delims Required. Delimiters list.           *
'*----------------------------------------------------------*
'* Description:   When first time called strVar must contain*
'*            : the string to be tokenized, otherwise       *
'*            : vbNullString (""). delims contains the      *
'*            : delimiters which are valid to tokenize      *
'*            : strVar.                                     *
'*            :   strtok keeps a local copy of the rest of  *
'*            : strVar which has not been tokenized         *
'*            :   If no delimiter can be found in strVar the*
'*            : whole string is returned                    *
'*            :   If there are no more tokens left,         *
'*            : vbNullString ("") is returned               *
'*----------------------------------------------------------*
'* Original idea by Steinebach                              *
'* Improved by Serge Baranovsky                             *
'*----------------------------------------------------------*
Public Function strtok(strVar As String, delims As String) As String
  Static stmp As String
  Dim i As Long

  strtok = vbNullString

  'Initialize first time calling
  If strVar <> vbNullString Then
    stmp = strVar
  End If

  'Nothing left to tokenize!
  If stmp = vbNullString Then
    Exit Function
  End If

search_for_next_delimiter:

  'Loop until we find a delimiter
  For i = 1 To Len(stmp)

    If InStr(1, delims, Mid$(stmp, i, 1), vbBinaryCompare) > 0 Then

      If i > 1 Then
        strtok = Left(stmp, i - 1)
        stmp = Mid$(stmp, i + 1, Len(stmp) - i)
        Exit Function
      Else
        ' string starts with delimiter, so skip one
        stmp = Right$(stmp, Len(stmp) - 1)
        GoTo search_for_next_delimiter
      End If

    End If

  Next i

  'Did not find any, return whatever is left in stmp
  strtok = stmp
  stmp = vbNullString
End Function
Public Function QueryWhois(ByVal DomainName As String)
   Set Winsock1 = New Winsock
   
   Winsock1.Close
   Winsock1.LocalPort = 0
   Winsock1.Connect "rs.internic.net", 43
   
   strDomainName = DomainName
   
   DoEvents
   Wait 10, blnGotData
   
   QueryWhois = blnGotData
End Function

Private Sub Winsock1_Close()
   blnGotData = True
End Sub

Private Sub Winsock1_Connect()
   Winsock1.SendData strDomainName & vbCrLf
End Sub

Public Property Get DataReturned() As String
   DataReturned = strDataReturned
End Property

Private Sub Winsock1_DataArrival(ByVal bytesTotal As Long)
   Dim strData As String

   Winsock1.GetData strData
   strDataReturned = strDataReturned & strData
End Sub

Private Sub Class_Terminate()
   If IsObject(Winsock1) Then
       Set Winsock1 = Nothing
   End If
End Sub

Private Sub Wait(ByVal intSec As Integer, ByVal blnGotData As Boolean)
   Dim sngTime As Single
     
   sngTime = Timer
   Do
       'correction if midnight occurs
       If sngTime > Timer Then
           sngTime = sngTime - 86400
       End If
       DoEvents
   Loop Until sngTime + intSec <= Timer Or blnGotData
End Sub
Private Sub PropertyChanged(ByVal x As String)

End Sub
Public Sub DefaultInit()
    UserControl_Initialize
End Sub

Public Property Let ConnectionTimeOut(ByVal lTemp As Long)
  connTimeOut = lTemp
  PropertyChanged "ConnectionTimeOut"
End Property
Public Property Get ConnectionTimeOut() As Long
  ConnectionTimeOut = connTimeOut
End Property


Public Property Let Server(ByVal strTemp As String)
Attribute Server.VB_Description = "The IP address or DNS Server name of the Cyc server to connect to. (default=""localhost"")"
  strServ = strTemp
  PropertyChanged "Server"
End Property
Public Property Get Server() As String
  Server = strServ
End Property
Public Property Let Port(ByVal lTemp As Long)
Attribute Port.VB_Description = "Sets the IP port of the CYC server. (default=3601)"
  cycPort = lTemp
  PropertyChanged "Port"
End Property
Public Property Get Port() As Long
  Port = cycPort
End Property
Public Property Let Microtheory(ByVal strTemp As String)
Attribute Microtheory.VB_Description = "Sets the Default MicroTheory for all operations."
  strMicroTheory = strTemp
  PropertyChanged "Microtheory"
End Property
Public Property Get Microtheory() As String
  Microtheory = strMicroTheory
End Property

Public Property Let projectName(ByVal strTemp As String)
  strprojectName = strTemp
  PropertyChanged "projectName"
End Property
Public Property Get projectName() As String
  projectName = strprojectName
End Property

Public Property Let cyclistName(ByVal strTemp As String)
  strcyclistName = strTemp
  PropertyChanged "cyclistName"
End Property
Public Property Get cyclistName() As String
  cyclistName = strcyclistName
End Property



Public Property Let constant(ByVal strTemp As String)
Attribute constant.VB_Description = "The variable used to indicate the object that is the focus of ask* and assert* functions."
  strConstant = strTemp
  If Left$(strConstant, 1) <> "#" Then strConstant = "#$" + strConstant
  PropertyChanged "Constant"
End Property
Public Property Get constant() As String
  constant = strConstant
End Property
Public Property Get LastReply() As String
  LastReply = MsgIn
End Property
Public Property Get ResponseCode() As Integer
  ResponseCode = iCode
End Property
Public Property Get BindList() As collection
Attribute BindList.VB_Description = "Returns the collection of Cyc responses."
  Set BindList = CycBinds
End Property
Public Property Get BindCount() As Integer
Attribute BindCount.VB_Description = "The number of answers returned."
  BindCount = CycBinds.Count
End Property
Public Property Get BindValue(ByVal AnswerN As Integer, ByVal Variable As String) As String
Attribute BindValue.VB_Description = "Returns the valued of Variable in answer indexed by AnswerN."
On Error Resume Next
  BindValue = CycBinds.Item(AnswerN).Item(Variable)
End Property
Public Property Get BindAsk(ByVal AnswerN As Integer) As String
Attribute BindAsk.VB_Description = "Returns the binding of the first variable of the answer returned. For use with askIsa,askgenls,askgenlMt and accessing other single variable query responses."
On Error Resume Next
  BindAsk = CycBinds.Item(AnswerN).Item(1)
End Property

Public Property Let Pred(ByVal strTemp As String)
  strPred = strTemp
  PropertyChanged "Pred"
End Property
Public Property Get Pred() As String
  Pred = strPred
End Property

Public Property Let Args(ByVal strTemp As String)
  strArgs = strTemp
  PropertyChanged "Args"
End Property
Public Property Get Args() As String
  Pred = strArgs
End Property

Public Property Let Func(ByVal strTemp As String)
  strFunc = strTemp
  PropertyChanged "Func"
End Property
Public Property Get Func() As String
  Pred = strFunc
End Property
Public Property Let query(ByVal strTemp As String)
Attribute query.VB_Description = "Returns the last Message sent to Cyc."
  strQuery = strTemp
  PropertyChanged "Query"
End Property
Public Property Get query() As String
  query = strQuery
End Property
Public Property Let Time(ByVal strTemp As String)
  strTime = strTemp
  PropertyChanged "Time"
End Property
Public Property Get Time() As String
  Microtheory = strTime
End Property
Public Property Let BackChain(ByVal strTemp As String)
  strBackchain = strTemp
  PropertyChanged "Backchain"
End Property
Public Property Get BackChain() As String
  BackChain = strBackchain
End Property
Public Property Let Depth(ByVal strTemp As String)
  strDepth = strTemp
  PropertyChanged "Depth"
End Property
Public Property Get Depth() As String
  Depth = strDepth
End Property
Public Property Let Strength(ByVal strTemp As String)
  strStrength = strTemp
  PropertyChanged "Strength"
End Property
Public Property Get Strength() As String
  Strength = strStrength
End Property
Public Property Let Direction(ByVal strTemp As String)
  strDirection = strTemp
  PropertyChanged "Direction"
End Property
Public Property Get Direction() As String
  Direction = strDirection
End Property
Public Property Let Number(ByVal strTemp As String)
  strNumber = strTemp
  PropertyChanged "Number"
End Property
Public Property Get Number() As String
  Number = strNumber
End Property
Public Property Let Reconsider_deep(ByVal strTemp As String)
  strReconsider_deep = strTemp
  PropertyChanged "Reconsider_deep"
End Property
Public Property Get Reconsider_deep() As String
  Reconsider_deep = strReconsider_deep
End Property
Public Property Let Verify_supports(ByVal strTemp As String)
  strVerify_supports = strTemp
  PropertyChanged "Verify_supports"
End Property
Public Property Get Verify_supports() As String
  Verify_supports = strVerify_supports
End Property

Public Property Let Case_sensitiveQ(ByVal strTemp As String)
  strCase_sensitiveQ = strTemp
  PropertyChanged "Case_sensitiveQ"
End Property
Public Property Get Case_sensitiveQ() As String
  Case_sensitiveQ = strCase_sensitiveQ
End Property
Public Property Let External_id(ByVal strTemp As String)
  strExternal_id = strTemp
  PropertyChanged "External_id"
End Property
Public Property Get External_id() As String
  External_id = strExternal_id
End Property

Private Sub UserControl_Initialize()
    strServ = "localhost"
    cycPort = 3601
    connTimeOut = 90
    strMicroTheory = "InferencePSC"
    
    lTrueColor = RGB(0, 255, 0)
    lFalseColor = RGB(255, 0, 0)
    sTrueText = "True"
    sFalseText = "False"
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Args = PropBag.ReadProperty("Args")
  constant = PropBag.ReadProperty("Constant")
  Func = PropBag.ReadProperty("Func")
  Port = PropBag.ReadProperty("Port")
  ConnectionTimeOut = PropBag.ReadProperty("ConnectionTimeOut")
  Pred = PropBag.ReadProperty("Pred")
  Microtheory = PropBag.ReadProperty("Microtheory")
  query = PropBag.ReadProperty("Query")
  Server = PropBag.ReadProperty("Server")
  
  FalseColor = PropBag.ReadProperty("FalseColor")
  TrueColor = PropBag.ReadProperty("TrueColor")
  FalseText = PropBag.ReadProperty("FalseText")
  TrueText = PropBag.ReadProperty("TrueText")
  
  'SendTo = PropBag.ReadProperty("SendTo")
  'MailFrom = PropBag.ReadProperty("MailFrom")
  'MessageSubject = PropBag.ReadProperty("MessageSubject")
  'MessageText = PropBag.ReadProperty("MessageText")
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  PropBag.WriteProperty "Args", Args
  PropBag.WriteProperty "Constant", constant
  PropBag.WriteProperty "Func", Func
  PropBag.WriteProperty "Microtheory", Microtheory
  PropBag.WriteProperty "Port", Port
  PropBag.WriteProperty "Pred", Pred
  PropBag.WriteProperty "Query", query
  PropBag.WriteProperty "Server", Server
  PropBag.WriteProperty "ConnectionTimeOut", connTimeOut
  
  PropBag.WriteProperty "TrueText", TrueText
  PropBag.WriteProperty "FalseText", FalseText
  PropBag.WriteProperty "TrueColor", TrueColor
  PropBag.WriteProperty "FalseColor", FalseColor
  
  'PropBag.WriteProperty "SendTo", SendTo
  'PropBag.WriteProperty "MailFrom", MailFrom
  'PropBag.WriteProperty "MessageSubject", MessageSubject
  'PropBag.WriteProperty "MessageText", MessageText
End Sub

Public Sub Connect()
  On Error GoTo ErrHandler
  Set wsTCP = CreateObject("oswinsck.TCP")
  
  strStatus = "Connecting to CYC server"
  If wsTCP.Connect(strServ, cycPort) = 0 Then
    'If Not ReadWrite("HELO " & strServ, 220) Then Exit Sub
    strStatus = "Connected to SMTP server"
    RaiseEvent ConnectCYC
    'If Not ReadWrite("MAIL FROM: " & strFrom, 250) Then Exit Sub
    'If Not ReadWrite("RCPT TO: " & strTo, 250) Then Exit Sub
    'If Not ReadWrite("DATA", 250) Then Exit Sub
    'If Not ReadWrite("DATE: " & Format(Now, "dd mmm yy Hh:Nn:Ss") & vbCrLf _
    '  & "FROM: " & strFrom & vbCrLf & "TO: " & strTo & vbCrLf _
    '  & "SUBJECT: " & strSubj & vbCrLf & vbCrLf & strMsg & _
    '  vbCrLf & "." & vbCrLf, 354) Then Exit Sub
    'If Not ReadWrite("QUIT", 250) Then Exit Sub
    strStatus = "Message sent"
    RaiseEvent SendCYC
    wsTCP.GetData
    wsTCP.Disconnect
    Set wsTCP = Nothing
    strStatus = "CYC session closed"
    RaiseEvent CloseCYC
  Else
        RaiseEvent ErrorCYC(0, "Connection not completed")

  End If
  Exit Sub
  
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If
End Sub
Public Sub assertIsa(ByVal ATOM$)
Attribute assertIsa.VB_Description = "Tells Cyc that Constant ISA member of Arg's collection (assumed to be a Cyc Collection)"
Dim Rply$
Dim Msg$
    If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "(cyc-assert '(#$isa " + strConstant + " " + ATOM$ + ") " + strMicroTheory$ + " )"
    Rply$ = Direct(Msg$)
    
End Sub
Public Sub assertGenls(ByVal ATOM$)
Attribute assertGenls.VB_Description = "Tells Cyc Constant is a subCollection or gens of passed Arg (assumed to be a Cyc Collection)"
Dim Rply$
Dim Msg$
    If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "(cyc-assert '(#$genls" + strConstant + " " + ATOM$ + ") " + strMicroTheory$ + " )"
    Rply$ = Direct(Msg$)
    
End Sub
Public Sub assertGenlMt(ByVal ATOM$)
Attribute assertGenlMt.VB_Description = "Tells Cyc Constant is a subMicrotheory or genlMt of passed Arg (assumed to be a Cyc Microtheory)"
Dim Rply$
Dim Msg$
    If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "(cyc-assert '(#$genlMt " + strConstant + " " + ATOM$ + ") " + strMicroTheory$ + " )"
    Rply$ = Direct(Msg$)
    
End Sub
Public Sub assertPred(ByVal Pred$, ByVal Args$)
Attribute assertPred.VB_Description = "Tells Cyc that the Predicate relation exists between Constant and Args."
Dim Rply$
Dim Msg$
    If Left$(Pred$, 1) <> "#" Then Pred$ = "#$" + Pred$
    If Left$(Args$, 1) <> "#" Then Args$ = "#$" + Args$
    Msg$ = "(cyc-assert '(" + Pred$ + " " + strConstant + " " + Args$ + ") " + strMicroTheory$ + " )"
    Rply$ = Direct(Msg$)
    
End Sub
Public Sub askisa()
Attribute askisa.VB_Description = "Asks Cyc if Constant ISA member of the passed arg (assumed to be a Cyc Collection)"
Dim Msg$
    'If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "#$isa " + strConstant + " ?QUERY"
    AskCyc Msg$
    
End Sub
Public Sub askgenls()
Attribute askgenls.VB_Description = "Asks Cyc if Constant is a genls of passed arg (assumed to be a Cyc Collection)"
Dim Msg$
    'If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "#$genls " + strConstant + " ?QUERY"
    AskCyc Msg$
    
End Sub
Public Sub askgenlMt()
Attribute askgenlMt.VB_Description = "Asks Cyc if Constant is a genlsMT of passed arg (assumed to be a Cyc Microtheory)"
Dim Msg$

    Msg$ = "#$genlMt " + strConstant + " ?QUERY"
    AskCyc Msg$
    
End Sub
Public Sub askPred(ByVal ATOM$)
Attribute askPred.VB_Description = "Asks Cyc ""Arg Constant ?Query"".  For instance, if Constant=""Bob"" and control.askPred(""likes"") is called, Cyc is asked ""#$likes #$BOB ?QUERY"""
Dim Msg$
    If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = ATOM$ + " " + strConstant + " ?QUERY"
    AskCyc Msg$
    
End Sub
Public Sub askcomment()
Attribute askcomment.VB_Description = "Asks Cyc to return the comment for the property Constant."
Dim Msg$
    'If Left$(ATOM$, 1) <> "#" Then ATOM$ = "#$" + ATOM$
    Msg$ = "#$comment " + strConstant + " ?QUERY"
    AskCyc Msg$
    
End Sub

'DATABASE CONTROL LIKE INTERFACE FUNCTIONS------------------------
Public Sub Refresh()
Attribute Refresh.VB_Description = "Retransmitts the last Query to Cyc."
    AskCyc strQuery
End Sub
Public Sub MoveFirst()
Attribute MoveFirst.VB_Description = "Moves the internal Answer collection pointer to the first Answer."
    RecPtr = 1
End Sub
Public Sub MoveNext()
Attribute MoveNext.VB_Description = "Moves the internal Answer collection pointer forward by one."
    RecPtr = RecPtr + 1
    If RecPtr > CycBinds.Count Then RecPtr = CycBinds.Count
End Sub
Public Sub MovePrevious()
Attribute MovePrevious.VB_Description = "Moves the internal Answer collection pointer backward by one."
    RecPtr = RecPtr - 1
    If RecPtr < 1 Then RecPtr = 1
End Sub
Public Sub MoveLast()
Attribute MoveLast.VB_Description = "Moves the internal Answer collection pointer to the last Answer."
    RecPtr = CycBinds.Count
End Sub
Public Sub Move(ByVal N As Long)
Attribute Move.VB_Description = "Moves the internal Answer collection pointer by the indicated amount."
Dim NewPtr
    NewPtr = RecPtr + N
    If NewPtr >= 1 And NewPtr <= CycBinds.Count Then
        RecPtr = NewPtr
    Else
        'if NewPtr
    End If
    
End Sub
Public Sub Delete()
Attribute Delete.VB_Description = "Removes record from response record collection."
On Error Resume Next
    CycBinds.Remove (RecPtr)
End Sub
Public Property Get NoMatch() As Boolean
Attribute NoMatch.VB_Description = "Returns the if FindFirst, Find Next, FindPrevious or FindLast were successful."
  NoMatch = bNoMatch
End Property
Public Property Get RecordCount() As Long
Attribute RecordCount.VB_Description = "The number of records parsed from Cyc."
  RecordCount = CycBinds.Count
End Property
Public Property Get CurrentRecord() As Long
Attribute CurrentRecord.VB_Description = "Returns the index of the internal answer collection pointer."
  CurrentRecord = RecPtr
End Property
Public Property Get EOF() As Boolean
Attribute EOF.VB_Description = "End of File or list of answer bindings."
  EOF = (RecPtr >= CycBinds.Count)
End Property
Public Property Get BOF() As Boolean
Attribute BOF.VB_Description = "Begining of File or Binding set"
  BOF = (RecPtr <= CycBinds.Count)
End Property

Public Sub FindFirst(ByVal Variable As String, ByVal value As String)
Attribute FindFirst.VB_Description = "Sets index to the first element of the answer collection where variable IsLike Value."
    FindEngine Variable, value, 1, CycBinds.Count, -1
End Sub
Public Sub FindNext(ByVal Variable As String, ByVal value As String)
Attribute FindNext.VB_Description = "Sets index to the next element of the answer collection where variable IsLike Value."
    FindEngine Variable, value, RecPtr, CycBinds.Count, -1
End Sub
Public Sub FindPrevious(ByVal Variable As String, ByVal value As String)
Attribute FindPrevious.VB_Description = "Sets index a lower indexed element of the answer collection where variable IsLike Value."
    FindEngine Variable, value, RecPtr, 1, -1
End Sub
Public Sub FindLast(ByVal Variable As String, ByVal value As String)
Attribute FindLast.VB_Description = "Sets index to the last element of the answer collection where variable IsLike Value."
    FindEngine Variable, value, CycBinds.Count, 1, -1
End Sub
Private Sub FindEngine(ByVal Variable As String, ByVal value As String, StartP As Long, StopP As Long, StepP As Long)
On Error Resume Next
Dim r As Long
Dim Dat$
    bNoMatch = True
    For r = StartP To StopP Step StepP
        Dat$ = CycBinds.Item(r).Item(Variable)
        If Dat$ Like value Then
            RecPtr = r: bNoMatch = False: Exit Sub
        End If
    Next r

End Sub
'GUI Helper Functions
Public Property Get ListControl() As Variant
  Set ListControl = GuiC
End Property
Public Property Let ListControl(ByVal ListControl As Variant)

  Set GuiC = ListControl
  'PropertyChanged "Server"
End Property
Function OpenRecordSet(ByVal CycQuery As String) As Object
Attribute OpenRecordSet.VB_Description = "Executes a Cyc Query and returns an open ADOrecordset with the results."
    AskCyc CycQuery
    Set OpenRecordSet = GetOpenRecordSet()
End Function
Function GetOpenRecordSet() As Object
  On Error GoTo ErrHandler
Dim r As Long
Dim f As Long
    'Create RecordSet
    Dim Rst As New ADODB.Recordset
    'Fill in the record structure
    For f = 1 To CycVars.Count
        Rst.Fields.Append CycVars.Item(f), adVariant
    Next f
    'Open so we can insert the records
    Rst.Open
    'Add each record
    For r = 1 To CycBinds.Count
         Rst.AddNew
         For f = 0 To CycVars.Count - 1
            Debug.Print "f:"; r, f, CycBinds.Item(r).Item(f + 1)
            Rst(f) = CycBinds.Item(r).Item(f + 1)
         Next f
         Rst.Update
    Next r
    'Rst.Close ' Don't closeit'
    'Just return it
    Set GetOpenRecordSet = Rst
    Exit Function
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    Set GetOpenRecordSet = Nothing
  End If
    
End Function
Public Function PopulateFlexGrid(FlexGrid As Object, _
   rs As Object) As Boolean
'*******************************************************
'PURPOSE: Populate MSFlexGrid with data from an
'         ADO Recordset
'PARAMETERS:  FlexGrid: MsFlexGrid to Populate
'             RS: Open ADO Recordset
'RETURNS:     True if successful, false otherwise
'REQUIRES:    -- Reference to Microsoft Active Data Objects
'             -- Recordset should be open with cursor set at
'                first row when passed and must
'                support recordcount property
'             -- FlexGrid should be empty when passed
'EXAMPLE:
'Dim conn As New ADODB.Connection
'Dim rs As New ADODB.Recordset
'Dim sConnString As String
'
'sConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\MyDatabase.mdb"
'conn.Open sConnString
'rs.Open " SELECT * FROM MyTable", oConn, adOpenKeyset, adLockOptimistic
'PopulateFlexGrid MSFlexGrid1, rs
'
'rs.Close
'conn.Close
'***********************************************************
            
On Error GoTo ErrorHandler

If Not TypeOf FlexGrid Is MSFlexGrid Then Exit Function
If Not TypeOf rs Is ADODB.Recordset Then Exit Function

Dim i As Integer
Dim J As Integer


    FlexGrid.FixedRows = 1
    FlexGrid.FixedCols = 0
    
    If Not rs.EOF Then
    
        FlexGrid.Rows = rs.RecordCount + 1
        FlexGrid.Cols = rs.Fields.Count
        

    
        For i = 0 To rs.Fields.Count - 1
            FlexGrid.TextMatrix(0, i) = rs.Fields(i).Name
           Next
    
        i = 1
        Do While Not rs.EOF
    
            For J = 0 To rs.Fields.Count - 1
                If Not IsNull(rs.Fields(J).value) Then
                    FlexGrid.TextMatrix(i, J) = _
                       rs.Fields(J).value
                End If
            Next
    
        i = i + 1
        rs.MoveNext
        Loop
    
    
    End If
PopulateFlexGrid = True
ErrorHandler:
Exit Function
End Function
Sub UpdateUsingTag(UserControl As Object)
Attribute UpdateUsingTag.VB_Description = "Updates the value of the control based on the information contained in that controls tag."
Dim query As String
Dim Answer As String
Dim Provable As Boolean
Dim cmdp As Integer
Dim cmd As String
Dim Neg As Boolean
  On Error GoTo ErrHandler

If Not TypeOf UserControl Is Control Then Exit Sub

query = UserControl.Tag
cmd = ""
cmdp = InStr(query, ":")
If cmdp > 0 Then
    cmd = UCase(Trim$(Left$(query, cmdp - 1)))
    query = Mid$(query$, cmdp + 1)
End If
If cmdp > 0 And cmd <> "LIST" Then
    Provable = CanProve(query)
    If Left$(cmd, 3) = "NOT" Then
        cmd = Trim$(Mid$(cmd, 4))
        Provable = Not (Provable)
    End If
    Select Case cmd
        Case "VISIBLE": UserControl.Visible = Provable
        Case "ENABLED": UserControl.Enabled = Provable
        Case "CANCEL": UserControl.Cancel = Provable
        Case "DEFAULT": UserControl.Default = Provable
        Case "VALUE":
            If TypeOf UserControl Is CheckBox Then
                If Provable Then
                    UserControl.value = 1
                Else
                    UserControl.value = 0
                End If
            Else
                UserControl.value = Provable
            End If
        Case "TEXT":
            If Provable Then
                Answer = sTrueText
            Else
                Answer = sFalseText
            End If

            If (TypeOf UserControl Is TextBox) _
                  Or (TypeOf UserControl Is ComboBox) _
                Then
                    UserControl.text = Answer
                Else
                    UserControl.Caption = Answer
                End If

        Case "FORECOLOR":
            If Provable Then
                    UserControl.ForeColor = lTrueColor
                Else
                    UserControl.ForeColor = lFalseColor
            End If
                
        Case "BACKCOLOR":
            If Provable Then
                    UserControl.BackColor = lTrueColor
                Else
                    UserControl.BackColor = lFalseColor
            End If
        
        Case "GREYED":
            If TypeOf UserControl Is CheckBox Then
                If Provable Then
                    UserControl.value = 2
                Else
                    'UserControl.Value = 0
                End If
            Else
                UserControl.Enabled = Provable
            End If
      Case Else
        strStatus = "CYC control error"
        RaiseEvent ErrorCYC(2, "Control command not understood:" + cmd)
    End Select
Else
    If (TypeOf UserControl Is ListBox) _
        Or (TypeOf UserControl Is MSFlexGrid) _
        Or (TypeOf UserControl Is ComboBox) _
        Or (TypeOf UserControl Is TextBox) Then
        AskCyc query
        FillList UserControl
    Else
        Provable = CanProve(query)
        If (TypeOf UserControl Is CheckBox) Then
            If Provable Then
                UserControl.value = 1
            Else
                UserControl.value = 0
            End If
        Else
            'Assume Options want the value
            If (TypeOf UserControl Is OptionButton) Then UserControl.value = Provable
             
             'Assume Images want visibility
             'Though it could be a load on result
             'i.e. cyc says what picture to show
            If (TypeOf UserControl Is Picture) Then UserControl.Visible = Provable
            If (TypeOf UserControl Is Image) Then UserControl.Visible = Provable
            If (TypeOf UserControl Is Line) Then UserControl.Visible = Provable
            If (TypeOf UserControl Is Shape) Then UserControl.Visible = Provable
            If (TypeOf UserControl Is Label) Then UserControl.Visible = Provable
            'Assume buttons/frames/timers want enabled bits
            If (TypeOf UserControl Is Frame) Then UserControl.Enabled = Provable
            If (TypeOf UserControl Is CommandButton) Then UserControl.Enabled = Provable
            If (TypeOf UserControl Is Timer) Then UserControl.Enabled = Provable
            'Dont understand anything else for now
            ' but file boxes could have paths set
            ' browsers could have URL's
            ' Databases have sources
            ' ranges or value for scrollbars
            ' ect.....
            ' The concept could be extended to forms as well
            
        End If
        
    End If
End If
Exit Sub
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Sub
Sub FillList(ByVal ListControl As Object)
Attribute FillList.VB_Description = "Used to fill a ListBox, ComboBox, or MSFlexGrid with the bindings returned from a query, using all bindings."
  On Error GoTo ErrHandler
Dim N As Long
Dim e As Long
Dim Dat$

If TypeOf ListControl Is MSFlexGrid Then
    ListControl.FixedRows = 1
    ListControl.FixedCols = 0
    
    If CycBinds.Count > 0 Then
    
        ListControl.Rows = CycBinds.Count + 1
        ListControl.Cols = CycVars.Count + 1
        
        For e = 1 To CycVars.Count
            ListControl.TextMatrix(0, e) = CycVars.Item(e)
        Next
    
        For N = 1 To CycBinds.Count
    
            For e = 1 To CycBinds.Item(N).Count
                If Not IsNull(CycBinds.Item(N).Item(e)) Then
                    ListControl.TextMatrix(N, e) = _
                       CycBinds.Item(N).Item(e)
                End If
            Next
    
        Next N
    End If
Else

    If IsObject(ListControl) Then
        For N = 1 To CycBinds.Count
            Dat$ = ""
            For e = 1 To CycBinds.Item(N).Count
                Dat$ = Dat$ + Chr$(9) + CycBinds.Item(N).Item(e)
            Next e
            
            If (TypeOf ListControl Is TextBox) Then
                ListControl.text = ListControl.text + Mid$(Dat$, 2)
                If N < CycBinds.Count Then ListControl.text = ListControl.text + vbCrLf
            Else
                ListControl.AddItem Mid$(Dat$, 2)
            End If
            
        Next N
    Else
            RaiseEvent ErrorCYC(1, "FillList passed a Non-Object")
    
    End If
End If
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Sub
Sub FillListWithVariable(ByVal ListControl As Variant, ByVal Variable As String)
Attribute FillListWithVariable.VB_Description = "Used to fill a ListBox, ComboBox, or MSFlexGrid with the bindings returned from a query, focusing on only the variable binding indicated."
  On Error GoTo ErrHandler
Dim N As Long
Dim Dat$
If IsObject(ListControl) Then
    For N = 1 To CycBinds.Count
        Dat$ = CycBinds.Item(N).Item(Variable)
        
        'ListControl.AddItem Dat$
        If (TypeOf ListControl Is TextBox) Then
            ListControl.text = ListControl.text + Dat$
            If N < CycBinds.Count Then ListControl.text = ListControl.text + vbCrLf
        Else
            ListControl.AddItem Dat$
        End If
    
    Next N
Else
        RaiseEvent ErrorCYC(1, "FillList passed a Non-Object")

End If
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Sub
'Boolean Check : CanProve()
Public Function CanProve(ByVal CycQuery) As Boolean
Attribute CanProve.VB_Description = "A boolean function that returns true if Cyc can prove Query. Note : False may indicate either proven false or unprovable/unknown."
    AskCyc CycQuery
    If MsgIn Like "200 NIL*" Then CanProve = False: Exit Function
    If MsgIn Like "200 (NIL)*" Then CanProve = True: Exit Function 'a fully specified atomic response
    If MsgIn Like "200 (((T . T)))*" Then CanProve = True: Exit Function
    If MsgIn Like "500 *" Then CanProve = False: Exit Function
    If MsgIn Like "200 (*((*))*)*" Then CanProve = True: Exit Function
    If MsgIn Like "*200 T*" Then CanProve = True: Exit Function
    
    CanProve = False 'Dangerous assumption should be unknown...
    
End Function
Public Function CheckTrue(ByVal Results) As Boolean
    If Results Like "200 NIL*" Then CheckTrue = False: Exit Function
    If Results Like "200 (NIL)*" Then CheckTrue = True: Exit Function 'a fully specified atomic response
    If Results Like "200 (((T . T)))*" Then CheckTrue = True: Exit Function
    If Results Like "500 *" Then CheckTrue = False: Exit Function
    If Results Like "200 (*((*))*)*" Then CheckTrue = True: Exit Function
    If Results Like "*200 T*" Then CheckTrue = True: Exit Function
    
    CheckTrue = False 'Dangerous assumption should be unknown...

End Function
Public Sub ifTrueSet(ByVal query As String, Variable As Variant, value As Variant)
Attribute ifTrueSet.VB_Description = "If Query is proven true then Variable=Value"
Dim Provable As Boolean
  On Error GoTo ErrHandler
Provable = CanProve(query)
If Provable Then
    If TypeOf Variable Is Object  Then
        Set Variable = value
    Else
        Variable = value
    End If
End If
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Sub
'------------------------------------------------------------
'Simple Proof based color and string functions
'------------------------------------------------------------
Public Property Let FalseColor(ByVal lTemp As OLE_COLOR)
Attribute FalseColor.VB_Description = "Returns/Sets the color used to indicate a false or unprovable query."
  lFalseColor = lTemp
  PropertyChanged "FalseColor"
End Property
Public Property Get FalseColor() As OLE_COLOR
  FalseColor = lFalseColor
End Property
Public Property Let TrueColor(ByVal lTemp As OLE_COLOR)
Attribute TrueColor.VB_Description = "Returns/Sets the color used to indicate a provable query."
  lTrueColor = lTemp
  PropertyChanged "TrueColor"
End Property
Public Property Get TrueColor() As OLE_COLOR
  TrueColor = lTrueColor
End Property
Public Property Let FalseText(ByVal TXT As String)
Attribute FalseText.VB_Description = "Returns/Sets the text to fill a control with if a query is proven false or unknown"
  sFalseText = TXT
  PropertyChanged "FalseText"
End Property
Public Property Get FalseText() As String
  FalseText = sFalseText
End Property
Public Property Let TrueText(ByVal TXT As String)
Attribute TrueText.VB_Description = "Returns/Sets the text used to indicate a true or provable query."
  sTrueText = TXT
  PropertyChanged "TrueText"
End Property
Public Property Get TrueText() As String
  TrueText = sTrueText
End Property
Public Function ProofColor(ByVal query As String) As OLE_COLOR
Attribute ProofColor.VB_Description = "Returns either TrueColor or FalseColor depending on if canProve(Query)"
Dim Provable As Boolean
  On Error GoTo ErrHandler
Provable = CanProve(query)
If Provable Then
        ProofColor = lTrueColor
    Else
        ProofColor = lFalseColor
End If
Exit Function

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Function
Public Function ProofText(ByVal query As String) As String
Attribute ProofText.VB_Description = "Returns either TrueText or FalseText depending on if canProve(Query)"
Dim Provable As Boolean
  On Error GoTo ErrHandler
Provable = CanProve(query)
If Provable Then
        ProofText = sTrueText
Else
        ProofText = sFalseText
End If
Exit Function

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If

End Function
Public Sub SetForeColorUsingTag(UserControl As Object)
Attribute SetForeColorUsingTag.VB_Description = "Sets the foreground color of a control based on the ability to prove the statement in that controls Tag."
Dim query As String
Dim Provable As Boolean
  On Error GoTo ErrHandler
If Not TypeOf UserControl Is Control Then Exit Sub
query = UserControl.Tag
UserControl.ForeColor = ProofColor(query)
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    
  End If
End Sub
Public Sub SetBackColorUsingTag(UserControl As Object)
Attribute SetBackColorUsingTag.VB_Description = "Sets the background color of a control based on the ability to prove the statement in that controls Tag."
Dim query As String
Dim Provable As Boolean
  On Error GoTo ErrHandler
If Not TypeOf UserControl Is Control Then Exit Sub
query = UserControl.Tag
UserControl.BackColor = ProofColor(query)
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    
  End If
End Sub
Public Sub SetTextUsingTag(UserControl As Object)
Attribute SetTextUsingTag.VB_Description = "Sets the text or caption of a control based on the ability to prove the statement in that controls Tag."
Dim query As String
Dim Provable As Boolean
Dim Answer As String
  On Error GoTo ErrHandler
If Not TypeOf UserControl Is Control Then Exit Sub
query = UserControl.Tag
Answer = ProofText(query)

If (TypeOf UserControl Is TextBox) _
  Or (TypeOf UserControl Is ComboBox) _
Then
    UserControl.text = Answer
Else
    UserControl.Caption = Answer
End If
Exit Sub

ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    
  End If

End Sub
Sub ProcessFormTags(UserForm As Object)
Attribute ProcessFormTags.VB_Description = "Given a Form processes each contol with proper information in the tag to ProcessControl"
Dim UserControl As Control
On Error GoTo ErrHandler
If Not TypeOf UserForm Is Form Then Exit Sub

For Each UserControl In UserForm.Controls
    If UserControl.Tag Like "*:*" Then
         UpdateUsingTag UserControl
    End If
Next
Exit Sub
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    
  End If

End Sub
'CORE ACCESS FUNCTIONS -------------------------------------------
Public Function Direct(ByVal Message$) As String
Attribute Direct.VB_Description = "Sents Msg to Cyc and returns response. No extra processing."


  On Error GoTo ErrHandler
  strQuery = Message$
  strStatus = "Connecting to CYC server"
  RaiseEvent ConnectCYC
 '------------------------------------------------
    If Not ReadWriteCYC(strQuery) Then
        RaiseEvent ErrorCYC(0, "CycLink:AskCyc:ReadWriteCyc=False")

        Exit Function
    End If
    RaiseEvent ReplyCYC(strQuery, MsgIn)
    strStatus = "CYC session closed"
    RaiseEvent CloseCYC
    Direct = MsgIn
  Exit Function

  '------------------------------------------


  On Error GoTo ErrHandler
  Set wsTCP = CreateObject("oswinsck.TCP")
  strQuery = Message$

  strStatus = "Connecting to CYC server"
  If wsTCP.Connect(strServ, cycPort) = 0 Then
    'If Not ReadWrite("HELO " & strServ, 220) Then Exit Sub
    strStatus = "Connected to CYC server"
    RaiseEvent ConnectCYC
    
    If Not ReadWriteCYC(strQuery) Then Exit Function
    RaiseEvent ReplyCYC(strQuery, MsgIn)
    wsTCP.Disconnect
    Set wsTCP = Nothing
    strStatus = "CYC session closed"
    RaiseEvent CloseCYC
    Direct = MsgIn
  End If
  Exit Function
  
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
    Direct = ""
  End If
End Function
Public Sub BindLastResult()
    ChunkDictionary MsgIn
    QueryReplyBindList MsgIn
End Sub
Public Sub AskCyc(ByVal query$)
Attribute AskCyc.VB_Description = "Used to send a query to Cyc. Will fill the response properties and trigger any related events."
  On Error GoTo ErrHandler
  strQuery = "(fi-ask '(" + query$ + ") #$" + strMicroTheory + ")"
  strStatus = "Connecting to CYC server"
  '------------------------------------------------
    If Not ReadWriteCYC(strQuery) Then
        RaiseEvent ErrorCYC(0, "CycLink:AskCyc:ReadWriteCyc=False")

        Exit Sub
    End If
    RaiseEvent ReplyCYC(strQuery, MsgIn)
    ChunkDictionary MsgIn
    RaiseEvent SendCYC
    QueryReplyBindList MsgIn
    strStatus = "Message sent"
    strStatus = "CYC session closed"
    RaiseEvent CloseCYC
  Exit Sub

  '------------------------------------------
   Set wsTCP = CreateObject("oswinsck.TCP")
 
  If wsTCP.Connect(strServ, cycPort) = 0 Then
    'If Not ReadWrite("HELO " & strServ, 220) Then Exit Sub
    strStatus = "Connected to CYC server"
    RaiseEvent ConnectCYC
    RaiseEvent PreQueryCyc(strQuery)

    'If Not ReadWrite("MAIL FROM: " & strFrom, 250) Then Exit Sub
    'If Not ReadWrite("RCPT TO: " & strTo, 250) Then Exit Sub
    'If Not ReadWrite("DATA", 250) Then Exit Sub
    'If Not ReadWrite("DATE: " & Format(Now, "dd mmm yy Hh:Nn:Ss") & vbCrLf _
    '  & "FROM: " & strFrom & vbCrLf & "TO: " & strTo & vbCrLf _
    '  & "SUBJECT: " & strSubj & vbCrLf & vbCrLf & strMsg & _
    '  vbCrLf & "." & vbCrLf, 354) Then Exit Sub
    'If Not ReadWrite("QUIT", 250) Then Exit Sub
    
    If Not ReadWriteCYC(strQuery) Then Exit Sub
    RaiseEvent ReplyCYC(strQuery, MsgIn)
    ChunkDictionary MsgIn
    RaiseEvent SendCYC
    QueryReplyBindList MsgIn
    strStatus = "Message sent"
    
    'MsgIn = wsTCP.GetData
    'RaiseEvent ReplyCYC(strQuery, MsgIn)
    
    wsTCP.Disconnect
    Set wsTCP = Nothing
    strStatus = "CYC session closed"
    RaiseEvent CloseCYC
  End If
  Exit Sub
  
ErrHandler:
  If Err.Number <> 0 Then
    strStatus = "CYC control error"
    RaiseEvent ErrorCYC(Err.Number, Err.Description)
    Err.Clear
  End If
End Sub
Private Sub objWinSock_DataArrival(ByVal bytesTotal As Long)
     Dim strTemp
    RaiseEvent ErrorCYC(0, "CycLink: objWinSock_DataArrival =" + Str$(bytesTotal))
     objWinSock.GetData strTemp, vbString
     strData = strData & strTemp
    RaiseEvent ErrorCYC(0, "CycLink: DataArrival =<" + Left$(strTemp, 64) + ">")
    bProgress = True
    If bytesTotal <> 4096 Then
        bContinueData = False
        RaiseEvent ErrorCYC(0, "CycLink: Totaldata =" + Str$(Len(strData)))
    End If
End Sub

Private Sub objWinSock_Connect()
    RaiseEvent ErrorCYC(0, "CycLink: Connect")
     bConnected = True
End Sub
Private Sub objWinSock_Error(ByVal Number As Integer, Description As String, _
  ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, _
  ByVal HelpContext As Long, CancelDisplay As Boolean)

    RaiseEvent ErrorCYC(0, "CycLink: Winsock Error: " & Number & vbCrLf & Description)
     CancelDisplay = True
End Sub
Private Sub DirectOpen()
Dim dtStart As Date
Dim QuickTime As Long

'--- INIT ---
'ReadWriteCYC = False
strData = ""
bConnected = False

If objWinSock Is Nothing Then
    Set objWinSock = New MSWinsockLib.Winsock
Else
    Set objWinSock = Nothing
    Set objWinSock = New MSWinsockLib.Winsock

End If

'--- CONNECT ---
dtStart = Now()
objWinSock.Protocol = sckTCPProtocol
objWinSock.RemoteHost = strServ
objWinSock.RemotePort = cycPort
objWinSock.Connect
Do Until bConnected
     DoEvents
     If DateDiff("s", dtStart, Now) > 30 Then
         RaiseEvent ErrorCYC(0, "CycLink:Connect Timeout")
         Exit Sub
     End If
Loop

If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK Connect" + Err.Description)
    Err.Clear
    Exit Sub

End If

End Sub
Sub DirectSend(ByVal MsgOut As String)
Dim dtStart As Date
Dim QuickTime As Long

'--- SEND REQUEST ---
dtStart = Now()      'Timeout timer is now
bContinueData = True 'Assume we want to continue
bProgress = False    'We have made no progress yet

objWinSock.SendData MsgOut & vbCrLf 'Tell Cyc the message

'Wait until Cyc closes the connection or we get a short packet
' indicating end of this query results
QuickTime = connTimeOut
Do Until objWinSock.State = sckClosing Or bContinueData = False
     DoEvents
     
     If DateDiff("s", dtStart, Now) > QuickTime And bProgress = False Then
         RaiseEvent ErrorCYC(0, "CycLink:Request Timeout")
                       Exit Sub

     End If
     
     If bProgress = True Then
            dtStart = Now()   'reset the timeout timer
            bProgress = False 'toggle the progress flag back off
            If QuickTime > 5 Then QuickTime = 5 'we saw progress so when it stops we are done
     End If
Loop

'objWinSock.SendData MsgOut & vbCrLf
If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK SendData" + Err.Description)
    Err.Clear
    Exit Sub

End If


End Sub
Sub DirectClose()

'--- CLOSE CONNECTION ---
objWinSock.Close
'objWinSock.GetData MsgIn
If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK GetData" + Err.Description)
    Err.Clear
    Exit Sub

End If
'--- RETURN DATA ---
MsgIn = strData
'ReadWriteCYC = True
Exit Sub

End Sub
Private Function ReadWriteCYC(ByVal MsgOut As String) As Boolean
Dim dtStart As Date
Dim QuickTime As Long

'--- INIT ---
ReadWriteCYC = False
strData = ""
bConnected = False

If objWinSock Is Nothing Then
    Set objWinSock = New MSWinsockLib.Winsock
Else
    Set objWinSock = Nothing
    Set objWinSock = New MSWinsockLib.Winsock

End If

'--- CONNECT ---
dtStart = Now()
objWinSock.Protocol = sckTCPProtocol
objWinSock.RemoteHost = strServ
objWinSock.RemotePort = cycPort
objWinSock.Connect
Do Until bConnected
     DoEvents
     If DateDiff("s", dtStart, Now) > 30 Then
         RaiseEvent ErrorCYC(0, "CycLink:Connect Timeout")
         Exit Function
     End If
Loop

If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK Connect" + Err.Description)
    Err.Clear
    Exit Function

End If

'--- SEND REQUEST ---
dtStart = Now()      'Timeout timer is now
bContinueData = True 'Assume we want to continue
bProgress = False    'We have made no progress yet

objWinSock.SendData MsgOut & vbCrLf 'Tell Cyc the message

'Wait until Cyc closes the connection or we get a short packet
' indicating end of this query results
QuickTime = connTimeOut
Do Until objWinSock.State = sckClosing Or bContinueData = False
     DoEvents
     
     If DateDiff("s", dtStart, Now) > QuickTime And bProgress = False Then
         RaiseEvent ErrorCYC(0, "CycLink:Request Timeout")
                       Exit Function

     End If
     
     If bProgress = True Then
            dtStart = Now()   'reset the timeout timer
            bProgress = False 'toggle the progress flag back off
            If QuickTime > 5 Then QuickTime = 5 'we saw progress so when it stops we are done
     End If
Loop

'objWinSock.SendData MsgOut & vbCrLf
If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK SendData" + Err.Description)
    Err.Clear
    Exit Function

End If

'--- CLOSE CONNECTION ---
objWinSock.Close
'objWinSock.GetData MsgIn
If Err.Number <> 0 Then
    RaiseEvent ErrorCYC(Err.Number, "MSOCK GetData" + Err.Description)
    Err.Clear
    Exit Function

End If
'--- RETURN DATA ---
MsgIn = strData
ReadWriteCYC = True
Exit Function

'--------------------------------------------
  'Dim MsgIn As String
  'Dim iCode As Integer
  Dim LocMsg1, LocMsg2 As String
  Dim getcount As Integer
  getcount = 0
  wsTCP.SendData MsgOut & vbCrLf
  LocMsg1 = wsTCP.GetData: getcount = getcount + 1
  MsgIn = LocMsg1
  iCode = Val(Left(MsgIn, 3))
  If iCode <> 200 Then
    RaiseEvent ErrorCYC(iCode, Mid(MsgIn, 5))
  End If
  LocMsg2 = wsTCP.GetData: getcount = getcount + 1
  If LocMsg2 = "" Then RaiseEvent ErrorCYC(0, "Follow on Get is Empty")
  If LocMsg2 = LocMsg1 Then RaiseEvent ErrorCYC(0, "Follow on Get is The Same")
  While LocMsg2 <> "" And LocMsg2 <> LocMsg1 And getcount < 64
    
    LocMsg1 = LocMsg2
    MsgIn = MsgIn + LocMsg1
    LocMsg2 = wsTCP.GetData: getcount = getcount + 1
    
  Wend
  RaiseEvent ErrorCYC(0, "Getcount = " + Str$(getcount))
  'If iCode = iExpectedCode Then
    'wsTCP.SendData MsgOut & vbCrLf
  'Else
  '  RaiseEvent ErrorCYC(10000 + iCode, Mid(MsgIn, 5))
  '  wsTCP.Disconnect
  '  Exit Function
  'End If
  ReadWriteCYC = True
End Function

Private Function ReadWrite(ByVal MsgOut As String, ByVal iExpectedCode As Integer) As Boolean
  Dim MsgIn As String
  'Dim iCode As Integer
  
  MsgIn = wsTCP.GetData
  iCode = Val(Left(MsgIn, 3))
  If iCode = iExpectedCode Then
    wsTCP.SendData MsgOut & vbCrLf
  Else
    RaiseEvent ErrorCYC(10000 + iCode, Mid(MsgIn, 5))
    wsTCP.Disconnect
    Exit Function
  End If
  ReadWrite = True
End Function

Private Sub QueryReplyBindList(Response$)
Dim Q, q1, q2
Dim VAR$
Dim VL$
Dim lastQ

If Response$ Like "200 (((T . T)))*" Then
    VAR$ = "T"
    VL$ = "T"
    RaiseEvent QueryReplyCYC(strQuery, VAR$, VL$)
    Exit Sub
End If

lastQ = 1
Q = InStr(Response$, ".")
While Q > 0
    q2 = InStr(Q, Response$, ")")
    If q2 = 0 Then Exit Sub 'Confused or at the end
    VL$ = Trim$(Mid$(Response$, Q, q2 - Q))
    q1 = InStr(lastQ, Response$, "?")
    If q1 = 0 Then Exit Sub ' NOT A BIND LIST Or Done
    VAR$ = Trim$(Mid$(Response$, q1, Q - q1))
    RaiseEvent QueryReplyCYC(strQuery, VAR$, VL$)
    lastQ = Q
    Q = InStr(q2, Response$, ".")
    If Q = 0 Then Exit Sub 'At the end
Wend

End Sub
Sub ChunkDictionary(ByVal Response$)
Dim VAR$
Dim SubDict As collection
Dim SubItem As Integer
Dim Depth
Dim J, Q
Dim a$, Key$, Dat$
'We always start with a clean dictionary
If Not (CycBinds Is Nothing) Then
    Set CycBinds = Nothing
    Set CycVars = Nothing
End If

If Response$ Like "### *" Then Response = Mid$(Response$, 4)
VAR$ = ""
Depth = 0
SubItem = 0
For J = 1 To Len(Response$)
    a$ = Mid$(Response$, J, 1)
    
    If a$ = "(" And Depth = 0 Then
        'XML$ = XML$ + "<reply>" + vbCrLf
        ' New CycBind Dictionary
        If Not (CycBinds Is Nothing) Then
            Set CycBinds = Nothing
            Set CycVars = Nothing
        End If
        Set CycBinds = New collection
        Set CycVars = New collection
    End If
    If a$ = ")" And Depth = 1 Then
        'XML$ = XML$ + "</reply>" + vbCrLf
        'Close CycBind
    End If
    
    If a$ = "(" And Depth = 1 Then
        'XML$ = XML$ + "  <blist>" + vbCrLf
        'New Sub Dictionary
        Set SubDict = New collection
        SubItem = SubItem + 1
    End If
    If a$ = ")" And Depth = 2 Then
        'XML$ = XML$ + "  </blist>" + vbCrLf
        'Close Sub Dictionary
        CycBinds.Add SubDict ', SubItem '.Item(SubItem) = SubDict
        
    End If
    
    If a$ = "(" And Depth = 2 Then
        'XML$ = XML$ + "    <variable>"
        'New Variable
        VAR$ = ""
    End If
    If a$ = ")" And Depth = 3 Then
        'XML$ = XML$ + "    </variable>" + vbCrLf
        'Close Variable and parse
        VAR$ = Trim$(VAR$)
        Q = InStr(VAR$, "."): If Q = 0 Then Q = InStr(VAR$, " ")
        If Q > 0 Then
            Key$ = Trim$(Left$(VAR$, Q - 1))
            Dat$ = Trim$(Mid$(VAR$, Q + 1))
            SubDict.Add Dat$, Key$ '  Item(KEY$) = DAT$
            If CycBinds.Count < 1 Then CycVars.Add Key$
        End If
    End If
    
    If a$ = "(" Then Depth = Depth + 1
    If a$ = ")" Then Depth = Depth - 1
    If (Depth <= 2 And a$ = ")") Or (Depth <= 3 And a$ = "(") Then a$ = ""
    
    VAR$ = VAR$ + a$
Next J

End Sub
Sub ShowAboutBox()
        ' frmAbout.Show vbModal
        ' Unload frmAbout
        ' Set frmAbout = Nothing
      End Sub

'---------------------------------------------------------------
' MS FLEX GRID MANIPULATION
'---------------------------------------------------------------

Private Sub HighlightGridRow(grd As MSFlexGrid, iRow As Long)
    With grd
        If .Rows > 1 Then
            .Row = iRow
            .Col = 1
            .ColSel = .Cols - 1
            .RowSel = iRow
        End If
    End With
End Sub
Public Sub LoadRecordSetIntoCyc(rs As Object, Template As String)
    Dim x As Long
    Dim Count As Long
    Dim AssertText As String
    Dim RText As String
    Dim PText As String
    Dim LField() As String
    
    If Not TypeOf rs Is Recordset Then Exit Sub
    ReDim LField(rs.Fields.Count)
    
    For x = 0 To rs.Fields.Count - 1
        LField(x + 1) = "||" + Trim$(rs.Fields(x).Name) + "||"
        'grd.ColData(x + 1) = rs.Fields(x).Type
    Next
Dim RX As Recordset
    If rs.CursorLocation = adUseClient Then
        'grd.Rows = rs.RecordCount + 1
        rs.MoveFirst
        For Count = 1 To rs.RecordCount
            'rs.Move(Count-1)
            AssertText = Template
            'grd.TextMatrix(Count, 0) = Count    'assign line number
            For x = 0 To rs.Fields.Count - 1
                'we use Variant conversion to avoid any possible NULL errors
                'grd.TextMatrix(Count, x + 1) = "" & CVar(rs.Fields(x).Value)
                RText = "" & CVar(rs.Fields(x).value)
                PText = AssertText
              'RaiseEvent CycAsserted("IMMED1:" + PText + "/" + LField(x + 1) + "/" + RText)
               AssertText = Replace(PText, LField(x + 1), RText)
                
            Next
            AssertText = Replace(AssertText, "#$#$", "#$")
            RaiseEvent CycAsserted(AssertText)
            
            rs.MoveNext
        Next
    ElseIf rs.CursorLocation = adUseServer Then
        Do While Not rs.EOF
            Count = Count + 1
            AssertText = Template
            
            'If Count >= grd.Rows Then
                'increase the amount of rows by 100 at a time
                'makes everything faster
                'grd.Rows = grd.Rows + 100
            'End If
            
            'grd.TextMatrix(Count, 0) = Count    'assign line number
            For x = 0 To rs.Fields.Count - 1
                'we use Variant conversion to avoid any possible NULL errors
                'grd.TextMatrix(Count, x + 1) = "" & CVar(rs.Fields(x).Value)
                RText = "" & CVar(rs.Fields(x).value)
                PText = AssertText
                'RaiseEvent CycAsserted("IMMED2:" + PText + "/" + LField(x + 1) + "/" + RText)
                AssertText = Replace(PText, LField(x + 1), RText)

            Next
            AssertText = Replace(AssertText, "#$#$", "#$")
            RaiseEvent CycAsserted(AssertText)

            rs.MoveNext
        Loop
        
        'reset the number of rows to the number of records
        'grd.Rows = Count + 1
    End If

End Sub


Public Sub LoadRecordsetIntoGrid(rs As Object, grd As Object, _
                Optional AutosizeColumns As Boolean = True, _
                Optional HighlightFirstRow As Boolean = True)
                
    Dim x As Long
    Dim Count As Long

    If Not TypeOf rs Is Recordset Then Exit Sub
    If Not TypeOf grd Is MSFlexGrid Then Exit Sub
    grd.Redraw = False
    grd.Clear

    'setup the minimum number of rows & add column headers
    grd.Rows = 2
    grd.FixedRows = 1
    grd.Row = 0
    grd.Cols = rs.Fields.Count + 1
    For x = 0 To rs.Fields.Count - 1
        grd.Col = x + 1
        grd.text = rs.Fields(x).Name
        grd.ColData(x + 1) = rs.Fields(x).Type
    Next

    If rs.CursorLocation = adUseClient Then
        grd.Rows = rs.RecordCount + 1
        For Count = 1 To rs.RecordCount
            
            grd.TextMatrix(Count, 0) = Count    'assign line number
            For x = 0 To rs.Fields.Count - 1
                'we use Variant conversion to avoid any possible NULL errors
                grd.TextMatrix(Count, x + 1) = "" & CVar(rs.Fields(x).value)
            Next
            rs.MoveNext
        Next
    ElseIf rs.CursorLocation = adUseServer Then
        Do While Not rs.EOF
            Count = Count + 1
            
            If Count >= grd.Rows Then
                'increase the amount of rows by 100 at a time
                'makes everything faster
                grd.Rows = grd.Rows + 100
            End If
            
            grd.TextMatrix(Count, 0) = Count    'assign line number
            For x = 0 To rs.Fields.Count - 1
                'we use Variant conversion to avoid any possible NULL errors
                grd.TextMatrix(Count, x + 1) = "" & CVar(rs.Fields(x).value)
            Next
    
            rs.MoveNext
        Loop
        
        'reset the number of rows to the number of records
        grd.Rows = Count + 1
    End If
    
    'autosize the grid
    If AutosizeColumns Then SetGridColumnWidth grd

    'highlight the first row
    If HighlightFirstRow Then
        If grd.Rows > 1 Then HighlightGridRow grd, 1
    End If
    
    'redraw the entire grid
    grd.Redraw = True
End Sub



Public Sub LoadRecordsetIntoGridNoCr(rs As Object, grd As Object, _
                Optional AutosizeColumns As Boolean = True, _
                Optional HighlightFirstRow As Boolean = True)
                
    'This sub assumes that the records doesn't have any
    'data in it with Carriage Returns
    'This knowledge allows the routine to dump the
    'entire recordset wholesale into the MsFlexGrid
    'via the .Clip property
    
    Dim x As Long
    Dim Count As Long
    If Not TypeOf rs Is Recordset Then Exit Sub
    If Not TypeOf grd Is MSFlexGrid Then Exit Sub

    'this prevents the grid from repainting
    'everytime something is added
    grd.Redraw = False
    grd.Clear

    'setup the minimum number of rows & add column headers
    grd.Rows = 2
    grd.FixedRows = 1
    grd.Row = 0
    grd.Cols = rs.Fields.Count + 1
    For x = 0 To rs.Fields.Count - 1
        grd.Col = x + 1
        grd.text = rs.Fields(x).Name
        grd.ColData(x + 1) = rs.Fields(x).Type
    Next

    If rs.CursorLocation = adUseClient Then
        If rs.RecordCount > 0 Then
            'setup all the rows necessary for this recordset
            grd.Rows = rs.RecordCount + 1
            grd.Row = 1
            grd.Col = 1
                        
            grd.ColSel = rs.Fields.Count
            grd.RowSel = rs.RecordCount
            
            'fill in the recordset
            grd.Clip = rs.GetString(, , Chr$(9), Chr$(13))
            
            'remove the highlight
            grd.RowSel = 0
            grd.ColSel = 0
            grd.Row = 1
            grd.Col = 1
            
            'assign record numbers
            For x = 1 To grd.Rows - 1
                grd.TextMatrix(x, 0) = x
            Next
            
        End If
    ElseIf rs.CursorLocation = adUseServer Then
        Do While Not rs.EOF
            Count = Count + 1
            
            If Count >= grd.Rows Then
                'increase the amount of rows by 100 at a time
                'makes everything faster
                grd.Rows = grd.Rows + 100
            End If
            
            grd.TextMatrix(Count, 0) = Count    'assign line number
            For x = 0 To rs.Fields.Count - 1
                'we use Variant conversion to avoid any possible NULL errors
                grd.TextMatrix(Count, x + 1) = "" & CVar(rs.Fields(x).value)
            Next
    
            rs.MoveNext
        Loop
        
        'reset the number of rows to the number of records
        grd.Rows = Count + 1
    End If
    
    'autosize the grid
    If AutosizeColumns Then SetGridColumnWidth grd

    'highlight the first row
    If HighlightFirstRow Then
        If grd.Rows > 1 Then HighlightGridRow grd, 1
    End If
    
    'redraw the entire grid
    grd.Redraw = True
End Sub



Private Sub SetGridColumnWidth(grd As MSFlexGrid)
    'params:    ms flexgrid control
    'purpose:   sets the column widths to the
    '           lengths of the longest string in the column
    'requirements:  the grid must have the same
    '               font as the underlying form

    Dim InnerLoopCount As Long
    Dim OuterLoopCount As Long
    Dim lngLongestLen As Long
    Dim sLongestString As String
    Dim lngColWidth As Long
    Dim szCellText As String

    For OuterLoopCount = 0 To grd.Cols - 1
        sLongestString = ""
        lngLongestLen = 0

        'grd.Col = OuterLoopCount
        For InnerLoopCount = 0 To grd.Rows - 1
            szCellText = grd.TextMatrix(InnerLoopCount, OuterLoopCount)
            'grd.Row = InnerLoopCount
            'szCellText = Trim$(grd.Text)
            If Len(szCellText) > lngLongestLen Then
                lngLongestLen = Len(szCellText)
                sLongestString = szCellText
            End If
        Next
        lngColWidth = grd.Parent.TextWidth(sLongestString)

        'add 100 for more readable spreadsheet
        grd.ColWidth(OuterLoopCount) = lngColWidth + 200
    Next
End Sub
'----------------------------------------------------
'----------------------------------------------------
'   AUTO GENERATED CYC FUNCTIONS FROM API
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
' function CYC-FIND-OR-CREATE : (name external-id)
' Return constant with NAME if it is present.
' If not present, then create constant with NAME, using EXTERNAL-ID if given.
' If EXTERNAL-ID is not given, generate a new one for the new constant.
' NAME must satisfy VALID-CONSTANT-NAME.
' EXTERNAL-ID must satisfy (NIL-OR CONSTANT-EXTERNAL-ID-P).
' Single value returned satisfies CONSTANT-P.
Public Function CYC_FIND_OR_CREATE(ByVal Name As String, ByVal External_id As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
    If Left$(External_id, 1) <> "#" Then External_id = "#$" + External_id
     Msg$ = "(CYC-FIND-OR-CREATE " + Name + " " + External_id + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_FIND_OR_CREATE = Rply$
 End Function
'----------------------------------------------------
' function CYC-CREATE : (name external-id)
' Create a new constant with id EXTERNAL-ID.
' If NAME is anything other than :unnamed,
' the new constant will be given the name NAME.
' NAME must satisfy NEW-CONSTANT-NAME-SPEC-P.
' EXTERNAL-ID must satisfy (NIL-OR CONSTANT-EXTERNAL-ID-P).
' Single value returned satisfies CONSTANT-P.
Public Function CYC_CREATE(ByVal Name As String, ByVal External_id As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
    If Left$(External_id, 1) <> "#" Then External_id = "#$" + External_id
     Msg$ = "(CYC-CREATE " + Name + " " + External_id + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_CREATE = Rply$
 End Function
'----------------------------------------------------
' function CYC-CREATE-NEW-EPHEMERAL : (name)
' Creates a new constant with name NAME, but makes
' no effort to synchronize its external ID with
' other Cyc images. This is intended for constants
' that will not be transmitted to other Cyc images.
' NAME must satisfy NEW-CONSTANT-NAME-SPEC-P.
' Single value returned satisfies CONSTANT-P.
Public Function CYC_CREATE_NEW_EPHEMERAL(ByVal Name As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
     Msg$ = "(CYC-CREATE-NEW-EPHEMERAL " + Name + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_CREATE_NEW_EPHEMERAL = Rply$
 End Function
'----------------------------------------------------
' function CYC-CREATE-NEW-PERMANENT : (name)
' Creates a new constant with name NAME, gives it a
' permanent unique external ID, and adds the constant
' creation operation to the transcript queue.
' NAME must satisfy NEW-CONSTANT-NAME-SPEC-P.
' Single value returned satisfies CONSTANT-P.
Public Function CYC_CREATE_NEW_PERMANENT(ByVal Name As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
     Msg$ = "(CYC-CREATE-NEW-PERMANENT " + Name + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_CREATE_NEW_PERMANENT = Rply$
 End Function
'----------------------------------------------------
' function CYC-KILL : (fort)
' Kill FORT and all its uses from the KB. If FORT is a microtheory, all assertions
' in that microtheory are removed.
' FORT must satisfy FORT-P.
' Single value returned satisfies BOOLEANP.
Public Function CYC_KILL(ByVal fort As String)
Dim Rply$
Dim Msg$
     Msg$ = "(CYC-KILL " + fort + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_KILL = Rply$
 End Function
'----------------------------------------------------
' function CYC-RECREATE : (constant)
' Doesn't unassert the bookkeeping info,
' but it might actually move it, or change
' its format somehow.
' CONSTANT must satisfy CONSTANT-P.
' Single value returned satisfies CONSTANT-P.
Public Function CYC_RECREATE(ByVal constant As String)
Dim Rply$
Dim Msg$
    If Left$(constant, 1) <> "#" Then constant = "#$" + constant
     Msg$ = "(CYC-RECREATE " + constant + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_RECREATE = Rply$
 End Function
'----------------------------------------------------
' function CYC-RENAME : (constant name)
' Change name of CONSTANT to NAME. Return the constant if no error, otherwise return NIL.
' CONSTANT must satisfy CONSTANT-P.
' NAME must satisfy VALID-CONSTANT-NAME.
' Single value returned satisfies CONSTANT-P or is NIL.
Public Function CYC_RENAME(ByVal constant As String, ByVal Name As String)
Dim Rply$
Dim Msg$
    If Left$(constant, 1) <> "#" Then constant = "#$" + constant
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
     Msg$ = "(CYC-RENAME " + constant + " " + Name + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_RENAME = Rply$
 End Function
'----------------------------------------------------
' function CYC-MERGE : (kill-fort keep-fort)
' Move asserted assertions on KILL-TERM onto KEEP-TERM before killing KILL-TERM.
' @return fort-p; KEEP-FORT
' KILL-FORT must satisfy FORT-P.
' KEEP-FORT must satisfy FORT-P.
' Single value returned satisfies FORT-P.
Public Function CYC_MERGE(ByVal kill_fort As String, ByVal keep_fort As String)
Dim Rply$
Dim Msg$
    If Left$(kill_fort, 1) <> "#" Then kill_fort = "#$" + kill_fort
    If Left$(keep_fort, 1) <> "#" Then keep_fort = "#$" + keep_fort
     Msg$ = "(CYC-MERGE " + kill_fort + " " + keep_fort + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_MERGE = Rply$
 End Function
'----------------------------------------------------
' function CYC-ASSERT : (sentence &optional mt properties)
' Assert SENTENCE in the specified MT.
' properties; :strength el-strength-p (:default or :monotonic)
' :direction direction-p (:forward or :backward)
' GAF assertion direction defaults to :forward, and rule
' assertion direction defaults to :backward.
' @return booleanp; t iff the assert succeeded. If the assertion
' already existed, it is considered a success.
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' MT must satisfy (NIL-OR HLMT-P).
' PROPERTIES must satisfy ASSERT-PROPERTIES-P.
' Single value returned satisfies BOOLEANP.
Public Function CYC_ASSERT(ByVal cycl_sentence As String, Optional ByVal Mt As String, Optional ByVal properties As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(properties) Then properties = strProperties
     Msg$ = "(CYC-ASSERT " + "'" + cycl_sentence + " " + Mt + " " + properties + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_ASSERT = Rply$
 End Function
'----------------------------------------------------
' function CYC-UNASSERT : (sentence &optional mt)
' Remove the assertions canonicalized from FORMULA in the microtheory MT.
' Return T if the operation succeeded, otherwise return NIL.
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' MT must satisfy (NIL-OR HLMT-P).
' Single value returned satisfies BOOLEANP.
Public Function CYC_UNASSERT(ByVal cycl_sentence As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(CYC-UNASSERT " + "'" + cycl_sentence + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_UNASSERT = Rply$
 End Function
'----------------------------------------------------
' function CYC-EDIT : (old-sentence new-sentence &optional old-mt new-mt properties)
' Unassert OLD-SENTENCE in OLD-MT, and assert NEW-SENTENCE in the specified NEW-MT.
' @see cyc-unassert and @xref cyc-assert
' OLD-SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' NEW-SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' OLD-MT must satisfy (NIL-OR HLMT-P).
' NEW-MT must satisfy (NIL-OR HLMT-P).
' Single value returned satisfies BOOLEANP.
Public Function CYC_EDIT(ByVal cycl_old_sentence As String, ByVal cycl_new_sentence As String, Optional ByVal old_mt As String, Optional ByVal new_mt As String, Optional ByVal properties As String)
Dim Rply$
Dim Msg$
    If IsMissing(old_mt) Then old_mt = strMicroTheory
    If Left$(old_mt, 1) <> "#" Then old_mt = "#$" + old_mt
    If IsMissing(new_mt) Then new_mt = strMicroTheory
    If Left$(new_mt, 1) <> "#" Then new_mt = "#$" + new_mt
    If IsMissing(properties) Then properties = strProperties
     Msg$ = "(CYC-EDIT " + "'" + cycl_old_sentence + " " + "'" + cycl_new_sentence + " " + old_mt + " " + new_mt + " " + properties + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_EDIT = Rply$
 End Function
'----------------------------------------------------
' function CYC-QUERY : (sentence &optional mt properties)
' Query for bindings for free variables which will satisfy SENTENCE within MT.
' ;;;{{{DOC
' Properties: :backchain NIL or an integer or T
' :number NIL or an integer
' :time NIL or an integer
' :depth NIL or an integer
' :conditional-sentence boolean
' If :backchain is NIL, no backchaining is performed.
' If :backchain is an integer, then at most that many backchaining steps using rules
' are performed.
' If :backchain is T, then inference is performed without limit on the number of
' backchaining steps when searching for bindings.
' If :number is an integer, then at most that number of bindings are returned.
' If :time is an integer, then at most that many seconds are consumed by the search for
' bindings.
' If :depth is an integer, then the inference paths are limited to that number of
' total steps.
' Returns NIL if the operation had an error. Otherwise returns a (possibly empty)
' binding set. In the case where the SENTENCE has no free variables,
' the form (NIL), the empty binding set is returned, indicating that the gaf is either
' directly asserted in the KB, or that it can be derived via rules in the KB.
' If it fails to be proven, NIL will be returned.
' The second return value indicates the reason why the query halted.
' If SENTENCE is an implication, or an ist wrapped around an implication,
' and the :conditional-sentence property is non-nil, cyc-query will attempt to
' prove SENTENCE by reductio ad absurdum.
' ;;;}}}EDOC
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' MT must satisfy (NIL-OR HLMT-P).
' PROPERTIES must satisfy QUERY-PROPERTIES-P.
' Single value returned satisfies QUERY-RESULTS-P.
Public Function CYC_QUERY(ByVal cycl_sentence As String, Optional ByVal Mt As String, Optional ByVal properties As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(properties) Then properties = strProperties
     Msg$ = "(CYC-QUERY " + "'" + cycl_sentence + " " + Mt + " " + properties + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_QUERY = Rply$
 End Function
'----------------------------------------------------
' function CYC-CONTINUE-QUERY : (&optional query-id properties)
' Continues a query started by @xref cyc-query.
' If QUERY-ID is :last, the most recent query is continued.
' QUERY-ID must satisfy QUERY-ID-P.
' PROPERTIES must satisfy QUERY-PROPERTIES-P.
' Single value returned satisfies QUERY-RESULTS-P.
Public Function CYC_CONTINUE_QUERY(Optional ByVal query_id As String, Optional ByVal properties As String)
Dim Rply$
Dim Msg$
    If IsMissing(query_id) Then query_id = ":last"
    If Left$(query_id, 1) <> "#" Then query_id = "#$" + query_id
    If IsMissing(properties) Then properties = strProperties
     Msg$ = "(CYC-CONTINUE-QUERY " + query_id + " " + properties + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_CONTINUE_QUERY = Rply$
 End Function
'----------------------------------------------------
' function CYC-ADD-ARGUMENT : (sentence cycl-supports &optional mt properties verify-supports)
' Tell Cyc to conclude SENTENCE (optionally in MT) based on the list of CYCL-SUPPORTS which should themselves be assertions or
' otherwise valid for support-p. If VERIFY-SUPPORTS is non-nil, then this function will attempt to verify the list of supports
' before making the assertion.
' Properties: :direction :forward or :backward
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' CYCL-SUPPORTS must satisfy LIST-OF-CYCL-SUPPORT-P.
' MT must satisfy (NIL-OR HLMT-P).
' PROPERTIES must satisfy ASSERT-PROPERTIES-P.
' VERIFY-SUPPORTS must satisfy BOOLEANP.
' Single value returned satisfies BOOLEANP.
Public Function CYC_ADD_ARGUMENT(ByVal cycl_sentence As String, ByVal cycl_supports As String, Optional ByVal Mt As String, Optional ByVal properties As String, Optional ByVal Verify_supports As String)
Dim Rply$
Dim Msg$
    If Left$(cycl_supports, 1) <> "#" Then cycl_supports = "#$" + cycl_supports
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(properties) Then properties = strProperties
    If IsMissing(Verify_supports) Then Verify_supports = strVerify_supports
    If Left$(Verify_supports, 1) <> "#" Then Verify_supports = "#$" + Verify_supports
     Msg$ = "(CYC-ADD-ARGUMENT " + "'" + cycl_sentence + " " + cycl_supports + " " + Mt + " " + properties + " " + Verify_supports + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_ADD_ARGUMENT = Rply$
 End Function
'----------------------------------------------------
' function CYC-REMOVE-ALL-ARGUMENTS : (sentence &optional mt)
' Remove all arguments for SENTENCE within MT, including both those
' arguments resulting the direct assertion of SENTENCE, and
' those arguments supporting SENTENCE which were derived through inference.
' Return T if successful, otherwise return NIL.
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' MT must satisfy (NIL-OR HLMT-P).
' Single value returned satisfies BOOLEANP.
Public Function CYC_REMOVE_ALL_ARGUMENTS(ByVal cycl_sentence As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(CYC-REMOVE-ALL-ARGUMENTS " + "'" + cycl_sentence + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_REMOVE_ALL_ARGUMENTS = Rply$
 End Function
'----------------------------------------------------
' function CYC-REMOVE-ARGUMENT : (sentence cycl-supports &optional mt)
' Remove the argument for SENTENCE specified by CYCL-SUPPORTS.
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' CYCL-SUPPORTS must satisfy LIST-OF-CYCL-SUPPORT-P.
' MT must satisfy (NIL-OR HLMT-P).
' Single value returned satisfies BOOLEANP.
Public Function CYC_REMOVE_ARGUMENT(ByVal cycl_sentence As String, ByVal cycl_supports As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(cycl_supports, 1) <> "#" Then cycl_supports = "#$" + cycl_supports
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(CYC-REMOVE-ARGUMENT " + "'" + cycl_sentence + " " + cycl_supports + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_REMOVE_ARGUMENT = Rply$
 End Function
'----------------------------------------------------
' function CYC-REWRITE : (source-fort target-fort)
' 'moves' all asserted arguments from SOURCE-FORT to TARGET-FORT
' @return fort-p; TARGET-FORT
' SOURCE-FORT must satisfy FORT-P.
' TARGET-FORT must satisfy FORT-P.
' Single value returned satisfies FORT-P.
Public Function CYC_REWRITE(ByVal source_fort As String, ByVal target_fort As String)
Dim Rply$
Dim Msg$
    If Left$(source_fort, 1) <> "#" Then source_fort = "#$" + source_fort
    If Left$(target_fort, 1) <> "#" Then target_fort = "#$" + target_fort
     Msg$ = "(CYC-REWRITE " + source_fort + " " + target_fort + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_REWRITE = Rply$
 End Function
'----------------------------------------------------
' function CYC-TMS-RECONSIDER-SENTENCE : (sentence &optional mt)
' Reconsider all arguments for SENTENCE within MT. Return T if the
' operation succeeded, NIL if there was an error.
' SENTENCE must satisfy POSSIBLY-SENTENCE-P.
' MT must satisfy (NIL-OR HLMT-P).
' Single value returned satisfies BOOLEANP.
' ------------------------------------------------------------------
Public Function CYC_TMS_RECONSIDER_SENTENCE(ByVal cycl_sentence As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(CYC-TMS-RECONSIDER-SENTENCE " + "'" + cycl_sentence + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    CYC_TMS_RECONSIDER_SENTENCE = Rply$
 End Function
'----------------------------------------------------
' function FI-FIND : (name)
' Return the constant indentified by the string NAME.
' Single value returned satisfies CONSTANT-P or is NIL.
Public Function FI_FIND(ByVal Name As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
     Msg$ = "(FI-FIND " + Name + " " + ")"
     Rply$ = Direct(Msg$)
    FI_FIND = Rply$
 End Function
'----------------------------------------------------
' function FI-COMPLETE : (prefix &optional case-sensitive?)
' Return a list of constants whose name begins with PREFIX. The comparison is
' performed in a case-insensitive mode unless CASE-SENSITIVE? is non-nil.
' Single value returned is a list of elements satisfying CONSTANT-P.
Public Function FI_COMPLETE(ByVal prefix As String, Optional ByVal Case_sensitiveQ As String)
Dim Rply$
Dim Msg$
    If Left$(prefix, 1) <> "#" Then prefix = "#$" + prefix
    If IsMissing(Case_sensitiveQ) Then Case_sensitiveQ = strCase_sensitiveQ
    If Left$(Case_sensitiveQ, 1) <> "#" Then Case_sensitiveQ = "#$" + Case_sensitiveQ
     Msg$ = "(FI-COMPLETE " + prefix + " " + Case_sensitiveQ + " " + ")"
     Rply$ = Direct(Msg$)
    FI_COMPLETE = Rply$
 End Function
'----------------------------------------------------
' function FI-CREATE : (name &optional external-id)
' Create a new constant with NAME.
' If EXTERNAL-ID is non-null it is used, otherwise a unique identifier is generated.
' Single value returned satisfies CONSTANT-P.
Public Function FI_CREATE(ByVal Name As String, Optional ByVal External_id As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
    If IsMissing(External_id) Then External_id = strExternal_id
    If Left$(External_id, 1) <> "#" Then External_id = "#$" + External_id
     Msg$ = "(FI-CREATE " + Name + " " + External_id + " " + ")"
     Rply$ = Direct(Msg$)
    FI_CREATE = Rply$
 End Function
'----------------------------------------------------
' function FI-FIND-OR-CREATE : (name &optional external-id)
' Return constant with NAME if it is present.
' If not present, then create constant with NAME, using EXTERNAL-ID if given.
' If EXTERNAL-ID is not given, generate a new one for the new constant.
' Single value returned satisfies CONSTANT-P.
Public Function FI_FIND_OR_CREATE(ByVal Name As String, Optional ByVal External_id As String)
Dim Rply$
Dim Msg$
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
    If IsMissing(External_id) Then External_id = strExternal_id
    If Left$(External_id, 1) <> "#" Then External_id = "#$" + External_id
     Msg$ = "(FI-FIND-OR-CREATE " + Name + " " + External_id + " " + ")"
     Rply$ = Direct(Msg$)
    FI_FIND_OR_CREATE = Rply$
 End Function
'----------------------------------------------------
' function FI-KILL : (fort)
' Kill FORT and all its uses from the KB. If FORT is a microtheory, all assertions
' in that microtheory are removed.
' Single value returned satisfies BOOLEANP.
Public Function FI_KILL(ByVal fort As String)
Dim Rply$
Dim Msg$
     Msg$ = "(FI-KILL " + fort + " " + ")"
     Rply$ = Direct(Msg$)
    FI_KILL = Rply$
 End Function
'----------------------------------------------------
' function FI-RENAME : (constant name)
' Change name of CONSTANT to NAME. Return the constant if no error, otherwise return NIL.
' Single value returned satisfies CONSTANT-P or is NIL.
Public Function FI_RENAME(ByVal constant As String, ByVal Name As String)
Dim Rply$
Dim Msg$
    If Left$(constant, 1) <> "#" Then constant = "#$" + constant
    If Left$(Name, 1) <> "#" Then Name = "#$" + Name
     Msg$ = "(FI-RENAME " + constant + " " + Name + " " + ")"
     Rply$ = Direct(Msg$)
    FI_RENAME = Rply$
 End Function
'----------------------------------------------------
' function FI-LOOKUP : (formula mt)
' Returns two values when looking up the EL FORMULA in the microtheory MT. The
' first value returned is a list of HL formulas resulting from the canonicalization
' of the EL FORMULA. The second value is T iff all the HL assertions were properly
' put into the KB.
' Value 1 returned is a list of elements satisfying CONSP.
' Value 2 returned satisfies BOOLEANP
Public Function FI_LOOKUP(ByVal Formula As String, ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-LOOKUP " + Formula + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_LOOKUP = Rply$
 End Function
'----------------------------------------------------
' function FI-ASSERT : (formula mt &optional strength direction)
' Assert the FORMULA in the specified MT. STRENGTH is :default or :monotonic.
' DIRECTION is :forward or :backward. GAF assertion direction defaults to :forward, and rule
' assertion direction defaults to :backward. Return T if there was no error.
' Single value returned satisfies BOOLEANP.
Public Function FI_ASSERT(ByVal Formula As String, ByVal Mt As String, Optional ByVal Strength As String, Optional ByVal Direction As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(Strength) Then Strength = strStrength
    If Left$(Strength, 1) <> "#" Then Strength = "#$" + Strength
    If IsMissing(Direction) Then Direction = strDirection
    If Left$(Direction, 1) <> "#" Then Direction = "#$" + Direction
     Msg$ = "(FI-ASSERT " + Formula + " " + Mt + " " + Strength + " " + Direction + " " + ")"
     Rply$ = Direct(Msg$)
    FI_ASSERT = Rply$
 End Function
'----------------------------------------------------
' function FI-UNASSERT : (formula mt)
' Remove the assertions canonicalized from FORMULA in the microtheory MT.
' Return T if the operation succeeded, otherwise return NIL.
' Single value returned satisfies BOOLEANP.
Public Function FI_UNASSERT(ByVal Formula As String, ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-UNASSERT " + Formula + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_UNASSERT = Rply$
 End Function
'----------------------------------------------------
' function FI-EDIT : (old-formula new-formula &optional old-mt new-mt strength direction)
' Unassert the assertions canonicalized from OLD-FORMULA in the microtheory OLD-MT.
' Assert NEW-FORMULA in the specified NEW-MT.
' STRENGTH is :default or :monotonic.
' DIRECTION is :forward or :backward.
' GAF assertion direction defaults to :forward.
' Rule assertion direction defaults to :backward.
' Return T if there was no error.
' Single value returned satisfies BOOLEANP.
Public Function FI_EDIT(ByVal old_formula As String, ByVal new_formula As String, Optional ByVal old_mt As String, Optional ByVal new_mt As String, Optional ByVal Strength As String, Optional ByVal Direction As String)
Dim Rply$
Dim Msg$
    If Left$(old_formula, 1) <> "#" Then old_formula = "#$" + old_formula
    If Left$(new_formula, 1) <> "#" Then new_formula = "#$" + new_formula
    If IsMissing(old_mt) Then old_mt = strMicroTheory
    If Left$(old_mt, 1) <> "#" Then old_mt = "#$" + old_mt
    If IsMissing(new_mt) Then new_mt = strMicroTheory
    If Left$(new_mt, 1) <> "#" Then new_mt = "#$" + new_mt
    If IsMissing(Strength) Then Strength = strStrength
    If Left$(Strength, 1) <> "#" Then Strength = "#$" + Strength
    If IsMissing(Direction) Then Direction = strDirection
    If Left$(Direction, 1) <> "#" Then Direction = "#$" + Direction
     Msg$ = "(FI-EDIT " + old_formula + " " + new_formula + " " + old_mt + " " + new_mt + " " + Strength + " " + Direction + " " + ")"
     Rply$ = Direct(Msg$)
    FI_EDIT = Rply$
 End Function
'----------------------------------------------------
' function FI-BLAST : (formula mt)
' Remove all arguments for the FORMULA within MT, including both those
' arguments resulting the direct assertion of the FORMULA, and
' those arguments supporting the FORMULA which were derived through inference.
' Return T if successful, otherwise return NIL.
' Single value returned satisfies BOOLEANP.
Public Function FI_BLAST(ByVal Formula As String, ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-BLAST " + Formula + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_BLAST = Rply$
 End Function
'----------------------------------------------------
' function FI-ASK : (formula &optional mt backchain number time depth)
' Ask for bindings for free variables which will satisfy FORMULA within MT.
' If BACKCHAIN is NIL, no inference is performed.
' If BACKCHAIN is an integer, then at most that many backchaining steps using rules
' are performed.
' If BACKCHAIN is T, then inference is performed without limit on the number of
' backchaining steps when searching for bindings.
' If NUMBER is an integer, then at most that number of bindings are returned.
' If TIME is an integer, then at most TIME seconds are consumed by the search for
' bindings.
' If DEPTH is an integer, then the inference paths are limited to that number of
' total steps.
' Returns NIL if the operation had an error. Otherwise returns a list of variable/
' binding pairs. In the case where the FORMULA has no free variables, the form
' (((T . T))) is returned indicating that the gaf is either directly asserted in the
' KB, or that it can be derived via rules in the KB.
' Single value returned satisfies LISTP or is NIL.
Public Function FI_ASK(ByVal Formula As String, Optional ByVal Mt As String, Optional ByVal BackChain As String, Optional ByVal Number As String, Optional ByVal Time As String, Optional ByVal Depth As String)
Dim Rply$
Dim Msg$
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(BackChain) Then BackChain = strBackchain
    If IsMissing(Number) Then Number = strNumber
    If IsMissing(Time) Then Time = strTime
    If IsMissing(Depth) Then Depth = strDepth
     Msg$ = "(FI-ASK " + Formula + " " + Mt + " " + BackChain + " " + Number + " " + Time + " " + Depth + " " + ")"
     Rply$ = Direct(Msg$)
    FI_ASK = Rply$
 End Function
'----------------------------------------------------
' function FI-CONTINUE-LAST-ASK : (&optional backchain number time depth reconsider-deep)
' Continue the last ask that was performed with more resources.
' If BACKCHAIN is NIL, no inference is performed.
' If BACKCHAIN is an integer, then at most that many backchaining steps using rules
' are performed.
' If BACKCHAIN is T, then inference is performed without limit on the number of
' backchaining steps when searching for bindings.
' If NUMBER is an integer, then at most that number of bindings are returned.
' If TIME is an integer, then at most TIME seconds are consumed by the search for
' bindings.
' If DEPTH is an integer, then the inference paths are limited to that number of
' total steps.
' Returns NIL if the operation had an error. Otherwise returns a list of variable/
' binding pairs. In the case where the FORMULA has no free variables, the form
' (((T . T))) is returned indicating that the gaf is either directly asserted in the
' KB, or that it can be derived via rules in the KB.
' Single value returned satisfies LISTP or is NIL.
Public Function FI_CONTINUE_LAST_ASK(Optional ByVal BackChain As String, Optional ByVal Number As String, Optional ByVal Time As String, Optional ByVal Depth As String, Optional ByVal Reconsider_deep As String)
Dim Rply$
Dim Msg$
    If IsMissing(BackChain) Then BackChain = strBackchain
    If IsMissing(Number) Then Number = strNumber
    If IsMissing(Time) Then Time = strTime
    If IsMissing(Depth) Then Depth = strDepth
    If IsMissing(Reconsider_deep) Then Reconsider_deep = strReconsider_deep
    If Left$(Reconsider_deep, 1) <> "#" Then Reconsider_deep = "#$" + Reconsider_deep
     Msg$ = "(FI-CONTINUE-LAST-ASK " + BackChain + " " + Number + " " + Time + " " + Depth + " " + Reconsider_deep + " " + ")"
     Rply$ = Direct(Msg$)
    FI_CONTINUE_LAST_ASK = Rply$
 End Function
'----------------------------------------------------
' function FI-ASK-STATUS : ()
' Return a status as to how the last ask successfully completed regarding
' resource limits.
' :EXHAUST if the search spaces was exhausted.
' :DEPTH if the search space was limited because some nodes were too deep.
' :NUMBER if the requested number of bindings was found without exceeding other limits.
' :TIME if the time alloted expired prior to exhausting the search space.
' Return NIL if there was no prior successful ask.
' Single value returned satisfies ATOM or is NIL.
Public Function FI_ASK_STATUS()
Dim Rply$
Dim Msg$
     Msg$ = "(FI-ASK-STATUS " + ")"
     Rply$ = Direct(Msg$)
    FI_ASK_STATUS = Rply$
 End Function
'----------------------------------------------------
' function FI-TMS-RECONSIDER-FORMULA : (formula mt)
' Reconsider all arguments for FORMULA within MT. Return T if the
' operation succeeded, NIL if there was an error.
' Single value returned satisfies BOOLEANP.
Public Function FI_TMS_RECONSIDER_FORMULA(ByVal Formula As String, ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-TMS-RECONSIDER-FORMULA " + Formula + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_TMS_RECONSIDER_FORMULA = Rply$
 End Function
'----------------------------------------------------
' function FI-TMS-RECONSIDER-MT : (mt)
' Reconsider all arguments for all formulas within MT. Return T if the
' operation succeeded, NIL if there was an error.
' Single value returned satisfies BOOLEANP.
Public Function FI_TMS_RECONSIDER_MT(ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-TMS-RECONSIDER-MT " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_TMS_RECONSIDER_MT = Rply$
 End Function
'----------------------------------------------------
' function FI-TMS-RECONSIDER-GAFS : (term &optional arg predicate mt)
' Reconsider all arguments for all gaf formulas involving TERM.
' ARG optionally constrains gafs such that the TERM occupies a specific arg position.
' PREDICATE optionally constrains gafs such that the specifed PREDICATE
' occupies the arg0 position.
' MT optionally constrains gafs such that they must be included in the specific
' microtheory.
' Return T if the operation succeeded, NIL if there was an error.
' Single value returned satisfies BOOLEANP.
Public Function FI_TMS_RECONSIDER_GAFS(ByVal term As String, Optional ByVal arg As String, Optional ByVal predicate As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(term, 1) <> "#" Then term = "#$" + term
    If IsMissing(arg) Then arg = strArg
    If Left$(arg, 1) <> "#" Then arg = "#$" + arg
    If IsMissing(predicate) Then predicate = strPredicate
    If Left$(predicate, 1) <> "#" Then predicate = "#$" + predicate
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-TMS-RECONSIDER-GAFS " + term + " " + arg + " " + predicate + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_TMS_RECONSIDER_GAFS = Rply$
 End Function
'----------------------------------------------------
' function FI-TMS-RECONSIDER-TERM : (term &optional mt)
' Reconsider all arguments involving TERM.
' If MT is provided, then only arguments in that microtheory are reconsidered.
' Return T if the operation succeeded, NIL if there was an error.
' Single value returned satisfies BOOLEANP.
Public Function FI_TMS_RECONSIDER_TERM(ByVal term As String, Optional ByVal Mt As String)
Dim Rply$
Dim Msg$
    If Left$(term, 1) <> "#" Then term = "#$" + term
    If IsMissing(Mt) Then Mt = strMicroTheory
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
     Msg$ = "(FI-TMS-RECONSIDER-TERM " + term + " " + Mt + " " + ")"
     Rply$ = Direct(Msg$)
    FI_TMS_RECONSIDER_TERM = Rply$
 End Function
'----------------------------------------------------
' function FI-HYPOTHESIZE : (formula mt &optional name-prefix term-ids)
' Cyc attempts to check if FORMULA is satisfiable in MT by 'hypothesizing'
' constants for the variables in FORMULA, substituting them into FORMULA,
' and asserting the new formula in MT. If this would trigger a
' contradiction, then NIL is returned. Otherwise a binding list of variable /
' constant pairs is returned, indicating the constants which were
' successfully 'hypothesized'. The form (((T . T))) is returned if no new terms
' required creation for the assertion of FORMULA.
' NAME-PREFIX is a string which is used as a prefix for the name of each new
' constant hypothesized. TERM-IDS is a list of variable / id pairs indicating
' that the specified id should be used when generating the constant for the variable
' in FORMULA. If TERM-IDS is NIL, then unused ids are allocated for the new
' constants.
' Single value returned satisfies LISTP or is NIL.
Public Function FI_HYPOTHESIZE(ByVal Formula As String, ByVal Mt As String, Optional ByVal name_prefix As String, Optional ByVal term_ids As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(name_prefix) Then name_prefix = strName_prefix
    If Left$(name_prefix, 1) <> "#" Then name_prefix = "#$" + name_prefix
    If IsMissing(term_ids) Then term_ids = strTerm_ids
    If Left$(term_ids, 1) <> "#" Then term_ids = "#$" + term_ids
     Msg$ = "(FI-HYPOTHESIZE " + Formula + " " + Mt + " " + name_prefix + " " + term_ids + " " + ")"
     Rply$ = Direct(Msg$)
    FI_HYPOTHESIZE = Rply$
 End Function
'----------------------------------------------------
' function FI-PROVE : (formula mt &optional backchain number time depth)
' Attempts to prove FORMULA is true in MT under the given resource constraints.
' BACKCHAIN, NUMBER, TIME and DEPTH function as described for FI-ASK.
' FORMULA is interpreted as follows:
' If FORMULA is of the form (#$implies [antecedant] [consequent]) then
' (1) free variables in [antecedant] are assumed to be universally
' quantified
' (2) remaining variables in [consequent] are assumed to be existentially
' quantified.
' Otherwise FORMULA is interpreted as (#$implies #$True FORMULA) and handled as the
' case above.
' It returns NIL or a list of arguments as described for FI-JUSTIFY.
' Single value returned satisfies (LIST LISTP) or is NIL.
Public Function FI_PROVE(ByVal Formula As String, ByVal Mt As String, Optional ByVal BackChain As String, Optional ByVal Number As String, Optional ByVal Time As String, Optional ByVal Depth As String)
Dim Rply$
Dim Msg$
    If Left$(Mt, 1) <> "#" Then Mt = "#$" + Mt
    If IsMissing(BackChain) Then BackChain = strBackchain
    If IsMissing(Number) Then Number = strNumber
    If IsMissing(Time) Then Time = strTime
    If IsMissing(Depth) Then Depth = strDepth
     Msg$ = "(FI-PROVE " + Formula + " " + Mt + " " + BackChain + " " + Number + " " + Time + " " + Depth + " " + ")"
     Rply$ = Direct(Msg$)
    FI_PROVE = Rply$
 End Function
'----------------------------------------------------
' function FI-GET-ERROR : ()
' Return a description of the error resulting from the last FI operation.
' Single value returned satisfies ATOM or is NIL.
Public Function FI_GET_ERROR()
Dim Rply$
Dim Msg$
     Msg$ = "(FI-GET-ERROR " + ")"
     Rply$ = Direct(Msg$)
    FI_GET_ERROR = Rply$
 End Function
'----------------------------------------------------
' function FI-GET-WARNING : ()
' Return a description of the warning resulting from the last FI operation.
' Single value returned satisfies ATOM or is NIL.
Public Function FI_GET_WARNING()
Dim Rply$
Dim Msg$
     Msg$ = "(FI-GET-WARNING " + ")"
     Rply$ = Direct(Msg$)
    FI_GET_WARNING = Rply$
 End Function
 
'----------------------------------------------------
'----------------------------------------------------
'   AUTO GENERATED CYC FUNCTIONS FROM JAVA API
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------
'----------------------------------------------------

'---------------- setReadableNarts ----------------
Public Sub setReadableNarts()

'
' /**
' * Sets the *print-readable-narts* feature on.
' *
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void setReadableNarts ()
' throws IOException, UnknownHostException, CycApiException {
' converseVoid("(csetq *print-readable-narts t)");
' }
Dim Command$, Reply$
Command$ = "(csetq *print-readable-narts t)"
Reply$ = Direct(Command$)
' setReadableNarts = MsgIn
End Sub

'---------------- getConstantName ----------------
Public Function getConstantName(ID As Integer) As String

'
' /**
' * Gets the name for the given constant id.
' *
' * @param id the id of the constant object for which the name is sought
' * @return the name for the given CycConstant
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getConstantName (Integer id)
' throws IOException, UnknownHostException, CycApiException {
' // Optimized for the binary api.
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("constant-name"));
' CycList command1 = new CycList();
' command.add(command1);
' command1.add(CycObjectFactory.makeCycSymbol("find-constant-by-internal-id"));
' command1.add(id);
' return converseString(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(constant-name (find-constant-by-internal-id " + Str$(ID) + "))"

Reply$ = Direct(Command$)
getConstantName = MsgIn
End Function

'---------------- getVariableName ----------------
Public Function getVariableName(ID As Integer) As String

'
' /**
' * Gets the name for the given variable id.
' *
' * @param id the id of the variable object for which the name is sought
' * @return the name for the given CycVariable
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getVariableName (Integer id)
' throws IOException, UnknownHostException, CycApiException {
' // Optimized for the binary api.
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("variable-name"));
' CycList command1 = new CycList();
' command.add(command1);
' command1.add(CycObjectFactory.makeCycSymbol("find-variable-by-id"));
' command1.add(id);
' return converseString(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(variable-name (find-variable-by-internal-id " + Str$(ID) + "))"

Reply$ = Direct(Command$)
getVariableName = MsgIn
End Function

'---------------- getImprecisePluralGeneratedPhrase ----------------
Public Function getImprecisePluralGeneratedPhrase(cycFort As String) As String

'
' /**
' * Gets the imprecise plural generated phrase for a CycFort (intended for collections).
' *
' * @param cycFort the term for paraphrasing
' * @return the imprecise plural generated phrase for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getImprecisePluralGeneratedPhrase (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-off (generate-phrase " + cycFort.stringApiValue() + " '(#$plural)))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-off (generate-phrase " + cycFort + " '(#$plural)))"
Reply$ = Direct(Command$)
getImprecisePluralGeneratedPhrase = MsgIn
End Function

'---------------- getPluralGeneratedPhrase ----------------
Public Function getPluralGeneratedPhrase(cycFort As String) As String

'
' /**
' * Gets the plural generated phrase for a CycFort (intended for collections).
' *
' * @param cycFort the term for paraphrasing
' * @return the plural generated phrase for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getPluralGeneratedPhrase (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-on (generate-phrase " + cycFort.stringApiValue() + " '(#$plural)))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-on (generate-phrase " + cycFort + " '(#$plural)))"
Reply$ = Direct(Command$)
getPluralGeneratedPhrase = MsgIn
End Function

'---------------- getImpreciseSingularGeneratedPhrase ----------------
Public Function getImpreciseSingularGeneratedPhrase(cycFort As String) As String

'
' /**
' * Gets the imprecise singular generated phrase for a CycFort (intended for individuals).
' *
' * @param cycFort the term for paraphrasing
' * @return the singular generated phrase for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getImpreciseSingularGeneratedPhrase (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-off (generate-phrase " + cycFort.stringApiValue() + " '(#$singular)))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-off (generate-phrase " + cycFort + " '(#$singular)))"
Reply$ = Direct(Command$)
getImpreciseSingularGeneratedPhrase = MsgIn
End Function

'---------------- getSingularGeneratedPhrase ----------------
Public Function getSingularGeneratedPhrase(cycFort As String) As String

'
' /**
' * Gets the singular generated phrase for a CycFort (intended for individuals).
' *
' * @param cycFort the term for paraphrasing
' * @return the singular generated phrase for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getSingularGeneratedPhrase (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-on (generate-phrase " + cycFort.stringApiValue() + " '(#$singular)))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-on (generate-phrase " + cycFort + " '(#$singular)))"
Reply$ = Direct(Command$)
getSingularGeneratedPhrase = MsgIn
End Function

'---------------- getGeneratedPhrase ----------------
Public Function getGeneratedPhrase(cycFort As String) As String

'
' /**
' * Gets the default generated phrase for a CycFort (intended for predicates).
' *
' * @param cycFort the predicate term for paraphrasing
' * @return the default generated phrase for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getGeneratedPhrase (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-on (generate-phrase " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-on (generate-phrase " + cycFort + "))"
Reply$ = Direct(Command$)
getGeneratedPhrase = MsgIn
End Function

'---------------- getParaphrase ----------------
Public Function getParaphrase(assertion As String) As String

'
' /**
' * Gets the paraphrase for a Cyc assertion.
' *
' * @param assertion the assertion formula
' * @return the paraphrase for a Cyc assertion
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getParaphrase (CycList assertion)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-on (generate-phrase '" + assertion.cyclify() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-on (generate-phrase '" + assertion + "))"
Reply$ = Direct(Command$)
getParaphrase = MsgIn
End Function

'---------------- getImpreciseParaphrase ----------------
Public Function getImpreciseParaphrase(assertionString As String) As String

'
' /**
' * Gets the imprecise paraphrase for a Cyc assertion.
' *
' * @param assertionString the assertion formula
' * @return the imprecise paraphrase for a Cyc assertion
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getImpreciseParaphrase (String assertionString)
' throws IOException, UnknownHostException, CycApiException {
' CycList assertion = this.makeCycList(assertionString);
' return converseString("(with-precise-paraphrase-off (generate-phrase '" + assertion.cyclify() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-off (generate-phrase '" + assertionString + "))"
Reply$ = Direct(Command$)
getImpreciseParaphrase = MsgIn
End Function

'---------------- getImpreciseParaphrase ----------------
Public Function getImpreciseParaphrase2(assertion As String) As String

'
' /**
' * Gets the imprecise paraphrase for a Cyc assertion.
' *
' * @param assertion the assertion formula
' * @return the imprecise paraphrase for a Cyc assertion
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getImpreciseParaphrase (CycList assertion)
' throws IOException, UnknownHostException, CycApiException {
' return converseString("(with-precise-paraphrase-off (generate-phrase '" + assertion.cyclify() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-precise-paraphrase-off (generate-phrase '" + assertion + "))"
Reply$ = Direct(Command$)
getImpreciseParaphrase2 = MsgIn
End Function

'---------------- getComment ----------------
Public Function getComment(cycFort As String) As String
Dim Command$, Reply$

Dim Quote$
' /**
' * Gets the comment for a CycFort.  Embedded quotes are replaced by spaces.
' *
' * @param cycFort the term for which the comment is sought
' * @return the comment for the given CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getComment (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' String script =
' "(clet ((comment-string \n" +
' "         (with-all-mts (comment " + cycFort.stringApiValue() + ")))) \n" +
' "  (fif comment-string \n" +
' "       (string-substitute \" \" \"\\\"\" comment-string) \n" +
' "       \"\"))";
' return converseString(script);
' }

' *****> INSERT CODE HERE <*****
Quote$ = """"
Command$ = "(clet ((comment-string " + vbCr + _
            "         (with-all-mts (comment " + cycFort + ")))) " + vbCr + _
            "  (fif comment-string " + vbCr + _
            "       (string-substitute " + Quote$ + " " + Quote$ + " " + Quote$ + "\\ " + Quote$ + " " + Quote$ + " comment-string) " + vbCr + _
            "       " + Quote$ + "" + Quote$ + "))"

'Command$ = script
Reply$ = Direct(Command$)
getComment = MsgIn
End Function

'---------------- getCommentInMt ----------------
Public Function getCommentInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the comment for a CycFort in the relevant mt.
' * Embedded quotes are replaced by spaces.
' *
' * @param cycFort the term for which the comment is sought
' * @param mt the relevant mt from which the comment is visible
' * @return the comment for the given CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public String getComment (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' String script =
' "(clet ((comment-string \n" +
' "         (comment " + cycFort.stringApiValue() + " " + mt.stringApiValue() + "))) \n" +
' "  (fif comment-string \n" +
' "       (string-substitute \" \" \"\\\"\" comment-string) \n" +
' "       \"\"))";
' return converseString(script);
' }
Dim Command$, Reply$
Dim Quote$
Quote$ = """"
' *****> INSERT CODE HERE <*****
Quote$ = """"
Command$ = "(clet ((comment-string \n" + _
            "         (comment " + cycFort + " " + Mt + "))) \n" + vbCr + _
            "  (fif comment-string " + vbCr + _
            "       (string-substitute " + Quote$ + " " + Quote$ + " " + Quote$ + "\\ " + Quote$ + " " + Quote$ + " comment-string) " + vbCr + _
            "       " + Quote$ + "" + Quote$ + "))"

'Command$ = script
Reply$ = Direct(Command$)
getCommentInMt = MsgIn
End Function

'---------------- getIsas ----------------
Public Function getIsas(cycFort As String) As String

'
' /**
' * Gets the list of the isas for the given CycFort.
' *
' * @param cycFort the term for which its isas are sought
' * @return the list of the isas for the given CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getIsas (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (isa " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (isa " + cycFort + ")))"
Reply$ = Direct(Command$)
getIsas = MsgIn
End Function

'---------------- getIsasInMt ----------------
Public Function getIsasInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the isas for the given CycFort.
' *
' * @param cycFort the term for which its isas are sought
' * @param mt the relevant mt
' * @return the list of the isas for the given CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getIsas (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(isa " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(isa " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getIsasInMt = MsgIn
End Function

'---------------- getGenls ----------------
Public Function getGenls(cycFort As String) As String

'
' /**
' * Gets the list of the directly asserted true genls for the given CycFort collection.
' *
' * @param cycFort the given term
' * @return the list of the directly asserted true genls for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenls (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (genls " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (genls " + cycFort + ")))"
Reply$ = Direct(Command$)
getGenls = MsgIn
End Function

'---------------- getGenlsInMt ----------------
Public Function getGenlsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the directly asserted true genls for the given CycFort collection.
' *
' * @param cycFort the given term
' * @param mt the relevant mt
' * @return the list of the directly asserted true genls for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenls (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(genls " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genls " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getGenlsInMt = MsgIn
End Function

'---------------- getMinGenls ----------------
Public Function getMinGenls(cycFort As String) As String

'
' /**
' * Gets a list of the minimum (most specific) genls for a CycFort collection.
' *
' * @param cycFort the given collection term
' * @return a list of the minimum (most specific) genls for a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMinGenls (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (min-genls " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (min-genls " + cycFort + ")))"
Reply$ = Direct(Command$)
getMinGenls = MsgIn
End Function

'---------------- getMinGenlsInMt ----------------
Public Function getMinGenlsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets a list of the minimum (most specific) genls for a CycFort collection.
' *
' * @param cycFort the collection
' * @param mt the microtheory in which to look
' * @return a list of the minimum (most specific) genls for a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMinGenls (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(min-genls " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(min-genls " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getMinGenlsInMt = MsgIn
End Function

'---------------- getSpecs ----------------
Public Function getSpecs(cycFort As String) As String

'
' /**
' * Gets the list of the directly asserted true specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the directly asserted true specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSpecs (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (specs " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (specs " + cycFort + ")))"
Reply$ = Direct(Command$)
getSpecs = MsgIn
End Function

'---------------- getSpecsInMt ----------------
Public Function getSpecsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the directly asserted true specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the microtheory in which to look
' * @return the list of the directly asserted true specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSpecs (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(specs " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(specs " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getSpecsInMt = MsgIn
End Function

'---------------- getMaxSpecs ----------------
Public Function getMaxSpecs(cycFort As String) As String

'
' /**
' * Gets the list of the least specific specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the least specific specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMaxSpecs (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (max-specs " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (max-specs " + cycFort + ")))"
Reply$ = Direct(Command$)
getMaxSpecs = MsgIn
End Function

'---------------- getMaxSpecsInMt ----------------
Public Function getMaxSpecsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the least specific specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the microtheory in which to look
' * @return the list of the least specific specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMaxSpecs (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(max-specs " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(max-specs " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getMaxSpecsInMt = MsgIn
End Function

'---------------- getGenlSiblings ----------------
Public Function getGenlSiblings(cycFort As String) As String

'
' /**
' * Gets the list of the direct genls of the direct specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the direct genls of the direct specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenlSiblings (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (genl-siblings " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (genl-siblings " + cycFort + ")))"
Reply$ = Direct(Command$)
getGenlSiblings = MsgIn
End Function

'---------------- getGenlSiblingsInMt ----------------
Public Function getGenlSiblingsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the direct genls of the direct specs for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the microtheory in which to look
' * @return the list of the direct genls of the direct specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenlSiblings (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(genl-siblings " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl-siblings " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getGenlSiblingsInMt = MsgIn
End Function

'---------------- getSpecSiblings ----------------
Public Function getSpecSiblings(cycFort As String) As String

'
' /**
' * Gets the list of the siblings (direct specs of the direct genls) for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the siblings (direct specs of the direct genls) for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSpecSiblings (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (spec-siblings " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (spec-siblings " + cycFort + ")))"
Reply$ = Direct(Command$)
getSpecSiblings = MsgIn
End Function

'---------------- getSpecSiblingsInMt ----------------
Public Function getSpecSiblingsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the siblings (direct specs of the direct genls) for the given CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the microtheory in which to look
' * @return the list of the siblings (direct specs of the direct genls) for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSpecSiblings (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(spec-siblings " + cycFort.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(spec-siblings " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getSpecSiblingsInMt = MsgIn
End Function

'---------------- getAllGenls ----------------
Public Function getAllGenls(cycFort As String) As String

'
' /**
' * Gets the list of all of the direct and indirect genls for the given CycFort collection.
' *
' * @param cycFort the collection
' * @return the list of all of the direct and indirect genls for a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenls (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-genls-in-any-mt " + cycFort.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-genls-in-any-mt " + cycFort + ")"
Reply$ = Direct(Command$)
getAllGenls = MsgIn
End Function

'---------------- getAllGenlsInMt ----------------
Public Function getAllGenlsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect genls for a CycFort collection
' * given a relevant microtheory.
' *
' * @param cycFort the collection
' * @param mt the relevant mt
' * @return the list of all of the direct and indirect genls for a CycFort collection
' * given a relevant microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenls (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-genls " + cycFort.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-genls " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllGenlsInMt = MsgIn
End Function

'---------------- getAllSpecs ----------------
Public Function getAllSpecs(cycFort As String) As String

'
' /**
' * Gets a list of all of the direct and indirect specs for a CycFort collection.
' *
' * @param cycFort the collection
' * @return the list of all of the direct and indirect specs for the given collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecs (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-specs " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-specs " + cycFort + ")))"
Reply$ = Direct(Command$)
getAllSpecs = MsgIn
End Function

'---------------- getAllSpecsInMt ----------------
Public Function getAllSpecsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs for the given collection
' * in the given microtheory.
' *
' * @param cycFort the collection
' * @return the list of all of the direct and indirect specs for the given collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecs (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-specs " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-specs " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllSpecsInMt = MsgIn
End Function

'---------------- getAllGenlsWrt ----------------
Public Function getAllGenlsWrt(spec As String, genl As String) As String

'
' /**
' * Gets the list of all of the direct and indirect genls for a CycFort SPEC which are also specs of
' * CycFort GENL.
' *
' * @param spec the given collection
' * @param genl the more general collection
' * @return the list of all of the direct and indirect genls for a CycFort SPEC which are also specs of
' * CycFort GENL
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenlsWrt (CycFort spec, CycFort genl)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-genls-wrt " + spec.stringApiValue() + " " + genl.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-genls-wrt " + spec + " " + genl + ")))"
Reply$ = Direct(Command$)
getAllGenlsWrt = MsgIn
End Function

'---------------- getAllGenlsWrtInMt ----------------
Public Function getAllGenlsWrtInMt(spec As String, genl As String, Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect genls for a CycFort SPEC which are also specs of
' * CycFort GENL.
' *
' * @param spec the given collection
' * @param genl the more general collection
' * @param mt the relevant mt
' * @return the list of all of the direct and indirect genls for a CycFort SPEC which are also specs of
' * CycFort GENL
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenlsWrt (CycFort spec, CycFort genl, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-genls-wrt " + spec.stringApiValue() + " " + genl.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-genls-wrt " + spec + " " + genl + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllGenlsWrtInMt = MsgIn
End Function

'---------------- getAllDependentSpecs ----------------
Public Function getAllDependentSpecs(cycFort As String) As String

'
' /**
' * Gets the list of all of the dependent specs for a CycFort collection.  Dependent specs are those direct and
' * indirect specs of the collection such that every path connecting the spec to a genl of the collection passes
' * through the collection.  In a typical taxomonmy it is expected that all-dependent-specs gives the same
' * result as all-specs.
' *
' * @param cycFort the given collection
' * @return the list of all of the dependent specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllDependentSpecs (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-dependent-specs " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-dependent-specs " + cycFort + ")))"
Reply$ = Direct(Command$)
getAllDependentSpecs = MsgIn
End Function

'---------------- getAllDependentSpecsInMt ----------------
Public Function getAllDependentSpecsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of all of the dependent specs for a CycFort collection.  Dependent specs are those direct and
' * indirect specs of the collection such that every path connecting the spec to a genl of the collection passes
' * through the collection.  In a typical taxomonmy it is expected that all-dependent-specs gives the same
' * result as all-specs.
' *
' * @param cycFort the given collection
' * @param mt the relevant mt
' * @return the list of all of the dependent specs for the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllDependentSpecs (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-dependent-specs " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-dependent-specs " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllDependentSpecsInMt = MsgIn
End Function

'---------------- getSampleLeafSpecs ----------------
Public Function getSampleLeafSpecs(cycFort As String, numberOfSamples As Integer) As String

'
' /**
' * Gets the list with the specified number of sample specs of the given CycFort collection.
' * Attempts to return leaves that are maximally differet with regard to their all-genls.
' *
' * @param cycFort the given collection
' * @param numberOfSamples the maximum number of sample specs returned
' * @return the list with the specified number of sample specs of the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSampleLeafSpecs (CycFort cycFort, int numberOfSamples)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (sample-leaf-specs " + cycFort.stringApiValue() + " " + numberOfSamples + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (sample-leaf-specs " + cycFort + " " + numberOfSamples + "))"
Reply$ = Direct(Command$)
getSampleLeafSpecs = MsgIn
End Function

'---------------- getSampleLeafSpecsInMt ----------------
Public Function getSampleLeafSpecsInMt(cycFort As String, numberOfSamples As Integer, Mt As String) As String

'
' /**
' * Gets the list with the specified number of sample specs of the given CycFort collection.
' * Attempts to return leaves that are maximally differet with regard to their all-genls.
' *
' * @param cycFort the given collection
' * @param numberOfSamples the maximum number of sample specs returned
' * @param mt the relevant mt
' * @return the list with the specified number of sample specs of the given CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getSampleLeafSpecs (CycFort cycFort, int numberOfSamples, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(sample-leaf-specs " + cycFort.stringApiValue() + " " + numberOfSamples +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(sample-leaf-specs " + cycFort + " " + numberOfSamples + " " + Mt + ")"
Reply$ = Direct(Command$)
getSampleLeafSpecsInMt = MsgIn
End Function

'---------------- isGenlOf ----------------
Public Function isGenlOf(genl As String, spec As String) As Boolean

'
' /**
' * Returns true if CycFort GENL is a genl of CycFort SPEC.
' *
' * @param genl the collection for genl determination
' * @param spec the collection for spec determination
' * @return <tt>true</tt> if CycFort GENL is a genl of CycFort SPEC
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlOf (CycFort genl, CycFort spec)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(genl-in-any-mt? " + spec.stringApiValue() + " " + genl.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl-in-any-mt? " + spec + " " + genl + ")"
Reply$ = Direct(Command$)
isGenlOf = CheckTrue(MsgIn)
End Function

'---------------- isGenlOfInMt ----------------
Public Function isGenlOfInMt(genl As String, spec As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort GENL is a genl of CycFort SPEC in MT.
' *
' * @param genl the collection for genl determination
' * @param spec the collection for spec determination
' * @param mt the microtheory for spec determination
' * @return <tt>true</tt> if CycFort GENL is a genl of CycFort SPEC in MT
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlOf (CycFort genl, CycFort spec, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(genl? " + spec.stringApiValue() +
' " " + genl.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl? " + spec + " " + genl + " " + Mt + ")"
Reply$ = Direct(Command$)
isGenlOfInMt = CheckTrue(MsgIn)
End Function

'---------------- isGenlPredOfInMt ----------------
Public Function isGenlPredOfInMt(genlPred As String, specPred As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort GENLPRED is a genl-pred of CycFort SPECPRED in MT.
' *
' * @param genlPred the predicate for genl-pred determination
' * @param specPred the predicate for spec-pred determination
' * @param mt the microtheory for subsumption determination
' * @return <tt>true</tt> if CycFort GENLPRED is a genl-pred of CycFort SPECPRED in MT
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlPredOf (CycFort genlPred, CycFort specPred, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(genl-predicate? " + specPred.stringApiValue() +
' " " + genlPred.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl-predicate? " + specPred + " " + genlPred + " " + Mt + ")"
Reply$ = Direct(Command$)
isGenlPredOfInMt = CheckTrue(MsgIn)
End Function

'---------------- isGenlPredOf ----------------
Public Function isGenlPredOf(genlPred As String, specPred As String) As Boolean

'
' /**
' * Returns true if CycFort GENLPRED is a genl-pred of CycFort SPECPRED in any MT.
' *
' * @param genlPred the predicate for genl-pred determination
' * @param specPred the predicate for spec-pred determination
' * @return <tt>true</tt> if CycFort GENLPRED is a genl-pred of CycFort SPECPRED
' * in any MT
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlPredOf (CycFort genlPred, CycFort specPred)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (genl-predicate? " + specPred.stringApiValue() +
' " " + genlPred.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (genl-predicate? " + specPred + " " + genlPred + "))"
Reply$ = Direct(Command$)
isGenlPredOf = CheckTrue(MsgIn)
End Function

'---------------- isGenlInverseOfInMt ----------------
Public Function isGenlInverseOfInMt(genlPred As String, specPred As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort GENLPRED is a genl-inverse of CycFort SPECPRED in MT.
' *
' * @param genlPred the predicate for genl-inverse determination
' * @param specPred the predicate for spec-inverse determination
' * @param mt the microtheory for inverse subsumption determination
' * @return <tt>true</tt> if CycFort GENLPRED is a genl-inverse of CycFort SPECPRED in MT
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlInverseOf (CycFort genlPred, CycFort specPred, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(genl-inverse? " + specPred.stringApiValue() +
' " " + genlPred.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl-inverse? " + specPred + " " + genlPred + " " + Mt + ")"
Reply$ = Direct(Command$)
isGenlInverseOfInMt = CheckTrue(MsgIn)
End Function

'---------------- isGenlInverseOf ----------------
Public Function isGenlInverseOf(genlPred As String, specPred As String) As Boolean

'
' /**
' * Returns true if CycFort GENLPRED is a genl-inverse of CycFort SPECPRED in any MT.
' *
' * @param genlPred the predicate for genl-inverse determination
' * @param specPred the predicate for spec-inverse determination
' * @return <tt>true</tt> if CycFort GENLPRED is a genl-inverse of CycFort SPECPRED
' * in any MT
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlInverseOf (CycFort genlPred, CycFort specPred)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (genl-inverse? " + specPred.stringApiValue() +
' " " + genlPred.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (genl-inverse? " + specPred + " " + genlPred + "))"
Reply$ = Direct(Command$)
isGenlInverseOf = CheckTrue(MsgIn)
End Function

'---------------- isGenlMtOf ----------------
Public Function isGenlMtOf(genlMt As String, specMt As String) As Boolean

'
' /**
' * Returns true if CycFort GENLMT is a genl-mt of CycFort SPECPRED in *mt-mt*
' * (currently #$UniversalVocabularyMt).
' *
' * @param genlMt the microtheory for genl-mt determination
' * @param specMt the microtheory for spec-mt determination
' * @return <tt>true</tt> if CycFort GENLMT is a genl-mt of CycFort SPECPRED in *mt-mt*
' * (currently #$UniversalVocabularyMt)
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isGenlMtOf (CycFort genlMt, CycFort specMt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(genl-mt? " + specMt.stringApiValue() +
' " " + genlMt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(genl-mt? " + specMt + " " + genlMt + ")"
Reply$ = Direct(Command$)
isGenlMtOf = CheckTrue(MsgIn)
End Function

'---------------- areTacitCoextensional ----------------
Public Function areTacitCoextensional(collection1 As String, collection2 As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are tacitly coextensional
' * via mutual genls of each other.
' *
' * @param collection1 the first given collection
' * @param collection2 the second given collection
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are tacitly coextensional
' * via mutual genls of each other, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areTacitCoextensional (CycFort collection1, CycFort collection2)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (tacit-coextensional? " + collection1.stringApiValue() + " " + collection2.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (tacit-coextensional? " + collection1 + " " + collection2 + "))"
Reply$ = Direct(Command$)
areTacitCoextensional = CheckTrue(MsgIn)
End Function

'---------------- areTacitCoextensionalInMt ----------------
Public Function areTacitCoextensionalInMt(collection1 As String, collection2 As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are tacitly coextensional
' * via mutual genls of each other.
' *
' * @param collection1 the first given collection
' * @param collection2 the second given collection
' * @param mt the relevant mt
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are tacitly coextensional
' * via mutual genls of each other, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areTacitCoextensional (CycFort collection1, CycFort collection2, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(tacit-coextensional? " + collection1.stringApiValue() +
' " " + collection2.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(tacit-coextensional? " + collection1 + " " + collection2 + " " + Mt + ")"
Reply$ = Direct(Command$)
areTacitCoextensionalInMt = CheckTrue(MsgIn)
End Function

'---------------- areIntersecting ----------------
Public Function areIntersecting(collection1 As String, collection2 As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 intersect with regard to all-specs.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 intersect with regard to all-specs
' * otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areIntersecting (CycFort collection1, CycFort collection2)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (collections-intersect? " + collection1.stringApiValue() + " " +
' collection2.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (collections-intersect? " + collection1 + " " + collection2 + "))"
Reply$ = Direct(Command$)
areIntersecting = CheckTrue(MsgIn)
End Function

'---------------- areIntersectingInMt ----------------
Public Function areIntersectingInMt(collection1 As String, collection2 As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 intersect with regard to all-specs.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @param mt the relevant mt
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 intersect with regard to all-specs
' * otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areIntersecting (CycFort collection1, CycFort collection2, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(collections-intersect? " + collection1.stringApiValue() + " " +
' collection2.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(collections-intersect? " + collection1 + " " + collection2 + " " + Mt + ")"
Reply$ = Direct(Command$)
areIntersectingInMt = CheckTrue(MsgIn)
End Function

'---------------- areHierarchical ----------------
Public Function areHierarchical(collection1 As String, collection2 As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are in a hierarchy.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are in a hierarchy,
' * otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areHierarchical (CycFort collection1, CycFort collection2)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (hierarchical-collections? " + collection1.stringApiValue() +
' " " + collection2.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (hierarchical-collections? " + collection1 + " " + collection2 + "))"
Reply$ = Direct(Command$)
areHierarchical = CheckTrue(MsgIn)
End Function

'---------------- areHierarchicalInMt ----------------
Public Function areHierarchicalInMt(collection1 As String, collection2 As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are in a hierarchy.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @param mt the relevant mt
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are in a hierarchy,
' * otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areHierarchical (CycFort collection1, CycFort collection2, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(hierarchical-collections? " + collection1.stringApiValue() +
' collection2.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(hierarchical-collections? " + collection1 + collection2 + " " + Mt + ")"
Reply$ = Direct(Command$)
areHierarchicalInMt = CheckTrue(MsgIn)
End Function

'---------------- getWhyGenl ----------------
Public Function getWhyGenl(spec As String, genl As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort SPEC is a SPEC of CycFort GENL.
' * getWhyGenl("Dog", "Animal") -->
' * "(((#$genls #$Dog #$CanineAnimal) :TRUE)
' *    (#$genls #$CanineAnimal #$NonPersonAnimal) :TRUE)
' *    (#$genls #$NonPersonAnimal #$Animal) :TRUE))
' *
' * @param spec the specialized collection
' * @param genl the more general collection
' * @result the list of the justifications of why CycFort SPEC is a SPEC of CycFort GENL
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyGenl (CycFort spec, CycFort genl)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (why-genl? " + spec.stringApiValue() + " " + genl.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (why-genl? " + spec + " " + genl + "))"
Reply$ = Direct(Command$)
getWhyGenl = MsgIn
End Function

'---------------- getWhyGenlInMt ----------------
Public Function getWhyGenlInMt(spec As String, genl As String, Mt As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort SPEC is a SPEC of CycFort GENL.
' * getWhyGenl("Dog", "Animal") -->
' * "(((#$genls #$Dog #$CanineAnimal) :TRUE)
' *    (#$genls #$CanineAnimal #$NonPersonAnimal) :TRUE)
' *    (#$genls #$NonPersonAnimal #$Animal) :TRUE))
' *
' * @param spec the specialized collection
' * @param genl the more general collection
' * @param mt the relevant mt
' * @result the list of the justifications of why CycFort SPEC is a SPEC of CycFort GENL
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyGenl (CycFort spec, CycFort genl, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(why-genl? " + spec.stringApiValue() + " " + genl.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(why-genl? " + spec + " " + genl + " " + Mt + ")"
Reply$ = Direct(Command$)
getWhyGenlInMt = MsgIn
End Function

'---------------- getWhyCollectionsIntersect ----------------
Public Function getWhyCollectionsIntersect(collection1 As String, collection2 As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort COLLECTION1 and a CycFort COLLECTION2 intersect.
' * see getWhyGenl
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @return the list of the justifications of why CycFort COLLECTION1 and a CycFort COLLECTION2 intersect
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyCollectionsIntersect (CycFort collection1, CycFort collection2)
' CycFort collection2)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (why-collections-intersect? " +
' collection1.stringApiValue() + " " + collection2.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (why-collections-intersect? " + collection1 + " " + collection2 + "))"
AskCyc (Command$)
getWhyCollectionsIntersect = MsgIn
End Function

'---------------- getWhyCollectionsIntersectInMt ----------------
Public Function getWhyCollectionsIntersectInMt(collection1 As String, collection2 As String, Mt As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort COLLECTION1 and a CycFort COLLECTION2 intersect.
' * see getWhyGenl
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @param mt the relevant mt
' * @return the list of the justifications of why CycFort COLLECTION1 and a CycFort COLLECTION2 intersect
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyCollectionsIntersect (CycFort collection1, CycFort collection2, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(why-collections-intersect? " +
' collection1.stringApiValue() + " " + collection2.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(why-collections-intersect? " + collection1 + " " + collection2 + " " + Mt + ")"
AskCyc (Command$)
getWhyCollectionsIntersectInMt = MsgIn
End Function

'---------------- getCollectionLeaves ----------------
Public Function getCollectionLeaves(cycFort As String) As String

'
' /**
' * Gets the list of the collection leaves (most specific of the all-specs) for a CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the collection leaves (most specific of the all-specs) for a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getCollectionLeaves (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (collection-leaves " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (collection-leaves " + cycFort + "))"
Reply$ = Direct(Command$)
getCollectionLeaves = MsgIn
End Function

'---------------- getCollectionLeavesInMt ----------------
Public Function getCollectionLeavesInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the collection leaves (most specific of the all-specs) for a CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the relevant mt
' * @return the list of the collection leaves (most specific of the all-specs) for a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getCollectionLeaves (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(collection-leaves " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(collection-leaves " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getCollectionLeavesInMt = MsgIn
End Function

'---------------- getLocalDisjointWith ----------------
Public Function getLocalDisjointWith(cycFort As String) As String

'
' /**
' * Gets the list of the collections asserted to be disjoint with a CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the collections asserted to be disjoint with a CycFort collection
' */
' public CycList getLocalDisjointWith (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (local-disjoint-with " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (local-disjoint-with " + cycFort + "))"
Reply$ = Direct(Command$)
getLocalDisjointWith = MsgIn
End Function

'---------------- getLocalDisjointWithInMt ----------------
Public Function getLocalDisjointWithInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the collections asserted to be disjoint with a CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the relevant mt
' * @return the list of the collections asserted to be disjoint with a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getLocalDisjointWith (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(local-disjoint-with " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(local-disjoint-with " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getLocalDisjointWithInMt = MsgIn
End Function

'---------------- areDisjoint ----------------
Public Function areDisjoint(collection1 As String, collection2 As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are disjoint.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are disjoint, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areDisjoint (CycFort collection1, CycFort collection2)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (disjoint-with? " + collection1.stringApiValue() + " " + collection2.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (disjoint-with? " + collection1 + " " + collection2 + "))"
Reply$ = Direct(Command$)
areDisjoint = CheckTrue(MsgIn)
End Function

'---------------- areDisjointInMt ----------------
Public Function areDisjointInMt(collection1 As String, collection2 As String, Mt As String) As Boolean

'
' /**
' * Returns true if CycFort COLLECION1 and CycFort COLLECTION2 are disjoint.
' *
' * @param collection1 the first collection
' * @param collection2 the second collection
' * @param mt the relevant mt
' * @return true if CycFort COLLECION1 and CycFort COLLECTION2 are disjoint, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean areDisjoint (CycFort collection1, CycFort collection2, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(with-all-mts (disjoint-with? " + collection1.stringApiValue() +
' " " + collection2.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (disjoint-with? " + collection1 + " " + collection2 + " " + Mt + ")"
Reply$ = Direct(Command$)
areDisjointInMt = CheckTrue(MsgIn)
End Function

'---------------- getMinIsas ----------------
Public Function getMinIsas(cycFort As String) As String

'
' /**
' * Gets the list of the most specific collections (having no subsets) which contain a CycFort term.
' *
' * @param cycFort the given term
' * @return the list of the most specific collections (having no subsets) which contain a CycFort term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMinIsas (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (min-isa " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (min-isa " + cycFort + "))"
Reply$ = Direct(Command$)
getMinIsas = MsgIn
End Function

'---------------- getMinIsasInMt ----------------
Public Function getMinIsasInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the most specific collections (having no subsets) which contain a CycFort term.
' *
' * @param cycFort the given term
' * @param mt the relevant mt
' * @return the list of the most specific collections (having no subsets) which contain a CycFort term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getMinIsas (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(min-isa " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(min-isa " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getMinIsasInMt = MsgIn
End Function

'---------------- getInstances ----------------
Public Function getInstances(cycFort As String) As String

'
' /**
' * Gets the list of the instances (who are individuals) of a CycFort collection.
' *
' * @param cycFort the given collection
' * @return the list of the instances (who are individuals) of a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getInstances (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (instances " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (instances " + cycFort + "))"
Reply$ = Direct(Command$)
getInstances = MsgIn
End Function

'---------------- getInstancesInMt ----------------
Public Function getInstancesInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the instances (who are individuals) of a CycFort collection.
' *
' * @param cycFort the given collection
' * @param mt the relevant mt
' * @return the list of the instances (who are individuals) of a CycFort collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getInstances (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(instances " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(instances " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getInstancesInMt = MsgIn
End Function

'---------------- getInstanceSiblings ----------------
Public Function getInstanceSiblings(cycFort As String) As String

'
' /**
' * Gets the list of the instance siblings of a CycFort, for all collections of which
' * it is an instance.
' *
' * @param cycFort the given term
' * @return the list of the instance siblings of a CycFort, for all collections of which
' * it is an instance
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getInstanceSiblings (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (instance-siblings " + cycFort.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (instance-siblings " + cycFort + "))"
Reply$ = Direct(Command$)
getInstanceSiblings = MsgIn
End Function

'---------------- getInstanceSiblingsInMt ----------------
Public Function getInstanceSiblingsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the instance siblings of a CycFort, for all collections of which
' * it is an instance.
' *
' * @param cycFort the given term
' * @param mt the relevant mt
' * @return the list of the instance siblings of a CycFort, for all collections of which
' * it is an instance
' */
' public CycList getInstanceSiblings (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(instance-siblings " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(instance-siblings " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getInstanceSiblingsInMt = MsgIn
End Function

'---------------- getAllIsa ----------------
Public Function getAllIsa(cycFort As String) As String

'
' /**
' * Gets the list of the collections of which the CycFort is directly and indirectly an instance.
' *
' * @param cycFort the given term
' * @return the list of the collections of which the CycFort is directly and indirectly an instance
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllIsa (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-isa-in-any-mt " + cycFort.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-isa-in-any-mt " + cycFort + ")"
Reply$ = Direct(Command$)
getAllIsa = MsgIn
End Function

'---------------- getAllIsaInMt ----------------
Public Function getAllIsaInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of the collections of which the CycFort is directly and indirectly an instance.
' *
' * @param cycFort the given term
' * @param mt the relevant mt
' * @return the list of the collections of which the CycFort is directly and indirectly an instance
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllIsa (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-isa " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-isa " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllIsaInMt = MsgIn
End Function

'---------------- getAllInstances ----------------
Public Function getAllInstances(cycFort As String) As String

'
' /**
' * Gets a list of all the direct and indirect instances (individuals) for a CycFort
' * collection.
' *
' * @param cycFort the collection for which all the direct and indirect instances
' * (individuals) are sought
' * @return the list of all the direct and indirect instances (individuals) for the
' * given collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllInstances (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-instances-in-all-mts " + cycFort.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-instances-in-all-mts " + cycFort + ")"
Reply$ = Direct(Command$)
getAllInstances = MsgIn
End Function

'---------------- getAllInstancesInMt ----------------
Public Function getAllInstancesInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets a list of all the direct and indirect instances (individuals) for a CycFort
' * collection in the given microtheory.
' *
' * @param cycFort the collection for which all the direct and indirect instances
' * (individuals) are sought
' * @param mt the relevant mt
' * @return the list of all the direct and indirect instances (individuals) for the
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' * given collection
' */
' public CycList getAllInstances (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-instances " + cycFort.stringApiValue()
' + " " + mt.stringApiValue()+ ")");
' }
Dim Command$, Reply$
Command$ = "(all-instances " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllInstancesInMt = MsgIn
End Function

'---------------- isa ----------------
Public Function isa(term As String, collection As String) As Boolean

'
' /**
' * Returns true if CycFort TERM is a instance of CycFort COLLECTION, defaulting to all microtheories.
' *
' * @param term the term
' * @param collection the collection
' * @return <tt>true</tt> if CycFort TERM is a instance of CycFort COLLECTION
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isa (CycFort term, CycFort collection)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + term.stringApiValue() + " " + collection.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + term + " " + collection + ")"
Reply$ = Direct(Command$)
isa = CheckTrue(MsgIn)
End Function

'---------------- isaInMt ----------------
Public Function isaInMt(term As String, collection As String, Mt As String) As Boolean

' /**
' * Returns true if CycFort TERM is a instance of CycFort COLLECTION, using the given microtheory.
' * Method implementation optimised for the binary api.
' *
' * @param term the term
' * @param collection the collection
' * @param mt the microtheory in which the ask is performed
' * @return <tt>true</tt> if CycFort TERM is a instance of CycFort COLLECTION
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isa (CycFort term, CycFort collection, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("isa?"));
' command.add(term.cycListApiValue());
' command.add(collection.cycListApiValue());
' command.add(mt.cycListApiValue());
' return converseBoolean(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(isa? " + term + " " + collection + " " + Mt + ")"

Reply$ = Direct(Command$)
isaInMt = CheckTrue(MsgIn)
End Function

'---------------- getWhyIsa ----------------
Public Function getWhyIsa(spec As String, genl As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort TERM is an instance of CycFort COLLECTION.
' * getWhyIsa("Brazil", "Country") -->
' * "(((#$isa #$Brazil #$IndependentCountry) :TRUE)
' *    (#$genls #$IndependentCountry #$Country) :TRUE))
' *
' * @param spec the specialized collection
' * @param genl the more general collection
' * @return the list of the justifications of why CycFort TERM is an instance of CycFort COLLECTION
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyIsa (CycFort spec, CycFort genl)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (why-isa? " + spec.stringApiValue() + " " + genl.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (why-isa? " + spec + " " + genl + "))"
Reply$ = Direct(Command$)
getWhyIsa = MsgIn
End Function

'---------------- getWhyIsaInMt ----------------
Public Function getWhyIsaInMt(spec As String, genl As String, Mt As String) As String

'
' /**
' * Gets the list of the justifications of why CycFort TERM is an instance of CycFort COLLECTION.
' * getWhyIsa("Brazil", "Country") -->
' * "(((#$isa #$Brazil #$IndependentCountry) :TRUE)
' *    (#$genls #$IndependentCountry #$Country) :TRUE))
' *
' * @param spec the specialized collection
' * @param genl the more general collection
' * @param mt the relevant mt
' * @return the list of the justifications of why CycFort TERM is an instance of CycFort COLLECTION
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getWhyIsa (CycFort spec, CycFort genl, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(why-isa? " + spec.stringApiValue() + " " + genl.stringApiValue() +
' " " + mt.stringApiValue()+ ")");
' }
Dim Command$, Reply$
Command$ = "(why-isa? " + spec + " " + genl + " " + Mt + ")"
Reply$ = Direct(Command$)
getWhyIsaInMt = MsgIn
End Function

'---------------- getGenlPreds ----------------
Public Function getGenlPreds(predicate As String) As String

'
' /**
' * Gets the list of the genlPreds for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @result the list of the more general predicates for the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenlPreds (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (genl-predicates " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (genl-predicates " + predicate + ")))"
Reply$ = Direct(Command$)
getGenlPreds = MsgIn
End Function

'---------------- getGenlPredsInMt ----------------
Public Function getGenlPredsInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the genlPreds for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @param mt the relevant mt
' * @result the list of the more general predicates for the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getGenlPreds (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(genl-predicates " + predicate.stringApiValue() +
' " " + mt.stringApiValue()+ ")");
' }
Dim Command$, Reply$
Command$ = "(genl-predicates " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getGenlPredsInMt = MsgIn
End Function

'---------------- getAllGenlPreds ----------------
Public Function getAllGenlPreds(predicate As String) As String

'
' /**
' * Gets the list of all of the genlPreds for a CycConstant predicate, using an upward closure.
' *
' * @parameter predicate the predicate for which all the genlPreds are obtained
' * @return a list of all of the genlPreds for a CycConstant predicate, using an upward closure
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenlPreds (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-genl-predicates " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-genl-predicates " + predicate + ")))"
Reply$ = Direct(Command$)
getAllGenlPreds = MsgIn
End Function

'---------------- getAllGenlPredsInMt ----------------
Public Function getAllGenlPredsInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of all of the genlPreds for a CycConstant predicate, using an upward closure.
' *
' * @parameter predicate the predicate for which all the genlPreds are obtained
' * @param mt the relevant mt
' * @return a list of all of the genlPreds for a CycConstant predicate, using an upward closure
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllGenlPreds (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-genl-predicates " + predicate.stringApiValue() +
' " " + mt.stringApiValue()+ ")");
' }
Dim Command$, Reply$
Command$ = "(all-genl-predicates " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllGenlPredsInMt = MsgIn
End Function

'---------------- getAllSpecPreds ----------------
Public Function getAllSpecPreds(cycFort As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs-preds for the given predicate
' * in all microtheories.
' *
' * @param cycFort the predicate
' * @return the list of all of the direct and indirect spec-preds for the given predicate
' * in all microtheories.
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecPreds (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-spec-predicates " +
' cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-spec-predicates " + cycFort + ")))"
Reply$ = Direct(Command$)
getAllSpecPreds = MsgIn
End Function

'---------------- getAllSpecPredsInMt ----------------
Public Function getAllSpecPredsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs-preds for the given predicate
' * in the given microtheory.
' *
' * @param cycFort the predicate
' * @param mt the microtheory
' * @return the list of all of the direct and indirect spec-preds for the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecPreds (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-spec-predicates " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-spec-predicates " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllSpecPredsInMt = MsgIn
End Function

'---------------- getAllSpecInverses ----------------
Public Function getAllSpecInverses(cycFort As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs-inverses for the given predicate
' * in all microtheories.
' *
' * @param cycFort the predicate
' * @return the list of all of the direct and indirect spec-inverses for the given predicate
' * in all microtheories.
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecInverses (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (all-spec-inverses " +
' cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (all-spec-inverses " + cycFort + ")))"
Reply$ = Direct(Command$)
getAllSpecInverses = MsgIn
End Function

'---------------- getAllSpecInversesInMt ----------------
Public Function getAllSpecInversesInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs-inverses for the given predicate
' * in the given microtheory.
' *
' * @param cycFort the predicate
' * @param mt the microtheory
' * @return the list of all of the direct and indirect spec-inverses for the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecInverses (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-spec-inverses " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-spec-inverses " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getAllSpecInversesInMt = MsgIn
End Function

'---------------- getAllSpecMtsInMt ----------------
Public Function getAllSpecMtsInMt(Mt As String) As String

'
' /**
' * Gets the list of all of the direct and indirect specs-mts for the given microtheory
' * in *mt-mt* (currently #$UniversalVocabularyMt).
' *
' * @param mt the microtheory
' * @return the list of all of the direct and indirect specs-mts for the given microtheory
' * in *mt-mt* (currently #$UniversalVocabularyMt)
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getAllSpecMts (CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(all-spec-mts " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(all-spec-mts " + Mt + ")"
Reply$ = Direct(Command$)
getAllSpecMtsInMt = MsgIn
End Function

'---------------- getArg1Isas ----------------
Public Function getArg1Isas(predicate As String) As String

'
' /**
' * Gets a list of the arg1Isas for a CycConstant predicate.
' *
' * @param predicate the predicate for which argument 1 contraints are sought.
' * @return the list of the arg1Isas for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg1Isas (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (arg1-isa " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (arg1-isa " + predicate + ")))"
Reply$ = Direct(Command$)
getArg1Isas = MsgIn
End Function

'---------------- getArg1IsasInMt ----------------
Public Function getArg1IsasInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the arg1Isas for a CycConstant predicate given an mt.
' *
' * @param predicate the predicate for which argument 1 contraints are sought.
' * @param mt the relevant microtheory
' * @return the list of the arg1Isas for a CycConstant predicate given an mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg1Isas (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg1-isa " + predicate.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg1-isa " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg1IsasInMt = MsgIn
End Function

'---------------- getArg2Isas ----------------
Public Function getArg2Isas(predicate As String) As String

'
' /**
' * Gets a list of the arg2Isas for a CycConstant predicate.
' *
' * @param predicate the predicate for which argument 2 contraints are sought.
' * @return the list of the arg1Isas for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg2Isas (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (arg2-isa " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (arg2-isa " + predicate + ")))"
Reply$ = Direct(Command$)
getArg2Isas = MsgIn
End Function

'---------------- getArg2IsasInMt ----------------
Public Function getArg2IsasInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the arg2Isas for a CycConstant predicate given an mt.
' *
' * @param predicate the predicate for which argument 2 contraints are sought.
' * @param mt the relevant microtheory
' * @return the list of the arg2Isas for a CycConstant predicate given an mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg2Isas (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg2-isa " + predicate.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg2-isa " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg2IsasInMt = MsgIn
End Function

'---------------- getArg3Isas ----------------
Public Function getArg3Isas(predicate As String) As String

'
' /**
' * Gets a list of the arg3Isas for a CycConstant predicate.
' *
' * @param predicate the predicate for which argument 3 contraints are sought.
' * @return the list of the arg1Isas for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg3Isas (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (arg3-isa " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (arg3-isa " + predicate + ")))"
Reply$ = Direct(Command$)
getArg3Isas = MsgIn
End Function

'---------------- getArg3IsasInMt ----------------
Public Function getArg3IsasInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the arg3Isas for a CycConstant predicate given an mt.
' *
' * @param predicate the predicate for which argument 3 contraints are sought.
' * @param mt the relevant microtheory
' * @return the list of the arg1Isas for a CycConstant predicate given an mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg3Isas (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg3-isa " + predicate.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg3-isa " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg3IsasInMt = MsgIn
End Function

'---------------- getArg4Isas ----------------
Public Function getArg4Isas(predicate As String) As String

'
' /**
' * Gets a list of the arg4Isas for a CycConstant predicate.
' *
' * @param predicate the predicate for which argument 4 contraints are sought.
' * @return the list of the arg4Isas for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg4Isas (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (arg4-isa " + predicate.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (arg4-isa " + predicate + ")))"
Reply$ = Direct(Command$)
getArg4Isas = MsgIn
End Function

'---------------- getArg4IsasInMt ----------------
Public Function getArg4IsasInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the arg4Isas for a CycConstant predicate given an mt.
' *
' * @param predicate the predicate for which argument 4 contraints are sought.
' * @param mt the relevant microtheory
' * @return the list of the arg4Isas for a CycConstant predicate given an mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg4Isas (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg4-isa " + predicate.stringApiValue() + " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg4-isa " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg4IsasInMt = MsgIn
End Function

'---------------- getArgNIsas ----------------
Public Function getArgNIsas(predicate As String, argPosition As Integer) As String

'
' /**
' * Gets a list of the argNIsas for a CycConstant predicate.
' *
' * @param predicate the predicate for which argument N contraints are sought.
' * @param argPosition the argument position of argument N
' * @return the list of the argNIsas for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArgNIsas (CycConstant predicate, int argPosition)
' throws IOException, UnknownHostException, CycApiException {
' String command =
' "(remove-duplicates \n" +
' "  (with-all-mts \n" +
' "    (argn-isa " + predicate.stringApiValue() + " " + Integer.toString(argPosition) + ")))";
' return converseList(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(remove-duplicates " + vbCr + _
            "  (with-all-mts " + vbCr + _
            "    (argn-isa " + predicate + " " + Str$(argPosition) + ")))"

Reply$ = Direct(Command$)
getArgNIsas = MsgIn
End Function

'---------------- getArgNIsasInMt ----------------
Public Function getArgNIsasInMt(predicate As String, argPosition As Integer, Mt As String) As String

'
' /**
' * Gets the list of the argNIsas for a CycConstant predicate given an mt.
' *
' * @param predicate the predicate for which argument contraints are sought.
' * @param argPosition the argument position of argument N
' * @param mt the relevant microtheory
' * @return the list of the arg1Isas for a CycConstant predicate given an mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArgNIsas (CycConstant predicate, int argPosition, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' String command =
' "(remove-duplicates \n" +
' "  (with-all-mts \n" +
' "    (argn-isa \n" +
' "      " + predicate.stringApiValue() +
' "      " + Integer.toString(argPosition) +
' "      " + mt.stringApiValue() + ")))";
' return converseList(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(remove-duplicates " + _
           "  (with-all-mts" + _
           "    (argn-isa" + _
           "      " + predicate + _
           "      " + Str$(argPosition) + _
           "      " + Mt + ")))"

Reply$ = Direct(Command$)
getArgNIsasInMt = MsgIn
End Function

'---------------- getInterArgIsa1_2s ----------------
Public Function getInterArgIsa1_2s(predicate As String) As String

'
' /**
' * Gets the list of the interArgIsa1-2 isa constraint pairs for
' * the given predicate.  Each item of the returned list is a pair
' * (arg1-isa arg2-isa) which means that when (#$isa arg1 arg1-isa) holds, * (#$isa arg2 arg2-isa) must also hold for (predicate arg1 arg2 ..) to
' * (#$isa arg2 arg2-isa) must also hold for (predicate arg1 arg2 ..) to
' * be well formed.
' *
' * @param predicate the predicate for interArgIsa1-2 contraints are sought.
' * @return the list of the interArgIsa1-2 isa constraint pairs for
' * the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getInterArgIsa1_2s (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' String command =
' "(remove-duplicates \n" +
' "  (with-all-mts \n" +
' "    (inter-arg-isa1-2 " + predicate.stringApiValue() + ")))";
' return converseList(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(remove-duplicates " + vbCr + _
            "  (with-all-mts " + vbCr + _
            "    (inter-arg-isa1-2 " + predicate + ")))"
            
Reply$ = Direct(Command$)
getInterArgIsa1_2s = MsgIn
End Function

'---------------- getInterArgIsa1_2sInMt ----------------
Public Function getInterArgIsa1_2sInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets the list of the interArgIsa1-2 isa constraint pairs for
' * the given predicate.  Each item of the returned list is a pair
' * (arg1-isa arg2-isa) which means that when (#$isa arg1 arg1-isa) holds, * (#$isa arg2 arg2-isa) must also hold for (predicate arg1 arg2 ..) to
' * (#$isa arg2 arg2-isa) must also hold for (predicate arg1 arg2 ..) to
' * be well formed.
' *
' * @param predicate the predicate for interArgIsa1-2 contraints are sought.
' * @param mt the relevant inference microtheory
' * @return the list of the interArgIsa1-2 isa constraint pairs for
' * the given predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getInterArgIsa1_2s (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' String command =
' "(remove-duplicates \n" +
' "  (with-all-mts \n" +
' "    (inter-arg-isa1-2 " +
' "      " + predicate.stringApiValue() +
' "      " + mt.stringApiValue() + ")))";
' return converseList(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(remove-duplicates " + vbCr + _
            "  (with-all-mts " + vbCr + _
            "    (inter-arg-isa1-2 " + _
            "      " + predicate + _
            "      " + Mt + ")))"
Reply$ = Direct(Command$)
getInterArgIsa1_2sInMt = MsgIn
End Function

'---------------- getResultIsas ----------------
Public Function getResultIsas(cfunction As String) As String

'
' /**
' * Gets the list of the resultIsa for a CycConstant function.
' *
' * @param function the given function term
' * @return the list of the resultIsa for a CycConstant function
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getResultIsas (CycConstant function)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (result-isa " + function.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (result-isa " + cfunction + ")))"
Reply$ = Direct(Command$)
getResultIsas = MsgIn
End Function

'---------------- getResultIsasInMt ----------------
Public Function getResultIsasInMt(cfunction As String, Mt As String) As String

'
' /**
' * Gets the list of the resultIsa for a CycConstant function.
' *
' * @param function the given function term
' * @param mt the relevant mt
' * @return the list of the resultIsa for a CycConstant function
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getResultIsas (CycConstant function, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(result-isa " + function.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(result-isa " + cfunction + " " + Mt + ")"
Reply$ = Direct(Command$)
getResultIsasInMt = MsgIn
End Function

'---------------- getArgNGenls ----------------
Public Function getArgNGenls(predicate As String, argPosition As Integer) As String

'
' /**
' * Gets the list of the argNGenls for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @param argPosition the argument position for which the genls argument
' * constraints are sought (position 1 = first argument)
' * @return the list of the argNGenls for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArgNGenls (CycConstant predicate, int argPosition)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (argn-genl " + predicate.stringApiValue() +
' " " + argPosition + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (argn-genl " + predicate + " " + argPosition + ")))"
Reply$ = Direct(Command$)
getArgNGenls = MsgIn
End Function

'---------------- getArgNGenlsInMt ----------------
Public Function getArgNGenlsInMt(predicate As String, argPosition As Integer, Mt As String) As String

'
' /**
' * Gets the list of the argNGenls for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @param argPosition the argument position for which the genls argument
' * constraints are sought (position 1 = first argument)
' * @param mt the relevant mt
' * @return the list of the argNGenls for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArgNGenls (CycConstant predicate, int argPosition, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(argn-genl " + predicate.stringApiValue() +
' " " + argPosition +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(argn-genl " + predicate + " " + argPosition + " " + Mt + ")"
Reply$ = Direct(Command$)
getArgNGenlsInMt = MsgIn
End Function

'---------------- getArg1Formats ----------------
Public Function getArg1Formats(predicate As String) As String

'
' /**
' * Gets a list of the arg1Formats for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @return a list of the arg1Formats for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg1Formats (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (arg1-format " + predicate.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (arg1-format " + predicate + "))"
Reply$ = Direct(Command$)
getArg1Formats = MsgIn
End Function

'---------------- getArg1FormatsInMt ----------------
Public Function getArg1FormatsInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets a list of the arg1Formats for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @param mt the relevant mt
' * @return a list of the arg1Formats for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg1Formats (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg1-format " + predicate.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg1-format " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg1FormatsInMt = MsgIn
End Function

'---------------- getArg2Formats ----------------
Public Function getArg2Formats(predicate As String) As String

'
' /**
' * Gets a list of the arg2Formats for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @return a list of the arg2Formats for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg2Formats (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(with-all-mts (arg2-format " + predicate.stringApiValue() + "))");
' }
Dim Command$, Reply$
Command$ = "(with-all-mts (arg2-format " + predicate + "))"
Reply$ = Direct(Command$)
getArg2Formats = MsgIn
End Function

'---------------- getArg2FormatsInMt ----------------
Public Function getArg2FormatsInMt(predicate As String, Mt As String) As String

'
' /**
' * Gets a list of the arg2Formats for a CycConstant predicate.
' *
' * @param predicate the given predicate term
' * @param mt the relevant mt
' * @return a list of the arg2Formats for a CycConstant predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getArg2Formats (CycConstant predicate, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(arg2-format " + predicate.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(arg2-format " + predicate + " " + Mt + ")"
Reply$ = Direct(Command$)
getArg2FormatsInMt = MsgIn
End Function

'---------------- getDisjointWiths ----------------
Public Function getDisjointWiths(cycFort As String) As String

'
' /**
' * Gets a list of the disjointWiths for a CycFort.
' *
' * @param cycFort the given collection term
' * @return a list of the disjointWiths for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getDisjointWiths (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(remove-duplicates (with-all-mts (local-disjoint-with " + cycFort.stringApiValue() + ")))");
' }
Dim Command$, Reply$
Command$ = "(remove-duplicates (with-all-mts (local-disjoint-with " + cycFort + ")))"
Reply$ = Direct(Command$)
getDisjointWiths = MsgIn
End Function

'---------------- getDisjointWithsInMt ----------------
Public Function getDisjointWithsInMt(cycFort As String, Mt As String) As String

'
' /**
' * Gets a list of the disjointWiths for a CycFort.
' *
' * @param cycFort the given collection term
' * @param mt the relevant mt
' * @return a list of the disjointWiths for a CycFort
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getDisjointWiths (CycFort cycFort, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(local-disjoint-with " + cycFort.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(local-disjoint-with " + cycFort + " " + Mt + ")"
Reply$ = Direct(Command$)
getDisjointWithsInMt = MsgIn
End Function

'---------------- isMicrotheory ----------------
Public Function isMicrotheory(cycFort As String) As Boolean

'
' /**
' * Returns true if cycConstant is a microtheory.
' *
' * @param cycConstant the constant for determination as a microtheory
' * @return <tt>true</tt> iff cycConstant is a microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isMicrotheory (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycFort.stringApiValue() + " #$Microtheory)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + cycFort + " #$Microtheory)"
Reply$ = Direct(Command$)
isMicrotheory = CheckTrue(MsgIn)
End Function

'---------------- isCollection ----------------
Public Function isCollection(cycFort As String) As Boolean

'
' /**
' * Returns true if cycConstant is a Collection.
' *
' * @param cycConstant the constant for determination as a Collection
' * @return <tt>true</tt> iff cycConstant is a Collection,
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isCollection (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycFort.stringApiValue() + " #$Collection)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + cycFort + " #$Collection)"
Reply$ = Direct(Command$)
isCollection = CheckTrue(MsgIn)
End Function

'---------------- isIndividual ----------------
Public Function isIndividual(cycFort As String) As Boolean

'
' /**
' * Returns true if cycConstant is an Individual.
' *
' * @param cycFort the given term
' * @return true if cycConstant is an Individual
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isIndividual (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycFort.stringApiValue() + " #$Individual)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + cycFort + " #$Individual)"
Reply$ = Direct(Command$)
isIndividual = CheckTrue(MsgIn)
End Function

'---------------- isFunction ----------------
Public Function isFunction(CycConstant As String) As Boolean

'
' /**
' * Returns true if cycConstant is a Function.
' *
' * @param cycConstant the given term
' * @return true if cycConstant is a Function, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isFunction (CycConstant cycConstant)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycConstant.stringApiValue() + " #$Function-Denotational)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + CycConstant + " #$Function-Denotational)"
Reply$ = Direct(Command$)
isFunction = CheckTrue(MsgIn)
End Function

'---------------- isEvaluatablePredicate ----------------
Public Function isEvaluatablePredicate(predicate As String) As Boolean

'
' /**
' * Returns true if cycConstant is an evaluatable predicate.
' *
' * @param predicate the given term
' * @return true if cycConstant is an evaluatable predicate, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isEvaluatablePredicate (CycConstant predicate)
' throws IOException, UnknownHostException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("with-all-mts"));
' CycList command1 = new CycList();
' command.add(command1);
' command1.add(CycObjectFactory.makeCycSymbol("evaluatable-predicate?"));
' command1.add(predicate);
' return converseBoolean(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(with-all-mts (evaluatable-predicate?" + predicate + "))"

Reply$ = Direct(Command$)
isEvaluatablePredicate = CheckTrue(MsgIn)
End Function

'---------------- isPredicate ----------------
Public Function isPredicate(cycFort As String) As Boolean

'
' /**
' * Returns true if cycFort is a Predicate.
' *
' * @param cycFort the term for determination as a predicate
' * @return true if cycFort is a Predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isPredicate (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' if (cycFort instanceof CycNart)
' return false;
' else
' return converseBoolean("(isa-in-any-mt? " + cycFort.stringApiValue() + " #$Predicate)");
' }
Dim Command$, Reply$

'**** Need test to check if instance of CycNart ****
Command$ = "(isa-in-any-mt? " + cycFort + " #$Predicate)"
Reply$ = Direct(Command$)
isPredicate = CheckTrue(MsgIn)
End Function

'---------------- isUnaryPredicate ----------------
Public Function isUnaryPredicate(CycConstant As String) As Boolean

'
' /**
' * Returns true if cycConstant is a UnaryPredicate.
' *
' * @param cycConstant the given term
' * @return true if cycConstant is a UnaryPredicate, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isUnaryPredicate (CycConstant cycConstant)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycConstant.stringApiValue() + " #$UnaryPredicate)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + CycConstant + " #$UnaryPredicate)"
Reply$ = Direct(Command$)
isUnaryPredicate = CheckTrue(MsgIn)
End Function

'---------------- isBinaryPredicate ----------------
Public Function isBinaryPredicate(CycConstant As String) As Boolean

'
' /**
' * Returns true if cycConstant is a BinaryPredicate.
' *
' * @param cycConstant the given term
' * @return true if cycConstant is a BinaryPredicate, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isBinaryPredicate (CycConstant cycConstant)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycConstant.stringApiValue() + " #$BinaryPredicate)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + CycConstant + " #$BinaryPredicate)"
Reply$ = Direct(Command$)
isBinaryPredicate = CheckTrue(MsgIn)
End Function

'---------------- isValidConstantName ----------------
Public Function isValidConstantName(candidateName As String) As Boolean

'
' /**
' * Returns true if the candidate name uses valid CycConstant characters.
' *
' * @param candidateName the candidate name
' * @return true if the candidate name uses valid CycConstant characters
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isValidConstantName (String candidateName)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(new-constant-name-spec-p \"" + candidateName + "\")");
' }
Dim Command$, Reply$
Command$ = "(new-constant-name-spec-p \"" + candidateName + " \ ")"
Reply$ = Direct(Command$)
isValidConstantName = CheckTrue(MsgIn)
End Function

'---------------- isConstantNameAvailable ----------------
Public Function isConstantNameAvailable(candidateName As String) As Boolean

'
' /**
' * Returns true if the candidate name is an available CycConstant name, case insensitive.
' *
' * @param candidateName the candidate name
' * @return true if the candidate name uses valid CycConstant characters
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isConstantNameAvailable (String candidateName)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(constant-name-available \"" + candidateName + "\")");
' }
Dim Command$, Reply$
Command$ = "(constant-name-available \"" + candidateName + " \ ")"
Reply$ = Direct(Command$)
isConstantNameAvailable = CheckTrue(MsgIn)
End Function

'---------------- isPublicConstant ----------------
Public Function isPublicConstant(CycConstant As String) As Boolean

'
' /**
' * Returns true if cycConstant is a PublicConstant.
' *
' * @param cycConstant the given constant
' * @return true if cycConstant is a PublicConstant
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isPublicConstant (CycConstant cycConstant)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(isa-in-any-mt? " + cycConstant.stringApiValue() + " #$PublicConstant)");
' }
Dim Command$, Reply$
Command$ = "(isa-in-any-mt? " + CycConstant + " #$PublicConstant)"
Reply$ = Direct(Command$)
isPublicConstant = CheckTrue(MsgIn)
End Function

'---------------- getKbSubset ----------------
Public Function getKbSubset(cycKbSubsetCollection As String) As String

'
' /**
' * Gets a list of the elements of the given CycKBSubsetCollection.
' *
' * @param cycKbSubsetCollection the given CycKBSubsetCollection
' * @return a list of the elements of the given CycKBSubsetCollection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList getKbSubset (CycFort cycKbSubsetCollection)
' throws IOException, UnknownHostException, CycApiException {
' return converseList("(ask-template '?X '(#$isa ?X " +
' cycKbSubsetCollection.stringApiValue() +
' ") #$EverythingPSC)");
' }
Dim Command$, Reply$
Command$ = "(ask-template '?X '(#$isa ?X " + cycKbSubsetCollection + ") #$EverythingPSC)"
Reply$ = Direct(Command$)
getKbSubset = MsgIn
End Function

Public Sub assertWithTranscript(sentence As String, Mt As String)

'  /**
'     * Asserts the given sentence, and then places it on
'     * the transcript queue.
'     *
'     * @param sentence the given sentence for assertion
'     * @param mt the microtheory in which the assertion is placed
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     */
'    public void assertWithTranscript (String sentence, CycFort mt)
'        throws IOException, UnknownHostException, CycApiException {
'        String projectName = "nil";
'        if (project != null)
'            projectName = project.stringApiValue();
'        String cyclistName = "nil";
'        if (cyclist != null)
'            cyclistName = cyclist.stringApiValue();
'        String command =
'            "(clet ((*the-cyclist* " + cyclistName + ")\n" +
'            "       (*ke-purpose* " + projectName + "))\n" +
'            "  (ke-assert-now\n" +
'            "    '" + sentence + "\n" +
'            "    " + mt.cyclify() + "))";
'        converseVoid(command);
'    }
Dim projectName As String
Dim cyclistName As String
Dim Command$, Reply$

projectName = "nil"
If strprojectName <> "" Then projectName = strprojectName
cyclistName = "nil"
If strcyclistName <> "" Then cyclistName = strcyclistName
Command$ = Command$ + "(clet ((*the-cyclist* " + cyclistName + ")" + vbCr
Command$ = Command$ + "       (*ke-purpose* " + projectName + "))" + vbCr
Command$ = Command$ + "  (ke-assert-now" + vbCr
Command$ = Command$ + "    '" + sentence + "" + vbCr
Command$ = Command$ + "    " + Mt + "))"
Reply$ = Direct(Command$)

End Sub

'---------------- assertWithTranscriptInMt ----------------
Public Sub assertWithTranscriptInMt(sentence As String, Mt As String)

'
' /**
' * Asserts the given sentence, and then places it on
' * the transcript queue.
' *
' * @param sentence the given sentence for assertion
' * @param mt the microtheory in which the assertion is placed
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertWithTranscript (CycList sentence, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertWithTranscript(sentence.cyclify(), mt);
' }

assertWithTranscript sentence, Mt

End Sub



'---------------- assertWithTranscriptAndBookkeepingInMt ----------------
Public Sub assertWithTranscriptAndBookkeeping(sentence As String, Mt As String)

'
' /**
' * Asserts the given sentence, and then places it on
' * the transcript queue.
' *
' * @param sentence the given sentence for assertion
' * @param mt the microtheory in which the assertion is placed
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertWithTranscriptAndBookkeeping (CycList sentence, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertWithTranscript(sentence.cyclify(), mt);
' }
assertWithTranscriptInMt sentence, Mt
End Sub

'---------------- assertWithTranscriptAndBookkeepingInMt ----------------
Public Sub assertWithTranscriptAndBookkeepingInMt(sentence As String, Mt As String)

'
' /**
' * Asserts the given sentence, and then places it on
' * the transcript queue.
' *
' * @param sentence the given sentence for assertion
' * @param mt the microtheory in which the assertion is placed
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertWithTranscriptAndBookkeeping (String sentence, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' String projectName = "nil";
' if (project != null)
' projectName = project.stringApiValue();
' String cyclistName = "nil";
' if (cyclist != null)
' cyclistName = cyclist.stringApiValue();
' String command =
' "(with-bookkeeping-info \n" +
' "  (new-bookkeeping-info " + cyclistName + " (the-date) " + projectName + "(the-second))\n" +
' "  (clet ((*the-cyclist* " + cyclistName + ")\n" +
' "         (*ke-purpose* " + projectName + "))\n" +
' "    (ke-assert-now\n" +
' "      '" + sentence + "\n" +
' "      " + mt.cyclify() + ")))";
' converseVoid(command);
' }
Dim projectName As String
Dim cyclistName As String
Dim Command$, Reply$

projectName = "nil"
If strprojectName <> "" Then projectName = strprojectName
cyclistName = "nil"
If strcyclistName <> "" Then cyclistName = strcyclistName

Command$ = Command$ + "(with-bookkeeping-info " + vbCr
Command$ = Command$ + "  (new-bookkeeping-info " + cyclistName + " (the-date) " + projectName + "(the-second))" + vbCr
Command$ = Command$ + "  (clet ((*the-cyclist* " + cyclistName + ")" + vbCr
Command$ = Command$ + "         (*ke-purpose* " + projectName + "))" + vbCr
Command$ = Command$ + "    (ke-assert-now" + vbCr
Command$ = Command$ + "      '" + sentence + vbCr
Command$ = Command$ + "      " + Mt + ")))"

Reply$ = Direct(Command$)
End Sub


'---------------- assertWithTranscriptAndBookkeepingInMt ----------------
Public Sub assertWithTranscriptAndBookkeepingInMt3(sentence As String, Mt As String)

' /**
' * Asserts the given sentence, and then places it on
' * the transcript queue.
' * @param sentence the given sentence for assertion
' * @param mt the microtheory in which the assertion is placed
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' "  (clet ((*the-cyclist* " + cyclistName + ")\n" +
' "         (*ke-purpose* " + projectName + "))\n" +
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(with-bookkeeping-info " + vbCr + _
            "  (new-bookkeeping-info " + strcyclistName + " (the-date) " + strprojectName + " (the-second))" + vbCr + _
            "  (clet ((*the-cyclist* " + strcyclistName + ")" + vbCr + _
            "         (*ke-purpose* " + strprojectName + "))" + vbCr + _
            "    (ke-assert-now" + vbCr + _
            "      '" + sentence + "" + vbCr + _
            "      " + Mt + ")))"
 
Reply$ = Direct(Command$)
' assertWithTranscriptAndBookkeepingInMt = MsgIn
End Sub
Public Sub assertGaf(ByVal Mt As String, ByVal predicate As String, ByVal arg1 As String, ByVal arg2 As String)

'    /**
'     * Asserts a ground atomic formula (gaf) in the specified microtheory MT.  The operation
'     * will be added to the KB transcript for replication and archive.
'     *
'     * @param mt the microtheory in which the assertion is made
'     * @param predicate the binary predicate of the assertion
'     * @param arg1 the first argument of the predicate
' '    * @param arg2 the second argument of the predicate, which is a string
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     */
'    public void assertGaf (CycFort mt,
'                           CycFort predicate,
'                           CycFort arg1,
'                           String arg2)
'        throws IOException, UnknownHostException, CycApiException {
'        // (predicate <CycFort> <String>)
'        String sentence =
'            "(" + predicate.cyclify() + " " +
'            arg1.cyclify() + " \"" +
'            arg2 + "\")";
'        assertWithTranscriptAndBookkeeping(sentence, mt);
'    }
Dim sentence As String
sentence = "(" + predicate + " " + arg1 + " " + arg2 + ")"
assertWithTranscriptAndBookkeepingInMt sentence, Mt

End Sub

'*** NON FUNCTIONAL ****:Need getCycConstantCacheByName
    Public Function getConstantByNamex(constantName As String) As String
'
'     * Gets a CycConstant by using its constant name.
'     *
'     * @param constantName the name of the constant to be instantiated
'     * @return the complete <tt>CycConstant</tt> if found, otherwise return null
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     */
'    public CycConstant getConstantByName (String constantName)
'        throws IOException, UnknownHostException, CycApiException {
'        String name = constantName;
'        if (constantName.startsWith("#$"))
'            name = name.substring(2);
'        CycConstant answer = CycObjectFactory.getCycConstantCacheByName(name);
'        if (answer != null)
'            return answer;
'        answer = new CycConstant();
'        answer.setName(name);
'        Integer id = getConstantId(name);
'        if (id == null)
'            return null;
'        answer.setId(id);
'        answer.setGuid(getConstantGuid(name));
'        CycObjectFactory.addCycConstantCacheByName(answer);
'        CycObjectFactory.addCycConstantCacheById(answer);
'        return answer;
'    }
 Dim Name As String
 Dim Answer As String
 Name = constantName
 If Left$(constantName, 2) = "#$" Then Name = Mid$(Name, 3)
 
 Answer = getCycConstantCacheByName(Name)
 If Answer <> "" Then getConstantByNamex = Answer
 '*****> INSERT CODE HERE <******
 
    End Function

Public Function makeCycConstant(Name As String) As String

'---------------- makeCycConstant ------------------------------
'/**
'     * Returns a new <tt>CycConstant</tt> object using the constant name,
'    * recording bookkeeping information and archiving to the Cyc transcript.
'     *
'     * @param name Name of the constant. If prefixed with "#$", then the prefix is
'     * removed for canonical representation.
'     * @return a new <tt>CycConstant</tt> object using the constant name,
'     * recording bookkeeping information and archiving to the Cyc transcript
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     */
'    public CycConstant makeCycConstant(String name)
'        throws UnknownHostException, IOException, CycApiException {
'        String constantName = name;
'        if (constantName.startsWith("#$"))
'            constantName = constantName.substring(2);
'        CycConstant cycConstant = this.getConstantByName(name);
'        if (cycConstant != null)
'            return cycConstant;
'        String projectName = "nil";
'        if (project != null)
'            projectName = project.stringApiValue();
'        String cyclistName = "nil";
'        if (cyclist != null)
'            cyclistName = cyclist.stringApiValue();
'        String command =
'            withBookkeepingInfo() +
'            "(clet ((*require-case-insensitive-name-uniqueness* nil)\n" +
'            "       (*the-cyclist* " + cyclistName + ")\n" +
'            "       (*ke-purpose* " + projectName + "))\n" +
'            "  (ke-create-now \"" + constantName + "\")))";
'        Object object = converseObject(command);
'        if (object instanceof CycConstant)
'            cycConstant = (CycConstant) object;
'        Else
'            throw new CycApiException("Cannot create new constant for " + name);
'        cycConstant.getName();
'        cycConstant.getGuid();
'        CycObjectFactory.addCycConstantCacheByName(cycConstant);
'        CycObjectFactory.addCycConstantCacheById(cycConstant);
'        return cycConstant;
'    }
Dim constantName As String
Dim CycConstant As String
Dim Obj$
Dim projectName As String
Dim Command$

constantName = Name
If Left$(constantName, 2) = "#$" Then constantName = Mid$(constantName, 3)
CycConstant = getConstantByName(Name)
If CycConstant <> "" Then makeCycConstant = CycConstant: Exit Function
projectName = "nil"
If strprojectName <> "" Then projectName = strprojectName
cyclistName = "nil"
If strcyclistName <> "" Then cyclistName = strcyclistName
Command$ = withBookkeepingInfo()
Command$ = Command$ + "(clet ((*require-case-insensitive-name-uniqueness* nil)\n"
Command$ = Command$ + "       (*the-cyclist* " + cyclistName + ")" + vbCr
Command$ = Command$ + "       (*ke-purpose* " + projectName + "))" + vbCr
Command$ = Command$ + "  (ke-create-now """" + constantName + """")))"
Obj$ = Direct(Command$)
makeCycConstant = Obj$
End Function


'---------------- CycConstant createNewPermanent ----------------
Public Function createNewPermanent(constantName As String) As String

'
' /**
' * Creates a new permanent Cyc constant in the KB with the specified name.  The operation
' * will be added to the KB transcript for replication and archive.
' *
' * @param constantName the name of the new constant
' * @return the new constant term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycConstant createNewPermanent (String constantName)
' throws IOException, UnknownHostException, CycApiException {
' return makeCycConstant(constantName);
' }

createNewPermanent = makeCycConstant(constantName)

End Function


'---------------- assertGafInMt ----------------
Public Sub assertGafInMt(Mt As String, predicate As String, arg1 As String, arg2 As String, arg3 As String)

'
' /**
' * Asserts a ground atomic formula (gaf) in the specified microtheory MT.
' * The operation and its bookkeeping info will be added to the KB transcript
' * for replication and archive.
' *
' * @param mt the microtheory in which the assertion is made
' * @param predicate the ternary predicate of the assertion
' * @param arg1 the first argument of the predicate
' * @param arg2 the second argument of the predicate
' * @param arg3 the third argument of the predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGaf (CycFort mt, CycConstant predicate, CycFort arg1, CycFort arg3)
' throws IOException, UnknownHostException, CycApiException {
' // (predicate <CycFort> <CycFort> <CycFort>)
' String sentence =
' "(" + predicate.cyclify() + " " +
' arg1.cyclify() + " " +
' arg2.cyclify() + " " +
' arg3.cyclify() + ")";
' assertWithTranscriptAndBookkeeping(sentence, mt);
' }
Dim sentence As String

sentence = "( " + predicate + " " + arg1 + " " + arg2 + " " + arg3 + " )"
assertWithTranscriptAndBookkeeping sentence, Mt

End Sub

'---------------- assertGafInMt ----------------
Public Sub assertGafInMt2(gaf As String, Mt As String)

'
'
' /**
' * Asserts a ground atomic formula (gaf) in the specified microtheory MT.  The operation
' * will be added to the KB transcript for replication and archive.
' *
' * @param gaf the gaf in the form of a CycList
' * @param mt the microtheory in which the assertion is made
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGaf (CycList gaf, CycFort mt)
' CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertWithTranscriptAndBookkeeping(gaf, mt);
' }
assertWithTranscriptAndBookkeeping gaf, Mt
End Sub
Function withBookkeepingInfo() As String
'    /**
'     * Returns a with-bookkeeping-info macro expresssion.
'     *
'     * @return a with-bookkeeping-info macro expresssion
'     */
'    protected String withBookkeepingInfo () {
'        String projectName = "nil";
'        if (project != null)
'            projectName = project.stringApiValue();
'        String cyclistName = "nil";
'        if (cyclist != null)
'            cyclistName = cyclist.stringApiValue();
'        return "(with-bookkeeping-info (new-bookkeeping-info " +
'            cyclistName + " (the-date) " +
'            projectName + "(the-second)) ";
'    }
Dim projectName As String
Dim cyclistName As String

projectName = "nil"
If strprojectName <> "" Then projectName = strprojectName
cyclistName = "nil"
If strcyclistName <> "" Then cyclistName = strcyclistName
withBookkeepingInfo = "(with-bokeepinginfo (new-bookeeping-info " + cyclistName + " (the-date) " + projectName + "(the-second)) "

End Function
'---------------- unassertGafInMt ----------------
Public Sub unassertGafInMt(gaf As String, Mt As String)

'
' /**
' * Unasserts the given ground atomic formula (gaf) in the specified microtheory MT.
' *
' * @param gaf the gaf in the form of a CycList
' * @param mt the microtheory in which the assertion is made
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void unassertGaf (CycList gaf, CycFort mt)
' CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' String command = withBookkeepingInfo() +
' "(ke-unassert-now '" +
' gaf.stringApiValue() +
' mt.stringApiValue() + "))";
' converseVoid(command);
' }
Dim Command$, Reply$

Command$ = withBookkeepingInfo() + " (ke-unassert-now '" + gaf + " " + Mt + "))"
Reply$ = Direct(Command$)
' unassertGafInMt = MsgIn
End Sub

'---------------- assertNameStringInMt ----------------
Public Sub assertNameInMt(cycConstantNameString As String, nameString As String, mtName As String)

'
' /**
' * Assert a nameString for the specified CycConstant in the specified lexical microtheory.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycConstantName the name of the given term
' * @param nameString the given name string for the term
' * @param mtName the name of the microtheory in which the name string is asserted
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertNameString (String cycConstantName, String nameString, String mtName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(getKnownConstantByName(mtName), getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"),
' getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"), getKnownConstantByName(cycConstantName),
' getKnownConstantByName(cycConstantName), nameString);
' nameString);
' }
Call assertGaf(getKnownConstantByName(mtName), getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"), getKnownConstantByName(cycConstantNameString), nameString)

End Sub

'---------------- assertCommentInMt ----------------
Public Sub assertCommentInMt(cycConstantName As String, comment As String, mtName As String)

'
' /**
' * Assert a comment for the specified CycConstant in the specified microtheory MT.  The operation
' * will be added to the KB transcript for replication and archive.
' *
' * @param cycConstantName the name of the given term
' * @param comment the comment string
' * @param mtName the name of the microtheory in which the comment is asserted
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertComment (String cycConstantName, String comment, String mtName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(getKnownConstantByName(mtName), CycAccess.comment, getKnownConstantByName(cycConstantName),
' comment);
' }
'*****> INSERT CODE HERE <*****
Call assertGaf(getKnownConstantByName(mtName), Comment_const, getKnownConstantByName(cycConstantName), comment)
End Sub
'Comment
'---------------- assertCommentInMt ----------------
Public Sub assertCommentInMt2(cycFort As String, comment As String, Mt As String)

'
' /**
' * Assert a comment for the specified CycFort in the specified microtheory.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the given term
' * @param comment the comment string
' * @param mt the comment assertion microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertComment (CycFort cycFort, String comment, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(mt, CycAccess.comment, cycFort, comment);
' }
Call assertGaf(Mt, Comment_const, cycFort, comment)
End Sub

'---------------- assertNameStringInMt ----------------
Public Sub assertNameInMt2(cycFortString As String, nameString As String, Mt As String)

'
' /**
' * Assert a name string for the specified CycFort in the specified microtheory.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the given term
' * @param nameString the name string
' * @param mt the name string assertion microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertNameString (CycFort cycFort, String nameString, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(mt, this.getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"),
' this.getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"), cycFort, nameString);
' }
assertGafInMt Mt, getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"), getKnownConstantByGuid("c0fdf7e8-9c29-11b1-9dad-c379636f7270"), cycFortString, nameString
End Sub
'**** NON FUNCTIONAL
'---------------- assertGenFormat ----------------
Public Sub assertGenFormat(relation As String, genFormatString As String, genFormatList As String)

'
' /**
' * Assert a paraphrase format for the specified CycFort in the #$EnglishParaphraseMt.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given term
' * @param genFormatString the genFormat string
' * @param genFormatList the genFormat argument substitution sequence
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenFormat (CycFort relation, String genFormatString, CycList genFormatList)
' throws IOException, UnknownHostException, CycApiException {
' // (#$genFormat <relation> <genFormatString> <genFormatList>)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("beed06de-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(genFormatString);
' if (genFormatList.size() == 0)
' sentence.add(CycObjectFactory.nil);
' else
' sentence.add(genFormatList);
' assertGaf(sentence, // #$EnglishParaphraseMt getKnownConstantByGuid("bda16220-9c29-11b1-9dad-c379636f7270"));
' }
Dim Command$, Reply$
'assertGaf(sentence, // #$EnglishParaphraseMt getKnownConstantByGuid("bda16220-9c29-11b1-9dad-c379636f7270")
Reply$ = Direct(Command$)
' assertGenFormat = MsgIn
End Sub
'**** NON FUNCTIONAL
'---------------- CycConstant createMicrotheoryInMt ----------------
Public Function createMicrotheoryInMt(mtName As String, comment As String, isaMt As String, genlMts As String) As String

'
' /**
' * Create a microtheory MT, with a comment, isa <mt type> and CycFort genlMts.
' * An existing microtheory with
' * the same name is killed first, if it exists.
' *
' * @param mtName the name of the microtheory term
' * @param comment the comment for the new microtheory
' * @param isMt the type of the new microtheory
' * @param genlMts the list of more general microtheories
' * @return the new microtheory term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycConstant createMicrotheory (String mtName, String comment, CycFort isaMt, genlMts)
' throws IOException, UnknownHostException, CycApiException {
' CycConstant mt = getConstantByName(mtName);
' if (mt != null) {
' kill(mt);
' }
'        mt = createNewPermanent(mtName);
'        assertComment(mt, comment, baseKB);
'        assertGaf(universalVocabularyMt, isa, mt, isaMt);
'        Iterator iterator = genlMts.iterator();
'        while (true) {
'            if (! iterator.hasNext())
'                break;
'            CycFort aGenlMt = (CycFort) iterator.next();
'            assertGaf(universalVocabularyMt, genlMt, mt, aGenlMt);
'        }
'    return mt;
'   }

Dim Mt As String
Dim aGenlMt As String
Dim delims As String

Mt = createNewPermanet(mtName)
assertCommentInMt Mt, comment, "#$BaseKB"
delims = " "
aGenlMt = strtok(genlMts, delims)
While aGenlMt <> vbNullString
    If Left$(aGenlMt, 2) <> "#$" Then aGenlMt = "#$" + aGenlMt
    assertGaf "#$UniversalVocabularyMt", genlMt_const, Mt, aGenlMt
    aGenlMt = strtok(vbNullString, delims)
Wend
createMicrotheoryInMt = Mt
End Function

'---------------- CycConstant[] createMicrotheorySystemInMt ----------------
Public Function createMicrotheorySystemInMt(mtRootName As String, comment As String, genlMts As String) As Integer

'
' /**
' * Create a microtheory system for a new mt.  Given a root mt name, create a theory <Root>Mt,
' * create a vocabulary <Root>VocabMt, and a data <Root>DataMt.  Establish genlMt links for the
' * theory mt and data mt.  Assert that the theory mt is a genlMt of the WorldLikeOursCollectorMt.
' * Assert that the data mt is a genlMt of the collector CurrentWorldDataMt.
' *
' * @param mtRootName the root name of the microtheory system
' * @param comment the root comment of the microtheory system
' * @param genlMts the list of more general microtheories
' * @return an array of three elements consisting of the theory mt, vocabulary mt,
' * and the data mt
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycConstant[] createMicrotheorySystem (String mtRootName, String comment, ArrayList genlMts)
' throws IOException, UnknownHostException, CycApiException {
' //traceOn();
' CycConstant[] mts = {null, null, null};
' String theoryMtName = mtRootName + "Mt";
' String vocabMtName = mtRootName + "VocabMt";
' String vocabMtComment = "The #$VocabularyMicrotheory for #$"+ theoryMtName;
' String dataMtName = mtRootName + "DataMt";
' String dataMtComment = "The #$DataMicrotheory for #$"+ theoryMtName;
'
' CycConstant worldLikeOursMt = getKnownConstantByGuid("bf4c781d-9c29-11b1-9dad-c379636f7270");
' CycConstant currentWorldDataMt = getKnownConstantByGuid("bf192b1e-9c29-11b1-9dad-c379636f7270");
'        CycConstant genlMt_Vocabulary = getKnownConstantByGuid("c054a49e-9c29-11b1-9dad-c379636f7270");'
'
' CycConstant theoryMicrotheory = getKnownConstantByGuid("be5275a8-9c29-11b1-9dad-c379636f7270");
'        CycConstant theoryMt = createMicrotheory(theoryMtName,
'                                                 comment,
'                                                 theoryMicrotheory,
'                                                 genlMts);
'        CycConstant vocabularyMicrotheory =
'            getKnownConstantByGuid("bda19dfd-9c29-11b1-9dad-c379636f7270");
'        CycConstant vocabMt = createMicrotheory(vocabMtName,
'                                                vocabMtComment,
'                                                vocabularyMicrotheory,
'                                                new ArrayList());
'        CycConstant dataMicrotheory = getKnownConstantByGuid("be5275a8-9c29-11b1-9dad-c379636f7270");
'        CycConstant dataMt = createMicrotheory(dataMtName,
'                                               dataMtComment,
'                                               dataMicrotheory,
'                                               new ArrayList());
' mts[0] = theoryMt;
' mts[1] = vocabMt;
' mts[2] = dataMt;
' //traceOff();
' return mts;
' }
Dim mts(3) As String
Dim theoryMtName As String
Dim vocabMtName As String
Dim vocabMtComment As String
Dim dataMtName As String
Dim dataMtComment As String
Dim worldLikeOursMt As String
Dim currentWorldDataMt As String
Dim genlMt_Vocabulary As String
Dim theoryMicrotheory As String
Dim vocabularyMicrotheory As String
Dim dataMicrotheory As String
Dim dataMt As String
Dim theoryMt As String
Dim vocabMt As String

theoryMtName = mtRootName + "Mt"
vocabMtName = mtRootName + "VocabMt"
vocabMtComment = "The #$VocabularyMicrotheory for #$" + theoryMtName
dataMtName = mtRootName + "DataMt"
dataMtComment = "The #$DataMicrotheory for #$" + theoryMtName

worldLikeOursMt = getKnownConstantByGuid("bf4c781d-9c29-11b1-9dad-c379636f7270")
currentWorldDataMt = getKnownConstantByGuid("bf192b1e-9c29-11b1-9dad-c379636f7270")
genlMt_Vocabulary = getKnownConstantByGuid("c054a49e-9c29-11b1-9dad-c379636f7270")

theoryMicrotheory = getKnownConstantByGuid("be5275a8-9c29-11b1-9dad-c379636f7270")
theoryMt = createMicrotheoryInMt(theoryMtName, comment, theoryMicrotheory, genlMts)
vocabularyMicrotheory = getKnownConstantByGuid("bda19dfd-9c29-11b1-9dad-c379636f7270")
vocabMt = createMicrotheoryInMt(vocabMtName, vocabMtComment, vocabularyMicrotheory, "")
dataMicrotheory = getKnownConstantByGuid("be5275a8-9c29-11b1-9dad-c379636f7270")
dataMt = createMicrotheoryInMt(dataMtName, dataMtComment, dataMicrotheory, "")

End Function

'---------------- assertIsaCollection ----------------
Public Sub assertIsaCollection(cycFort As String)

'
' /**
' * Assert that the specified CycConstant is a collection in the UniversalVocabularyMt.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the given collection term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsaCollection (CycFort cycFort)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(universalVocabularyMt, isa, cycFort, collection);
' }

assertGaf universalVocabularyMt_const, isa_const, cycFort, collection_const

End Sub

'---------------- assertIsaCollectionInMt ----------------
Public Sub assertIsaCollectionInMt(cycFort As String, Mt As String)

'
' /**
' * Assert that the specified CycConstant is a collection in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the given collection term
' * @param mt the assertion microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsaCollection (CycFort cycFort, CycFort mt)
' CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(mt, isa, cycFort, collection);
' }

assertGaf Mt, isa_const, cycFort, collection_const

End Sub

'---------------- assertGenlsInMt ----------------
Public Sub assertGenlsInMt(specCollectionName As String, genlsCollectionName As String, mtName As String)

'
' /**
' * Assert that the genlsCollection is a genls of specCollection,
' * in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specCollectionName the name of the more specialized collection
' * @param genlsCollectionName the name of the more generalized collection
' * @param mtName the assertion microtheory name
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenls (String specCollectionName, String genlsCollectionName, String mtName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(getKnownConstantByName(mtName), genls, getKnownConstantByName(specCollectionName),
' getKnownConstantByName(genlsCollectionName));
' }

assertGaf getKnownConstantByName(mtName), genls_const, getKnownConstantByName(specCollectionName), getKnownConstantByName(genlsCollectionName)

End Sub

'---------------- assertGenls ----------------
Public Sub assertGenls2(specCollectionName As String, genlsCollectionName As String)

'
' /**
' * Assert that the genlsCollection is a genls of specCollection,
' * in the UniversalVocabularyMt
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specCollectionName the name of the more specialized collection
' * @param genlsCollectionName the name of the more generalized collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenls (String specCollectionName, String genlsCollectionName)
' String genlsCollectionName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(universalVocabularyMt, genls, getKnownConstantByName(specCollectionName),
' getKnownConstantByName(genlsCollectionName));
' }

assertGaf universalVocabularyMt_const, genls_const, getKnownConstantByName(specCollectionName), getKnownConstantByName(genlsCollectionName)

End Sub

'---------------- assertGenls ----------------
Public Sub assertGenls3(specCollection As String, genlsCollection As String)

'
' /**
' * Assert that the genlsCollection is a genls of specCollection,
' * in the UniveralVocabularyMt.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specCollection the more specialized collection
' * @param genlsCollection the more generalized collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenls (CycFort specCollection, CycFort genlsCollection)
' CycFort genlsCollection)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(universalVocabularyMt, genls, specCollection, genlsCollection);
' }

assertGaf universalVocabularyMt_const, genls_const, specCollection, genlsCollection

End Sub

'---------------- assertGenlsInMt ----------------
Public Sub assertGenlsInMt2(specCollection As String, genlsCollection As String, Mt As String)

'
' /**
' * Assert that the genlsCollection is a genls of specCollection,
' * in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specCollection the more specialized collection
' * @param genlsCollection the more generalized collection
' * @param mt the assertion microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenls (CycFort specCollection, CycFort genlsCollection, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(mt, genls, specCollection, genlsCollection);
' }

assertGaf Mt, genls_const, specCollection, genlsCollection

End Sub

'---------------- assertGenlPreds ----------------
Public Sub assertGenlPreds(specPredName As String, genlPredName As String)

'
' /**
' * Assert that the more general predicate is a genlPreds of the more specialized
' * predicate, asserted in the UniversalVocabularyMt
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specPredName the name of the more specialized predicate
' * @param genlPredName the name of the more generalized predicate
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertGenlPreds (String specPredName, String genlPredName)
' String genlPredName)
' throws IOException, UnknownHostException, CycApiException {
' CycConstant genlPreds =
' getKnownConstantByGuid("bd5b4951-9c29-11b1-9dad-c379636f7270");
' assertGaf(universalVocabularyMt, genlPreds, getKnownConstantByName(specPredName),
' getKnownConstantByName(genlPredName));
' }

assertGaf universalVocabularyMt_const, genlsPreds_const, getKnownConstantByName(specPredName), getKnownConstantByName(genlPredName)

End Sub

'---------------- assertConceptuallyRelated ----------------
Public Sub assertConceptuallyRelated(term1 As String, term2 As String, Mt As String)

' /**
'     * Assert that term1 is conceptually related to term2 in the specified microtheory.
' * The operation will be added to the KB transcript for replication and archive.
' *
'     * @param term1 the first symbol
'     * @param term2 the second symbol
'     * @param mt the microtheory in which the assertion is made
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
'    public void assertConceptuallyRelated (CycFort term1,
'                                           CycFort term2,
'                                           CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' CycConstant conceptuallyRelated =
' getKnownConstantByGuid("bd58803e-9c29-11b1-9dad-c379636f7270");
'        assertGaf(mt,
'                  conceptuallyRelated,
'                  term1,
'                  term2);
' }

assertGaf Mt, conceptuallyRelated_const, term1, term2

End Sub

'---------------- assertGenlMt ----------------
Public Sub assertGenlMt2(specMtName As String, genlsMtName As String)

'
' /**
' * Assert that the more general micortheory is a genlMt of the more specialized
' * microtheory, asserted in the UniversalVocabularyMt
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param specMtName the more specialized microtheory
' * @param genlMtName the more generalized microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
'        assertGaf(universalVocabularyMt,
'                  genlMt,
'                  getKnownConstantByName(specMtName),
'                  getKnownConstantByName(genlsMtName));
' }

assertGaf universalVocabularyMt_const, genlMt_const, getKnownConstantByName(specMtName), getKnownConstantByName(genlsMtName)

End Sub

'---------------- assertIsaInMt ----------------
Public Sub assertIsaInUniversalMt(cycFortName As String, collectionName As String)

'
' /**
' * Assert that the cycFort is a collection,
' * in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFortName the collection element name
' * @param collectionName the collection name
' * @param mtName the assertion microtheory name
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsa (String cycFortName, String collectionName, String mtName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(getKnownConstantByName(mtName), isa, getKnownConstantByName(cycFortName),
' getKnownConstantByName(collectionName));
' }

assertGaf universalVocabularyMt_const, isa_const, getKnownConstantByName(cycFortName), getKnownConstantByName(collectionName)

End Sub
'---------------- assertIsaInMt ----------------
Public Sub assertIsaInUniversalMt2(cycFortName As String, collectionName As String)

'
'    /**
'     * Assert that the cycFort is a collection in the UniversalVocabularyMt.
'     * The operation will be added to the KB transcript for replication and archive.
'     *
'     * @param cycFortName the collection element name
'     * @param collectionName the collection name
'     * @throws UnknownHostException if cyc server host not found on the network
'     * @throws IOException if a data communication error occurs
'     * @throws CycApiException if the api request results in a cyc server error
'     */
'    public void assertIsa (String cycFortName,
'                           String collectionName)
'        throws IOException, UnknownHostException, CycApiException {
'        assertGaf(universalVocabularyMt,
'                  isa,
'                  getKnownConstantByName(cycFortName),
'                  getKnownConstantByName(collectionName));
'   }

assertGaf universalVocabularyMt_const, isa_const, getKnownConstantByName(cycFortName), getKnownConstantByName(collectionName)

End Sub
'---------------- assertIsaInMt ----------------
Public Sub assertIsaInMt(cycFortName As String, collectionName As String, mtName As String)

'
' /**
' * Assert that the cycFort is a collection,
' * in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFortName the collection element name
' * @param collectionName the collection name
' * @param mtName the assertion microtheory name
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsa (String cycFortName, String collectionName, String mtName)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(getKnownConstantByName(mtName), isa, getKnownConstantByName(cycFortName),
' getKnownConstantByName(collectionName));
' }

assertGaf getKnownConstantByName(mtName), isa_const, getKnownConstantByName(cycFortName), getKnownConstantByName(collectionName)

End Sub

'---------------- assertIsaInMt ----------------
Public Sub assertIsaInMt2(cycFort As String, aCollection As String, Mt As String)

'
' /**
' * Assert that the cycFort is a collection,
' * in the specified defining microtheory MT.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the collection element
' * @param aCollecton the collection
' * @param mt the assertion microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsa (CycFort cycFort, CycFort aCollection, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(mt, isa, cycFort, aCollection);
' }

assertGaf Mt, isa_const, cycFort, aCollection

End Sub

'---------------- assertIsa ----------------
Public Sub assertIsa2(cycFort As String, aCollection As String)

'
' /**
' * Assert that the cycFort is a collection,
' * in the UniversalVocabularyMt.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the collection element
' * @param aCollecton the collection
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsa (CycFort cycFort, CycFort aCollection)
' CycFort aCollection)
' throws IOException, UnknownHostException, CycApiException {
' assertGaf(universalVocabularyMt, isa, cycFort, aCollection);
' }

assertGaf universalVocabularyMt_const, isa_const, cycFort, aCollection

End Sub


'---------------- assertIsaBinaryPredicate ----------------
Public Sub assertIsaBinaryPredicate(cycFort As String)

' /**
  '   * Assert that the specified CycConstant is a #$BinaryPredicate in the specified defining
  '   * microtheory.
  '   * The operation will be added to the KB transcript for replication and archive.
  '   *
  '   * @param cycFort the given term
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
  '  public void assertIsaBinaryPredicate (CycFort cycFort)
  '      throws IOException, UnknownHostException, CycApiException {
  '      assertIsa(cycFort, binaryPredicate, universalVocabularyMt);
  '  }
  assertIsaInMt cycFort, binaryPredicate_const, universalVocabularyMt_const
End Sub

'---------------- assertIsaBinaryPredicateInMt ----------------
Public Sub assertIsaBinaryPredicateInMt(cycFort As String, Mt As String)

'
' /**
' * Assert that the specified CycConstant is a #$BinaryPredicate in the specified defining
' * microtheory.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param cycFort the given term
' * @param mt the defining microtheory
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertIsaBinaryPredicate (CycFort cycFort, CycFort mt)
' CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' assertIsa(cycFort, binaryPredicate, mt);
' }

assertIsaInMt cycFort, binaryPredicate_const, Mt

End Sub

'---------------- askWithVariableInMt ----------------
Public Function askWithVariableInMt(query As String, CycVariable As String, Mt As String) As String

'
' /**
' * Returns a list of bindings for a query with a single unbound variable.
' *
' * @param query the query to be asked in the knowledge base
' * @param variable the single unbound variable in the query for which bindings are sought
' * @param mt the microtheory in which the query is asked
' * @return a list of bindings for the query
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList askWithVariable (CycList query, CycVariable variable, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' StringBuffer queryBuffer = new StringBuffer();
' queryBuffer.append("(clet ((*cache-inference-results* nil) ");
' queryBuffer.append("       (*compute-inference-results* nil) ");
' queryBuffer.append("       (*unique-inference-result-bindings* t) ");
' queryBuffer.append("       (*generate-readable-fi-results* nil)) ");
' queryBuffer.append("  (without-wff-semantics ");
' queryBuffer.append("    (ask-template '" + variable.stringApiValue() + " ");
' queryBuffer.append("                  '" + query.stringApiValue() + " ");
' queryBuffer.append("                  " + mt.stringApiValue() + " ");
' queryBuffer.append("                  0 nil nil nil)))");
' return converseList(queryBuffer.toString());
' }
Dim Command$, Reply$
Dim queryBuffer$
queryBuffer$ = queryBuffer$ + "(clet ((*cache-inference-results* nil) "
queryBuffer$ = queryBuffer$ + "       (*compute-inference-results* nil) "
queryBuffer$ = queryBuffer$ + "       (*unique-inference-result-bindings* t) "
queryBuffer$ = queryBuffer$ + "       (*generate-readable-fi-results* nil)) "
queryBuffer$ = queryBuffer$ + "  (without-wff-semantics "
queryBuffer$ = queryBuffer$ + "    (ask-template '" + CycVariable + " "
queryBuffer$ = queryBuffer$ + "                  '" + query + " "
queryBuffer$ = queryBuffer$ + "                  " + Mt + " "
queryBuffer$ = queryBuffer$ + "                  0 nil nil nil)))"

Command$ = queryBuffer
Reply$ = Direct(Command$)
askWithVariableInMt = MsgIn
End Function

'---------------- askWithVariablesInMt ----------------
Public Function askWithVariablesInMt(query As String, variables As String, Mt As String) As String

'
' /**
' * Returns a list of bindings for a query with unbound variables.
' *
' * @param query the query to be asked in the knowledge base
' * @param variables the list of unbound variables in the query for which bindings are sought
' * @param mt the microtheory in which the query is asked
' * @return a list of bindings for the query
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList askWithVariables (CycList query, ArrayList variables, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' StringBuffer queryBuffer = new StringBuffer();
' queryBuffer.append("(clet ((*cache-inference-results* nil) ");
' queryBuffer.append("       (*compute-inference-results* nil) ");
' queryBuffer.append("       (*unique-inference-result-bindings* t) ");
' queryBuffer.append("       (*generate-readable-fi-results* nil)) ");
' queryBuffer.append("  (without-wff-semantics ");
' queryBuffer.append("    (ask-template '" + (new CycList(variables)).stringApiValue() + " ");
' queryBuffer.append("                  '" + query.stringApiValue() + " ");
' queryBuffer.append("                  " + mt.stringApiValue() + " ");
' queryBuffer.append("                  0 nil nil nil)))");
' return converseList(queryBuffer.toString());
' }
Dim Command$, Reply$
Dim queryBuffer$
queryBuffer$ = queryBuffer$ + "(clet ((*cache-inference-results* nil) "
queryBuffer$ = queryBuffer$ + "       (*compute-inference-results* nil) "
queryBuffer$ = queryBuffer$ + "       (*unique-inference-result-bindings* t) "
queryBuffer$ = queryBuffer$ + "       (*generate-readable-fi-results* nil)) "
queryBuffer$ = queryBuffer$ + "  (without-wff-semantics "
queryBuffer$ = queryBuffer$ + "    (ask-template '(" + variables + ") "
queryBuffer$ = queryBuffer$ + "                  '" + query + " "
queryBuffer$ = queryBuffer$ + "                  " + Mt + " "
queryBuffer$ = queryBuffer$ + "                  0 nil nil nil)))"

Command$ = queryBuffer
Reply$ = Direct(Command$)
askWithVariablesInMt = MsgIn
End Function



'---------------- getBackchainImplicationRulesInMt ----------------
Public Function getBackchainImplicationRulesInMt(predicate As String, Formula As String, Mt As String) As String

' //this.traceOn();
' return converseList(command.toString());
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
 Command$ = ""
 If (Mt = "#$InferencePsc") Or (Mt = "#$EverythingPsc") Then
            Command$ = Command$ + "(clet (backchain-rules formula) "
            Command$ = Command$ + "  (with-all-mts "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " :pos nil :backward) "
            Command$ = Command$ + "       (csetq formula (assertion-el-formula rule)) "
            Command$ = Command$ + "       (pwhen (cand (eq (first formula) #$implies) "
            Command$ = Command$ + "                    (unify-el-possible '" + Formula + " "
            Command$ = Command$ + "                                          (third formula))) "
            Command$ = Command$ + "         (cpush formula backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
        Else
            Command$ = Command$ + "(clet (backchain-rules formula) "
            Command$ = Command$ + "  (with-mt " + Mt + " "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " :pos nil :backward) "
            Command$ = Command$ + "       (csetq formula (assertion-el-formula rule)) "
            Command$ = Command$ + "       (pwhen (cand (eq (first formula) #$implies) "
            Command$ = Command$ + "                    (unify-el-possible '" + Formula + " "
            Command$ = Command$ + "                                          (third formula))) "
            Command$ = Command$ + "         (cpush formula backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
       End If

Reply$ = Direct(Command$)
getBackchainImplicationRulesInMt = MsgIn
End Function

'---------------- getForwardChainRulesInMt ----------------
Public Function getForwardChainRulesInMt(predicate As String, Formula As String, Mt As String) As String

' return converseList(command.toString());
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
 Command$ = ""
 If (Mt = "#$InferencePsc") Or (Mt = "#$EverythingPsc") Then
            Command$ = Command$ + "(clet (backchain-rules formula) "
            Command$ = Command$ + "  (with-all-mts "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " :pos nil :forward) "
            Command$ = Command$ + "       (csetq formula (assertion-el-formula rule)) "
            Command$ = Command$ + "       (pwhen (cand (eq (first formula) #$implies) "
            Command$ = Command$ + "                    (unify-el-possible '" + Formula + " "
            Command$ = Command$ + "                                          (third formula))) "
            Command$ = Command$ + "         (cpush formula backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
        Else
            Command$ = Command$ + "(clet (backchain-rules formula) "
            Command$ = Command$ + "  (with-mt " + Mt + " "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " :pos nil :forward) "
            Command$ = Command$ + "       (csetq formula (assertion-el-formula rule)) "
            Command$ = Command$ + "       (pwhen (cand (eq (first formula) #$implies) "
            Command$ = Command$ + "                    (unify-el-possible '" + Formula + " "
            Command$ = Command$ + "                                          (third formula))) "
            Command$ = Command$ + "         (cpush formula backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
       End If

Reply$ = Direct(Command$)
getForwardChainRulesInMt = MsgIn
End Function

'---------------- getBackchainRulesInMt ----------------
Public Function getBackchainRulesInMt(predicate As String, Mt As String) As String

Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
 Command$ = ""
 If (Mt = "#$InferencePsc") Or (Mt = "#$EverythingPsc") Then
            Command$ = Command$ + "(clet (backchain-rules) "
            Command$ = Command$ + "  (with-all-mts "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " "
            Command$ = Command$ + "                                :sense :pos "
            Command$ = Command$ + "                                :done nil "
            Command$ = Command$ + "                                :direction :backward) "
            Command$ = Command$ + "       (pwhen (eq (first (assertion-el-formula rule)) #$implies) "
            Command$ = Command$ + "         (cpush (assertion-el-formula rule) backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
        Else
            Command$ = Command$ + "(clet (backchain-rules) "
            Command$ = Command$ + "  (with-mt " + Mt + " "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " "
            Command$ = Command$ + "                                :sense :pos "
            Command$ = Command$ + "                                :done nil "
            Command$ = Command$ + "                                :direction :backward) "
            Command$ = Command$ + "       (pwhen (eq (first (assertion-el-formula rule)) #$implies) "
            Command$ = Command$ + "         (cpush (assertion-el-formula rule) backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
       End If
Reply$ = Direct(Command$)
getBackchainRulesInMt = MsgIn
End Function

'---------------- getForwardChainRulesInMt ----------------
Public Function getForwardChainRulesInMt2(predicate As String, Mt As String) As String

Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
 Command$ = ""
 If (Mt = "#$InferencePsc") Or (Mt = "#$EverythingPsc") Then
            Command$ = Command$ + "(clet (backchain-rules) "
            Command$ = Command$ + "  (with-all-mts "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " "
            Command$ = Command$ + "                                :sense :pos "
            Command$ = Command$ + "                                :done nil "
            Command$ = Command$ + "                                :direction :forward) "
            Command$ = Command$ + "       (pwhen (eq (first (assertion-el-formula rule)) #$implies) "
            Command$ = Command$ + "         (cpush (assertion-el-formula rule) backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
        Else
            Command$ = Command$ + "(clet (backchain-rules) "
            Command$ = Command$ + "  (with-mt " + Mt + " "
            Command$ = Command$ + "    (do-predicate-rule-index (rule " + predicate + " "
            Command$ = Command$ + "                                :sense :pos "
            Command$ = Command$ + "                                :done nil "
            Command$ = Command$ + "                                :direction :forward) "
            Command$ = Command$ + "       (pwhen (eq (first (assertion-el-formula rule)) #$implies) "
            Command$ = Command$ + "         (cpush (assertion-el-formula rule) backchain-rules)))) "
            Command$ = Command$ + "   backchain-rules)"
       End If
       
Reply$ = Direct(Command$)
getForwardChainRulesInMt2 = MsgIn
End Function

'---------------- Object getSymbolValue ----------------
Public Function getSymbolValue(cycSymbol As String) As Integer

'
' /**
' * Gets the value of a given KB symbol.  This is intended mainly for test case setup.
' *
' * @param symbol the KB symbol which will have a value bound
' * @return the value assigned to the symbol
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public Object getSymbolValue (CycSymbol cycSymbol)
' throws IOException, UnknownHostException, CycApiException {
' return converseObject("(symbol-value '" + cycSymbol + ")");
' }
Dim Command$, Reply$
Command$ = "(symbol-value '" + cycSymbol + ")"
Reply$ = Direct(Command$)
getSymbolValue = Val(MsgIn)
End Function

'---------------- setSymbolValue ----------------
Public Sub setSymbolValue(cycSymbol As String, value As String)

' /**
' * Sets a KB symbol to have the specified value.  This is intended mainly for test case setup.  If the symbol does
' * not exist at the KB, then it will be created and assigned the value.
' *
' * @param symbol the KB symbol which will have a value bound
' * @param value the value assigned to the symbol
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void setSymbolValue (CycSymbol cycSymbol, Object value)
' throws IOException, UnknownHostException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("csetq"));
' command.add(cycSymbol);
' command.add(value);
' converseVoid(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(csetq " + cycSymbol + " " + value + ")"

Reply$ = Direct(Command$)
' setSymbolValue = MsgIn
End Sub

'---------------- isWellFormedFormula ----------------
Public Function isWellFormedFormula(cycList As String) As Boolean

'
' /**
' * Returns <tt>true</tt> iff <tt>CycList</tt> represents a well formed formula.
' *
' * @param cycList the candidate well-formed-formula
' * @return true iff cycList represents a well formed formula
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isWellFormedFormula (CycList cycList)
' throws IOException, UnknownHostException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("with-all-mts"));
' CycList command1 = new CycList();
' command.add(command1);
' command1.add(CycObjectFactory.makeCycSymbol("el-wff?"));
' CycList command2 = new CycList();
' command1.add(command2);
' command2.add(CycObjectFactory.quote);
' command2.add(cycList);
' return converseBoolean(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(with-all-mts (el-wff? '" + cycList + " ))"
Reply$ = Direct(Command$)
isWellFormedFormula = CheckTrue(MsgIn)
End Function

'---------------- rkfPhraseReader ----------------
Public Function rkfPhraseReader(text As String, parsingMt As String, domainMt As String) As String

'
' /**
' * Returns a list of parsing expressions, each consisting of a parsing span expression,
' * and a list of parsed terms.
' * <pre>
' * (RKF-PHRASE-READER "penguins" #$RKFEnglishLexicalMicrotheoryPSC #$InferencePSC)
' * ==>
' * (((0) (#$Penguin #$PittsburghPenguins)))
' * </pre>
' *
' * @param text the phrase to be parsed
' * @param parsingMt the microtheory in which lexical info is asked
' * @param domainMt the microtherory in which the info about candidate terms is asked
' * @return a parsing expression consisting of a parsing span expression, and a list
' * of parsed terms
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList rkfPhraseReader (String text, CycFort parsingMt, CycFort domainMt)
' throws IOException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("rkf-phrase-reader"));
' command.add(text);
' command.add(parsingMt);
' command.add(domainMt);
' return converseList(command);
' }
Dim Command$, Reply$
Dim Quote$
Quote$ = """"

' *****> INSERT CODE HERE <*****
Command$ = "(rkf-phrase-reader " + Quote$ + text + Quote$ + " " + parsingMt + " " + domainMt + ")"

Reply$ = Direct(Command$)
rkfPhraseReader = MsgIn
End Function

'---------------- generateDisambiguationPhraseAndTypes ----------------
Public Function generateDisambiguationPhraseAndTypes(objects As String) As String

'
' /**
' * Returns a list of disambiguation expressions, corresponding to each of the terms
' * in the given list of objects.
' *
' * <pre>
' * (GENERATE-DISAMBIGUATION-PHRASES-AND-TYPES (QUOTE (#$Penguin #$PittsburghPenguins)))
' * ==>
' * ((#$Penguin "penguin" #$Bird "bird")
' *  (#$PittsburghPenguins "the Pittsburgh Penguins" #$IceHockeyTeam "ice hockey team"))
' * </pre>
' *
' * @param objects the list of terms to be disambiguated
' * @return a list of disambiguation expressions, corresponding to each of the terms
' * in the given list of objects
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public CycList generateDisambiguationPhraseAndTypes (CycList objects)
' throws IOException, CycApiException {
' CycList command = new CycList();
' command.add(CycObjectFactory.makeCycSymbol("generate-disambiguation-phrases-and-types"));
' command.addQuoted(objects);
' return converseList(command);
' }
Dim Command$, Reply$

' *****> INSERT CODE HERE <*****
Command$ = "(generate-disambiguation-phrases-and-types (QUOTE " + objects + "))"

Reply$ = Direct(Command$)
generateDisambiguationPhraseAndTypes = MsgIn
End Function

'---------------- isFormulaWellFormedInMt ----------------
Public Function isFormulaWellFormedInMt(Formula As String, Mt As String) As Boolean

'
' /**
' * Returns true if formula is well-formed in the relevant mt.
' *
' * @param formula the given EL formula
' * @param mt the relevant mt
' * @return true if formula is well-formed in the relevant mt, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isFormulaWellFormed (CycList formula, CycFort mt)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(el-formula-ok? '" + formula.stringApiValue() +
' " " + mt.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(el-formula-ok? '" + Formula + " " + Mt + ")"
Reply$ = Direct(Command$)
isFormulaWellFormedInMt = CheckTrue(MsgIn)
End Function

'---------------- isCycLNonAtomicReifableTerm ----------------
Public Function isCycLNonAtomicReifableTerm(Formula As String) As Boolean

'
' /**
' * Returns true if formula is well-formed Non Atomic Reifable Term.
' *
' * @param formula the given EL formula
' * @return true if formula is well-formed Non Atomic Reifable Term, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isCycLNonAtomicReifableTerm (CycList formula)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(cycl-nart-p '" + formula.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(cycl-nart-p '" + Formula + ")"
Reply$ = Direct(Command$)
isCycLNonAtomicReifableTerm = CheckTrue(MsgIn)
End Function

'---------------- isCycLNonAtomicUnreifableTerm ----------------
Public Function isCycLNonAtomicUnreifableTerm(Formula As String) As Boolean

'
' /**
' * Returns true if formula is well-formed Non Atomic Un-reifable Term.
' *
' * @param formula the given EL formula
' * @return true if formula is well-formed Non Atomic Un-reifable Term, otherwise false
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public boolean isCycLNonAtomicUnreifableTerm (CycList formula)
' throws IOException, UnknownHostException, CycApiException {
' return converseBoolean("(cycl-naut-p '" + formula.stringApiValue() + ")");
' }
Dim Command$, Reply$
Command$ = "(cycl-naut-p '" + Formula + ")"
Reply$ = Direct(Command$)
isCycLNonAtomicUnreifableTerm = CheckTrue(MsgIn)
End Function

'--------------------------------------------------------------------
'---------------- SECOND PASS API EXTRACTION ------------------------
'--------------------------------------------------------------------
'---------------- CycConstant createCollectorMtInMt ----------------
Public Function createCollectorMtInMt(mtName As String, comment As String, genlMts As String) As Integer

'
' /**
' * Creates a new Collector microtheory and links it more general mts.
' *
' * @param mtName the name of the new collector microtheory
' * @param comment the comment for the new collector microtheory
' * @param genlMts the list of more general microtheories
' * @return the new microtheory
' */
' public CycConstant createCollectorMt (String mtName, String comment, ArrayList genlMts)
' throws IOException, CycApiException {
' CycConstant collectorMt = getKnownConstantByName("CollectorMicrotheory");
' return createMicrotheory(mtName, comment, collectorMt, genlMts);
' }
 createCollectorMtInMt = createMicrotheoryInMt(mtName, comment, "#$CollectorMicrotheory", genlMts)
End Function

'---------------- assertIsas ----------------
Public Sub assertIsas(fortNames As String, collectionName As String)

'
' /**
' * Asserts each of the given list of forts to be instances of
' * the given collection in the UniversalVocabularyMt
' *
' * @param fortNames the list of forts
' * @param collectionName
' */
' public void assertIsas (ArrayList fortNames, String collectionName)
' String collectionName)
' throws IOException, CycApiException {
' ArrayList forts = new ArrayList();
' for (int i = 0; i < forts.size(); i++) {
' Object fort = forts.get(i);
' if (fort instanceof String)
' forts.add(getKnownConstantByName((String) fort));
' else if (fort instanceof CycFort)
' forts.add(fort);
' else
' throw new CycApiException(fort + " is neither String nor CycFort");
' assertIsas(forts, getKnownConstantByName(collectionName));
' getKnownConstantByName(collectionName));
' }
Dim aFortName As String
Dim delims As String

delims = " "
aFortName = strtok(fortNames, delims)
While aFortName <> vbNullString
    If Left$(aFortName, 2) <> "#$" Then aFortName = "#$" + aFortName
    assertIsaInUniversalMt aFortName, collectionName
    aFortName = strtok(vbNullString, delims)
Wend

End Sub

'---------------- assertIsas ----------------
Public Sub assertIsas2(forts As String, collection As String)

'
' /**
' * Asserts each of the given list of forts to be instances of
' * the given collection in the UniversalVocabularyMt
' *
' * @param forts the list of forts
' * @param collection
' */
' public void assertIsas (ArrayList forts, CycFort collection)
' CycFort collection)
' throws IOException, CycApiException {
' for (int i = 0; i < forts.size(); i++) {
' assertIsa((CycFort) forts.get(i), collection);
' }
Dim aFortName As String
Dim delims As String

delims = " "
aFortName = strtok(forts, delims)
While aFortName <> vbNullString
    If Left$(aFortName, 2) <> "#$" Then aFortName = "#$" + aFortName
    assertIsaInUniversalMt aFortName, collection
    aFortName = strtok(vbNullString, delims)
Wend
End Sub

'---------------- CycConstant createSpindleMt ----------------
Public Function createSpindleMt(spindleMtName As String, comment As String, spindleHeadMt As String, spindleCollectorMt) As String

'
' /**
' * Creates a new spindle microtheory in the given spindle system.
' *
' * @param spindleMtName the name of the new spindle microtheory
' * @param comment the comment for the new spindle microtheory
' * @param spindleHeadMtName the name of the spindle head microtheory
' * @param spindleCollectorMtName the name of the spindle head microtheory
' * @return the new spindle microtheory in the given spindle system
' */
'    public CycConstant createSpindleMt (String spindleMtName,
'                                        String comment,
'                                        CycFort spindleHeadMt,
'                                        CycFort spindleCollectorMt)
' throws IOException, CycApiException {
'        CycConstant spindleMt = getKnownConstantByName("SpindleMicrotheory");
'        ArrayList genlMts = new ArrayList();
'        genlMts.add(spindleHeadMt);
'        CycConstant mt = this.createMicrotheory(spindleMtName,
'                                               comment,
'                                                spindleMt,
'                                                genlMts);
'        assertGaf(universalVocabularyMt,
'                  genlMt,
'                  spindleCollectorMt,
'                  mt);
'        return mt;
'        }
Dim Mt As String


Mt = createMicrotheoryInMt(spindleMtName, comment, spindleMt_const, spindleHeadMt)
assertGaf universalVocabularyMt_const, genlMt_const, spindleCollectorMt, Mt
createSpindleMt = Mt

End Function
'**** NON FUNCTIONAL
'---------------- CycConstant createBinaryPredicate ----------------
Public Function createBinaryPredicate(predicateName As String, predicateType As String, comment As String, arg1Isa As String, arg2Isa As String, arg1Format As String, arg2Format As String, genlsPred As String, genFormatString As String, genFormatList As String) As String

'
' /**
' * Creates a new binary predicate term.
' *
' * @param predicateName the name of the new binary predicate
' * @param predicateType the type of binary predicate, for example
' * #$TransitiveBinaryPredicate, which when null defaults to #$BinaryPredicate
' * @param comment the comment for the new binary predicate, or null
' * @param arg1Isa the argument position one type constraint, or null
' * @param ar2Isa the argument position two type constraint, or null
' * @param arg1Format the argument position one format constraint, or null
' * @param arg2Format the argument position two format constraint, or null
' * @param genlsPreds the more general binary predicate of which this new
' * predicate is a specialization, that when null defaults to
' * #$conceptuallyRelated
' * @param genFormat the paraphrase generation string, or null
' * @return the new binary predicate term
' */
' public CycConstant createBinaryPredicate (String predicateName, CycFort predicateType, String comment,  CycFort arg2Isa, at, CycFort arg2Format, s, String genFormatString, )
' throws IOException, CycApiException {
' CycConstant predicate = findOrCreate(predicateName);
' if (predicateType == null)
' assertIsa(predicate, binaryPredicate);
' else
' assertIsa(predicate, predicateType);
' if (comment != null)
' assertComment(predicate, comment, baseKB);
' if (arg1Isa != null)
' assertArgIsa(predicate, 1, arg1Isa);
' if (arg2Isa != null)
' assertArgIsa(predicate, 2, arg2Isa);
' if (arg1Format != null)
' assertArgFormat(predicate, 1, arg1Format);
' if (arg2Format != null)
' assertArgFormat(predicate, 2, arg2Format);
' if (genlPreds == null)
' assertGenlPreds(predicate, // #$conceptuallyRelated getKnownConstantByGuid("bd58803e-9c29-11b1-9dad-c379636f7270"));
' else
' assertGenlPreds(predicate, genlPreds);
' if (genFormatString != null && genFormatList != null)
' assertGenFormat(predicate, genFormatString, genFormatList);
' return predicate;
' }
Dim predicate As String

predicate = findOrCreate(predicateName)
 If predicateType = "" Then
    assertIsa2 predicate, binaryPredicate_const
 Else
    assertIsa2 predicate, predicateType_const
 End If
 If comment <> "" Then assertCommentInMt predicate, comment, baseKB_const
 If arg1Isa <> "" Then assertArgIsa predicate, 1, arg1Isa
 If arg2Isa <> "" Then assertArgIsa predicate, 2, arg2Isa
 If arg1Format <> "" Then assertArgFormat predicate, 1, arg1Format
 If arg2Format <> "" Then assertArgFormat predicate, 2, arg2Format
 If genlsPred = "" Then
    assertGenlPreds predicate, "#$conceptuallyRelated" '// #$conceptuallyRelated getKnownConstantByGuid"bd58803e-9c29-11b1-9dad-c379636f7270"
 Else
    assertGenlPreds predicate, genlsPred
 End If
 
 If genFormatString <> "" And genFormatList <> "" Then
    assertGenFormat predicate, genFormatString, genFormatList
 End If
 createBinaryPredicate = predicate
End Function
'***** NON FUNCTIONAL
'---------------- CycConstant createKbSubsetCollection ----------------
Public Function createKbSubsetCollection(constantName As String, comment As String) As String

'
' /**
' * Creates a new KB subset collection term.
' *
' * @param constantName the name of the new KB subset collection
' * @param comment the comment for the new KB subset collection
' * @return the new KB subset collection term
' */
' public CycConstant createKbSubsetCollection (String constantName, String comment)
' String comment)
' throws IOException, CycApiException {
' CycConstant kbSubsetCollection = getKnownConstantByName("KBSubsetCollection");
' CycConstant cycConstant = getConstantByName(constantName);
' if (cycConstant == null)
' cycConstant = createNewPermanent(constantName);
' assertIsa(cycConstant, kbSubsetCollection);
' assertComment(cycConstant, comment, baseKB);
' assertGenls(cycConstant, thing);
' CycFort variableOrderCollection =
' getKnownConstantByGuid("36cf85d0-20a1-11d6-8000-0050dab92c2f");
' assertIsa(cycConstant, variableOrderCollection, baseKB);
' return cycConstant;
' }
Dim CycConstant As String
CycConstant = getConstantByName(constantName)
 If (CycConstant = "") Then CycConstant = createNewPermanent(constantName)
 assertIsa2 CycConstant, "#$KBSubsetCollection"
 assertCommentInMt CycConstant, comment, baseKB_const
 assertGenls2 CycConstant, "#$Thing"
 assertIsaInMt CycConstant, "#$variableOrderCollection", baseKB_const
 createKbSubsetCollection = CycConstant
End Function
'**** NON FUNCTIONAL
'---------------- CycConstant createCollection ----------------
Public Function createCollection(collectionName As String, comment As String, commentMtName As String, isaName As String, genlsName As String) As Integer

'
' /**
' * Creates a new collection term.
' *
' * @param collectionName the name of the new collection
' * @param comment the comment for the collection
' * @param commentMtName the name of the microtheory in which the comment is asserted
' * @param isaName the name of the collection of which the new collection is an instance
' * @param genlsName the name of the collection of which the new collection is a subset
' * @return the new collection term
' */
' public CycConstant createCollection (String collectionName, String comment, String commentMtName, String genlsName)
' throws IOException, CycApiException {
' CycConstant collection = findOrCreate(collectionName);
' assertComment(collection, comment, getKnownConstantByName(commentMtName));
' assertIsa(collection, getKnownConstantByName(isaName));
' assertGenls(collection, getKnownConstantByName(genlsName));
' return collection;
' }
Dim collection As String
 collection = findOrCreate(collectionName)
 assertCommentInMt collection, comment, getKnownConstantByName(commentMtName)
 assertIsa2 collection, getKnownConstantByName(isaName)
 assertGenls2 collection, getKnownConstantByName(genlsName)
 createCollection = collection
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createCollection ----------------
Public Function createCollection2(collectionName As String, comment As String, commentMt As String, isa As String, genls As String) As Integer

'
' /**
' * Creates a new collection term.
' *
' * @param collection the name of the new collection
' * @param comment the comment for the collection
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new collection is an instance
' * @param genls the collection of which the new collection is a subset
' * @return the new collection term
' */
' public CycFort createCollection (String collectionName, String comment, CycFort commentMt, CycFort genls)
' throws IOException, CycApiException {
' return createCollection(findOrCreate(collectionName), comment, commentMt, genls);
' }
createCollection2 = createCollection(findOrCreate(collectionName), comment, commentMt, isa, genls)
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createCollection ----------------
Public Function createCollection3(collection As String, comment As String, commentMt As String, isa As String, genls As String) As Integer

'
' /**
' * Creates a new collection term.
' *
' * @param collection the new collection
' * @param comment the comment for the collection
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new collection is an instance
' * @param genls the collection of which the new collection is a subset
' * @return the new collection term
' */
' public CycFort createCollection (CycFort collection, String comment, CycFort commentMt, CycFort genls)
' throws IOException, CycApiException {
' assertComment(collection, comment, commentMt);
' assertIsa(collection, isa);
' assertGenls(collection, genls);
' return collection;
' }
 assertCommentInMt collection, comment, commentMt
 assertIsa2 collection, isa
 assertGenls2 collection, genls
 createCollection3 = collection
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createIndivDenotingUnaryFunction ----------------
Public Function createIndivDenotingUnaryFunction(unaryFunction As String, comment As String, commentMt As String, isa As String, arg1Isa As String, resultIsa As String) As String

'
' /**
' * Creates a new individual-denoting reifiable unary function term.
' *
' * @param unaryFunction the new collection
' * @param comment the comment for the unary function
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new unary function is an instance
' * @param arg1Isa the kind of objects this unary function takes as its argument
' * @param resultIsa the kind of object represented by this reified term
' * @return the new individual-denoting reifiable unary function term
' */
' public CycFort createIndivDenotingUnaryFunction (String unaryFunction, String comment, String commentMt, String resultIsa)
' throws IOException, CycApiException {
' return createIndivDenotingUnaryFunction (
' findOrCreate(unaryFunction), comment, getKnownConstantByName(commentMt),
' getKnownConstantByName(arg1Isa), getKnownConstantByName(resultIsa));
' }


createIndivDenotingUnaryFunction = createIndivDenotingUnaryFunction(findOrCreate(unaryFunction), comment, getKnownConstantByName(commentMt), getKnownConstantByName(arg1Isa), getKnownConstantByName(resultIsa), getKnownConstantByName(resultIsa))
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createIndivDenotingUnaryFunction ----------------
Public Function createIndivDenotingUnaryFunction2(unaryFunction As String, comment As String, isa As String, arg1Isa As String, commentMt As String, resultIsa As String) As String

'
' /**
' * Creates a new individual-denoting reifiable unary function term.
' *
' * @param unaryFunction the new collection
' * @param comment the comment for the unary function
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new unary function is an instance
' * @param arg1Isa the kind of objects this unary function takes as its argument
' * @param resultIsa the kind of object represented by this reified term
' * @return the new individual-denoting reifiable unary function term
' */
' public CycFort createIndivDenotingUnaryFunction (CycFort unaryFunction, String comment, CycFort commentMt, CycFort resultIsa)
' throws IOException, CycApiException {
' assertComment(unaryFunction, comment, commentMt);
' // (#$isa unaryFunction #$UnaryFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd58af89-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd58af89-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$ReifiableFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$IndividualDenotingFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd58fad9-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd58fad9-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$Function-Denotational)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' assertArgIsa(unaryFunction, 1, arg1Isa);
' assertResultIsa(unaryFunction, resultIsa);
' return unaryFunction;
' }

  assertCommentInMt unaryFunction, comment, commentMt
  '//  #$isa unaryFunction #$UnaryFunction
  assertIsa2 unaryFunction, getKnownConstantByGuid("bd58af89-9c29-11b1-9dad-c379636f7270")

  '//  #$isa unaryFunction #$ReifiableFunction
  assertIsa2 unaryFunction, getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270")

  '//  #$isa unaryFunction #$IndividualDenotingFunction
  assertIsa2 unaryFunction, getKnownConstantByGuid("bd58fad9-9c29-11b1-9dad-c379636f7270")

  '//  #$isa unaryFunction #$Function-Denotational
  assertIsa2 unaryFunction, getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270")

  assertArgIsa unaryFunction, 1, arg1Isa
  assertResultIsa unaryFunction, resultIsa
 createIndivDenotingUnaryFunction2 = unaryFunction
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createCollectionDenotingUnaryFunction ----------------
Public Function createCollectionDenotingUnaryFunction(unaryFunction As String, comment As String, commentMt As String, arg1Isa As String, arg1GenlName As String, resultIsa As String, resultGenlName As String) As Integer

'
' /**
' * Creates a new collection-denoting reifiable unary function term.
' *
' * @param unaryFunction the new collection
' * @param comment the comment for the unary function
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new unary function is an instance
' * @param arg1Isa the isa type constraint for the argument
' * @param arg1GenlName the genls type constraint for the argument if it is a collection
' * @param resultIsa the isa object represented by this reified term
' * @param resultGenlName the genls object represented by this reified term
' * @return the new collection-denoting reifiable unary function term
' */
' public CycFort createCollectionDenotingUnaryFunction (String unaryFunction, String comment, String commentMt, String arg1GenlName, String resultGenlName)
' throws IOException, CycApiException {
' CycFort arg1Genl;
' if (arg1GenlName != null)
' arg1Genl = getKnownConstantByName(arg1GenlName);
' else
' arg1Genl = null;
' CycFort resultGenl;
' if (resultGenlName != null)
' resultGenl = getKnownConstantByName(resultGenlName);
' else
' resultGenl = null;
' return createCollectionDenotingUnaryFunction (
' findOrCreate(unaryFunction), comment, getKnownConstantByName(commentMt),
' getKnownConstantByName(arg1Isa), arg1Genl, getKnownConstantByName(resultIsa),
' resultGenl);
' }

  Dim arg1Genl As String
  If (arg1GenlName <> "") Then
    arg1Genl = getKnownConstantByName(arg1GenlName)
  Else
    arg1Genl = ""
  End If
  Dim resultGenl As String
  If (resultGenlName <> "") Then
    resultGenl = getKnownConstantByName(resultGenlName)
  Else
    resultGenl = ""
  End If
  createCollectionDenotingUnaryFunction = createCollectionDenotingUnaryFunction3( _
  findOrCreate(unaryFunction), comment, getKnownConstantByName(commentMt), _
  getKnownConstantByName(arg1Isa), arg1Genl, getKnownConstantByName(resultIsa), _
  resultGenl)


'cycFort createCollectionDenotingUnaryFunction = Val(MsgIn)
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createCollectionDenotingUnaryFunction ----------------
Public Function createCollectionDenotingUnaryFunction3(unaryFunction As String, comment As String, commentMt As String, arg1Isa As String, arg1Genl As String, resultIsa As String, resultGenl As String) As Integer

'
' /**
' * Creates a new collection-denoting reifiable unary function term.
' *
' * @param unaryFunction the new collection
' * @param comment the comment for the unary function
' * @param commentMt the microtheory in which the comment is asserted
' * @param arg1Isa the isa type constraint for the argument
' * @param arg1Genl the genls type constraint for the argument if it is a collection
' * @param resultIsa the isa object represented by this reified term
' * @param resultGenl the genls object represented by this reified term
' * @return the new collection-denoting reifiable unary function term
' */
' public CycFort createCollectionDenotingUnaryFunction (CycFort unaryFunction, String comment, CycFort commentMt, CycFort arg1Genl, a, CycFort resultGenl)
' throws IOException, CycApiException {
' assertComment(unaryFunction, comment, commentMt);
' // (#$isa unaryFunction #$UnaryFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd58af89-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd58af89-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$ReifiableFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$CollectionDenotingFunction)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270"));
' // (#$isa unaryFunction #$Function-Denotational)
' assertIsa(unaryFunction, getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' assertArgIsa(unaryFunction, 1, arg1Isa);
' if (arg1Genl != null)
' assertArg1Genl(unaryFunction, arg1Genl);
' assertResultIsa(unaryFunction, resultIsa);
' if (resultGenl != null)
' assertResultGenl(unaryFunction, resultGenl);
' return unaryFunction;
' }
 assertCommentInMt unaryFunction, comment, commentMt
 '//  #$isa unaryFunction #$UnaryFunction
 assertIsa2 unaryFunction, "#$UnaryFunction"
 '//  #$isa unaryFunction #$ReifiableFunction
 assertIsa2 unaryFunction, "#$ReifiableFunction"
 '//  #$isa unaryFunction #$CollectionDenotingFunction
 assertIsa2 unaryFunction, "#$CollectionDenotingFunction"
 '//  #$isa unaryFunction #$Function-Denotational
 assertIsa2 unaryFunction, "#$Function-Denotational"
 assertArgIsa unaryFunction, 1, arg1Isa
 If arg1Genl <> "" Then assertArg1Genl unaryFunction, arg1Genl
 assertResultIsa unaryFunction, resultIsa
 If resultGenl <> "" Then assertResultGenl unaryFunction, resultGenl


 createCollectionDenotingUnaryFunction3 = unaryFunction
End Function
'**** NON FUNCTIONAL
'---------------- CycFort createCollectionDenotingBinaryFunction ----------------
Public Function createCollectionDenotingBinaryFunction(binaryFunction As String, comment As String, commentMt As String, arg1IsaName As String, arg2IsaName As String, arg1GenlsName As String, arg2GenlsName As String, resultIsa As String) As Integer
' /**
' * Creates a new collection-denoting reifiable binary function term.
' *
' * @param binaryFunction the new collection
' * @param comment the comment for the binary function
' * @param commentMt the microtheory in which the comment is asserted
' * @param isa the collection of which the new binary function is an instance
' * @param arg1Isa the kind of objects this binary function takes as its first
' * argument, or null
' * @param arg2Isa the kind of objects this binary function takes as its first
' * argument, or null
' * @param arg1Genls the general collections this binary function takes as its first
' * argument, or null
' * @param arg2Genls the general collections this binary function takes as its second
' * argument, or null
' * @param resultIsa the kind of object represented by this reified term
' * @return the new collection-denoting reifiable binary function term
' */
' public CycFort createCollectionDenotingBinaryFunction (CycFort binaryFunction, String comment, CycFort commentMt, CycFort arg2Isa, ls, CycFort arg2Genls, sa)
' throws IOException, CycApiException {
' assertComment(binaryFunction, comment, commentMt);
' // (#$isa binaryFunction #$BinaryFunction)
' assertIsa(binaryFunction, getKnownConstantByGuid("c0e7247c-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("c0e7247c-9c29-11b1-9dad-c379636f7270"));
' // (#$isa binaryFunction #$ReifiableFunction)
' assertIsa(binaryFunction, getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270"));
' // (#$isa binaryFunction #$CollectionDenotingFunction)
' assertIsa(binaryFunction, getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270"));
' // (#$isa binaryFunction #$Function-Denotational)
' assertIsa(binaryFunction, getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270"));
' if (arg1Isa != null)
' assertArgIsa(binaryFunction, 1, arg1Isa);
' if (arg2Isa != null)
' assertArgIsa(binaryFunction, 2, arg2Isa);
' if (arg1Genls != null)
' assertArg1Genl(binaryFunction, arg1Genls);
' if (arg2Genls != null)
' assertArg2Genl(binaryFunction, arg2Genls);
' assertResultIsa(binaryFunction, resultIsa);
' return binaryFunction;
' }
Dim Command$, Reply$
'public CycFort createCollectionDenotingBinaryFunction (CycFort binaryFunction, String comment, CycFort commentMt, CycFort arg2Isa, ls, CycFort arg2Genls, sa)
'throws IOException, CycApiException {'assertComment(binaryFunction, comment, commentMt// (#$isa binaryFunction #$BinaryFunction)'assertIsa(binaryFunction, getKnownConstantByGuid("c0e7247c-9c29-11b1-9dad-c379636f7270")getKnownConstantByGuid("c0e7247c-9c29-11b1-9dad-c379636f7270")// (#$isa binaryFunction #$ReifiableFunction)
'assertIsa(binaryFunction, getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270")getKnownConstantByGuid("bd588002-9c29-11b1-9dad-c379636f7270")// (#$isa binaryFunction #$CollectionDenotingFunction)'assertIsa(binaryFunction, getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270")getKnownConstantByGuid("bd58806a-9c29-11b1-9dad-c379636f7270")// (#$isa binaryFunction #$Function-Denotational)'assertIsa(binaryFunction, getKnownConstantByGuid("bd5c40b0-9c29-11b1-9dad-c379636f7270")
'getKnownConstantByGuid("bd5c40b0-9c29-11b1-9d _
'-c379636f7270")if (arg1Isa != null)'assertArgIsa(binaryFunction, 1, arg1Isaif (arg2Isa != null)'assertArgIsa(binaryFunction, 2, arg2Isaif (arg1Genls != null)'assertArg1Genl(binaryFunction, arg1Genlsif (arg2Genls != null)'assertArg2Genl(binaryFunction, arg2Genls
'assertResultIsa(binaryFunction, resultIsareturn binaryFunction;
AskCyc (Command$)
'
'*****> INSERT CODE HERE <*******

'cycFort createCollectionDenotingBinaryFunction = Val(MsgIn)
End Function
'**** NON FUNCTIONAL
'---------------- assertArgIsa ----------------
Public Sub assertArgIsa(relation As String, argPosition As Integer, argNIsa As String)

'
' /**
' * Assert an argument isa contraint for the given relation and argument position.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argPosition the given argument position
' * @param argNIsa the argument constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArgIsa (CycFort relation, int argPosition, CycFort argNIsa)
' throws IOException, UnknownHostException, CycApiException {
' // (#$argIsa relation argPosition argNIsa)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("bee22d3d-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(new Integer(argPosition));
' sentence.add(argNIsa);
' assertGaf(sentence, universalVocabularyMt);
' }
assertGafInMt universalVocabularyMt_const, "#$argIsa", relation, Str$(argPosition), argNIsa


End Sub
'**** NON FUNCTIONAL
'---------------- assertArg1Genl ----------------
Public Sub assertArg1Genl(relation As String, argGenl As String)

'
' /**
' * Assert an argument one genls contraint for the given relation.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argGenl the argument constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArg1Genl (CycFort relation, CycFort argGenl)
' CycFort argGenl)
' throws IOException, UnknownHostException, CycApiException {
' // (#$arg1Genl relation argGenl)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("bd588b1d-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(argGenl);
' assertGaf(sentence, universalVocabularyMt);
' }
assertGaf universalVocabularyMt_const, "#$arg1Genl", relation, argGenl


End Sub
'**** NON FUNCTIONAL
'---------------- assertArg2Genl ----------------
Public Sub assertArg2Genl(relation As String, argGenl As String)

'
' /**
' * Assert an argument two genls contraint for the given relation.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argGenl the argument constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArg2Genl (CycFort relation, CycFort argGenl)
' CycFort argGenl)
' throws IOException, UnknownHostException, CycApiException {
' // (#$arg2Genl relation argGenl)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("bd58dcda-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(argGenl);
' assertGaf(sentence, universalVocabularyMt);
' }

assertGaf universalVocabularyMt_const, "#$arg2Genl", relation, argGenl


End Sub
'**** NON FUNCTIONAL
'---------------- assertArg3Genl ----------------
Public Sub assertArg3Genl(relation As String, argGenl As String)

'
' /**
' * Assert an argument three genls contraint for the given relation.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argGenl the argument constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArg3Genl (CycFort relation, CycFort argGenl)
' CycFort argGenl)
' throws IOException, UnknownHostException, CycApiException {
' // (#$arg3Genl relation argGenl)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("bd58b8c3-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(argGenl);
' assertGaf(sentence, universalVocabularyMt);
' }

assertGaf universalVocabularyMt_const, "#$arg3Genl", relation, argGenl

End Sub
'**** NON FUNCTIONAL
'---------------- assertResultIsa ----------------
Public Sub assertResultIsa(denotationalFunction As String, resultIsa As String)

'
' /**
' * Assert the isa result contraint for the given denotational function.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param denotationalFunction the given denotational function
' * @param resultIsa the function's isa result constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertResultIsa (CycFort denotationalFunction, CycFort resultIsa)
' CycFort resultIsa)
' throws IOException, UnknownHostException, CycApiException {
' // (#$resultIsa denotationalFunction resultIsa)
' assertGaf(universalVocabularyMt, getKnownConstantByGuid("bd5880f1-9c29-11b1-9dad-c379636f7270"),
' getKnownConstantByGuid("bd5880f1-9c29-11b1-9dad-c379636f7270"), denotationalFunction, resultIsa);
' }
assertGaf universalVocabularyMt_const, "#$resultIsa", denotationalFunction, resultIsa

End Sub
'*** NON FUNCTIONAL
'---------------- assertResultGenl ----------------
Public Sub assertResultGenl(denotationalFunction As String, resultGenl As String)

'
' /**
' * Assert the genls result contraint for the given denotational function.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param denotationalFunction the given denotational function
' * @param resultGenl the function's genls result constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertResultGenl (CycFort denotationalFunction, CycFort resultGenl)
' CycFort resultGenl)
' throws IOException, UnknownHostException, CycApiException {
' // (#$resultGenl denotationalFunction resultGenls)
' assertGaf(universalVocabularyMt, getKnownConstantByGuid("bd58d6ab-9c29-11b1-9dad-c379636f7270"),
' getKnownConstantByGuid("bd58d6ab-9c29-11b1-9dad-c379636f7270"), denotationalFunction, resultGenl);
' }
assertGaf universalVocabularyMt_const, "#$resultIsa", denotationalFunction, resultGenl
End Sub
'**** NON FUNCTIONAL
'---------------- assertArg1FormatSingleEntry ----------------
Public Sub assertArg1FormatSingleEntry(relation As String)

'
' /**
' * Assert an argument contraint for the given relation and argument position.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argPosition the given argument position
' * @param argNIsa the argument constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArg1FormatSingleEntry (CycFort relation)
' throws IOException, UnknownHostException, CycApiException {
' // (#$arg1Format relation SingleEntry)
' assertArgFormat(relation, 1, getKnownConstantByGuid("bd5880eb-9c29-11b1-9dad-c379636f7270"));
' }
assertGaf universalVocabularyMt_const, "#$arg1Format", relation, "#$SingleEntry"

End Sub
'**** NON FUNCTIONAL
'---------------- assertArgFormat ----------------
Public Sub assertArgFormat(relation As String, argPosition As Integer, argNFormat As String)

'
' /**
' * Assert an argument format contraint for the given relation and argument position.
' * The operation will be added to the KB transcript for replication and archive.
' *
' * @param relation the given relation
' * @param argPosition the given argument position
' * @param argNFormat the argument format constraint
' * @throws UnknownHostException if cyc server host not found on the network
' * @throws IOException if a data communication error occurs
' * @throws CycApiException if the api request results in a cyc server error
' */
' public void assertArgFormat (CycFort relation, int argPosition, CycFort argNFormat)
' throws IOException, UnknownHostException, CycApiException {
' // (#$argFormat relation argPosition argNFormat)
' CycList sentence = new CycList();
' sentence.add(getKnownConstantByGuid("bd8a36e1-9c29-11b1-9dad-c379636f7270"));
' sentence.add(relation);
' sentence.add(new Integer(argPosition));
' sentence.add(argNFormat);
' assertGaf(sentence, baseKB);
' }
assertGafInMt universalVocabularyMt_const, "#$argFormat", relation, Str$(argPosition), argNFormat

End Sub
'**** NON FUNCTIONAL
'---------------- assertSynonymousExternalConcept ----------------
Public Sub assertSynonymousExternalConcept(cycTerm As String, informationSource As String, externalConcept As String, Mt As String)
', ws IOException, UnknownHostException, CycApiException { mousExternalConcept nownConstantByGuid("c0e2af4e-9c29-11b1-9dad-c379636f7270"));

'
' /**
' * Asserts that the given DAML imported term is mapped to the
' * given Cyc term.
' *
' * @param cycTerm the mapped Cyc term
' * @param informationSource the external indexed information source
' * @param externalConcept the external concept within the information source
' * @param mt the assertion microtheory
' */
' public void assertSynonymousExternalConcept (CycFort cycTerm, CycFort informationSource, String externalConcept, ws IOException, UnknownHostException, CycApiException { mousExternalConcept nownConstantByGuid("c0e2af4e-9c29-11b1-9dad-c379636f7270"));
' gaf.add(cycTerm);
' gaf.add(informationSource);
' gaf.add(externalConcept);
' assertGaf(gaf, mt);
' }
assertGafInMt Mt, "#$synonymousExternalConcept", cycTerm, informationSource, externalConcept

End Sub
'**** NON FUNCTIONAL
'---------------- assertSynonymousExternalConcept ----------------
Public Sub assertSynonymousExternalConcepts(cycTerm As String, informationSource As String, externalConcept As String, Mt As String)

'
' /**
' * Asserts that the given DAML imported term is mapped to the
' * given Cyc term.
' *
' * @param cycTerm the mapped Cyc term
' * @param informationSource the external indexed information source
' * @param externalConcept the external concept within the information source
' * @param mt the assertion microtheory
' */
' public void assertSynonymousExternalConcept (CycFort cycTerm, CycFort informationSource, String externalConcept, ws IOException, UnknownHostException, CycApiException { mousExternalConcept nownConstantByGuid("c0e2af4e-9c29-11b1-9dad-c379636f7270"));
' gaf.add(cycTerm);
' gaf.add(informationSource);
' gaf.add(externalConcept);
' assertGaf(gaf, mt);
' }
assertGafInMt Mt, "#$synonymousExternalConcept", cycTerm, informationSource, externalConcept

End Sub

'**** NON FUNCTIONAL

'---------------- assertGenPhraseCountNounSingular ----------------
Public Sub assertGenPhraseCountNounSingular(cycTerm As String, phrase As String)

'
' /**
' * Asserts a preferred name string for the given term using lexical singular count noun
' * assumptions.
' *
' * @param cycTerm the Cyc term
' * @param phrase the preferred phrase for this term
' */
' public void assertGenPhraseCountNounSingular (CycFort cycTerm, String phrase)
' throws IOException, UnknownHostException, CycApiException {
' CycList gaf = new CycList();
' // (#$genPhrase <term> #$CountNoun #$singular <phrase>) in
' // #$EnglishParaphaseMt
' gaf.add(getKnownConstantByGuid("bd5fb28e-9c29-11b1-9dad-c379636f7270"));
' gaf.add(cycTerm);
' gaf.add(getKnownConstantByGuid("bd588078-9c29-11b1-9dad-c379636f7270"));
' gaf.add(getKnownConstantByGuid("bd6757b8-9c29-11b1-9dad-c379636f7270"));
' gaf.add(phrase);
' CycFort mt = getKnownConstantByGuid("bda16220-9c29-11b1-9dad-c379636f7270");
' assertGaf(gaf, mt);
' }
Dim gaf As String
gaf = "(#$genPhrase " + cycTerm + " #$CountNoun #$singular " + phrase + " )"
assertGafInMt2 gaf, "#$EnglishParaphaseMt"
End Sub
'**** NON FUNCTIONAL
'---------------- assertGenPhraseCountNounPlural ----------------
Public Sub assertGenPhraseCountNounPlural(cycTerm As String, phrase As String)

'
' /**
' * Asserts a preferred name string for the given term using lexical singular count noun
' * assumptions.
' *
' * @param cycTerm the Cyc term
' * @param phrase the preferred phrase for this term
' */
' public void assertGenPhraseCountNounPlural (CycFort cycTerm, String phrase)
' throws IOException, UnknownHostException, CycApiException {
' CycList gaf = new CycList();
' // (#$genPhrase <term> #$CountNoun #$plural <phrase>) in
' // #$EnglishParaphaseMt
' gaf.add(getKnownConstantByGuid("bd5fb28e-9c29-11b1-9dad-c379636f7270"));
' gaf.add(cycTerm);
' gaf.add(getKnownConstantByGuid("bd588078-9c29-11b1-9dad-c379636f7270"));
' gaf.add(getKnownConstantByGuid("bd5a6853-9c29-11b1-9dad-c379636f7270"));
' gaf.add(phrase);
' CycFort mt = getKnownConstantByGuid("bda16220-9c29-11b1-9dad-c379636f7270");
' assertGaf(gaf, mt);
' }
Dim gaf As String
gaf = "(#$genPhrase " + cycTerm + " #$CountNoun #$plural " + phrase + " )"
assertGafInMt2 gaf, "#$EnglishParaphaseMt"
End Sub
'**** NON FUNCTIONAL
'---------------- ensureWffConstraints ----------------
Public Sub ensureWffConstraints(cycFort As String, isaConstraint As String, genlsConstraint As String)

'
' /**
' * Ensures that the given term meets the given isa and genl wff constraints
' * in the UniversalVocabularyMt.
' *
' * @param cycFort the given term
' * @param isaConstraint the given isa type constraint, or null
' * @param genlsConstraint the given genls type constraint, or null
' */
' public void ensureWffConstraints (CycFort cycFort, CycFort isaConstraint, CycFort genlsConstraint)
' throws IOException, UnknownHostException, CycApiException {
' if (isaConstraint != null &&
' (! isa(cycFort, isaConstraint, universalVocabularyMt)))
' assertIsa(cycFort, isaConstraint);
' if (genlsConstraint != null &&
' (! isSpecOf(cycFort, genlsConstraint, universalVocabularyMt)))
' assertGenls(cycFort, genlsConstraint);
' }

If isaConstraint <> "" And Not (isa(cycFort, isaConstraint)) Then assertIsa2 cycFort, isaConstraint
If genlsConstraint <> "" And Not (isSpecOf(cycFort, genlsConstraint)) Then assertGenls2 cycFort, genlsConstraint

End Sub

Function getKnownConstantByGuid(ByVal GUID As String) As String
Dim Command$, Reply$
Command$ = "(FIND-CONSTANT-BY-EXTERNAL-ID (string-to-guid " + Chr(34) + GUID + Chr(34) + "))"
Reply$ = Direct(Command$)
If Val(MsgIn) > 0 Then
    getKnownConstantByGuid = Trim$(Mid$(MsgIn, 4))
Else
    getKnownConstantByGuid = MsgIn
End If
End Function
Function getCycConstantByName(ByVal Name As String) As String
Dim Command$, Reply$
Command$ = "(FIND-CONSTANT " + Name + ")"
Reply$ = Direct(Command$)
If Val(MsgIn) > 0 Then
    getCycConstantByName = Trim$(Mid$(MsgIn, 4))
Else
    getCycConstantByName = MsgIn
End If
End Function
Function getKnownConstantByName(ByVal constantName As String) As String
Dim Command$, Reply$
Dim Name As String
 
Name = constantName
If Left$(constantName, 2) <> "#$" Then Name = "#$" + constantName
 
Command$ = "(FIND-CONSTANT " + Name + ")"
Reply$ = Direct(Command$)
If Val(MsgIn) > 0 Then
    getKnownConstantByName = Trim$(Mid$(MsgIn, 4))
Else
    getKnownConstantByName = MsgIn
End If
End Function
Function getConstantByName(ByVal constantName As String) As String
Dim Command$, Reply$
Dim Name As String

Name = constantName
If Left$(constantName, 2) <> "#$" Then Name = "#$" + constantName
Command$ = "(FIND-OR-CREATE-CONSTANT " + Name + ")"
Reply$ = Direct(Command$)
If Val(MsgIn) > 0 Then
    getConstantByName = Trim$(Mid$(MsgIn, 4))
Else
    getConstantByName = MsgIn
End If
End Function
Function getCycConstantCacheByName(ByVal Name As String) As String
   getCycConstantCacheByName = getConstantByName(Name)
End Function

Function isSpecOf(spec As String, genl As String) As Boolean
    isSpecOf = isGenlOf(genl, spec)
End Function

Function findOrCreate(ByVal constantName As String) As String
Dim Command$, Reply$
Dim Name As String
 
Name = constantName
If Left$(constantName, 2) <> "#$" Then Name = "#$" + constantName

Command$ = "(FIND-OR-CREATE-CONSTANT " + Name + ")"
Reply$ = Direct(Command$)
If Val(MsgIn) > 0 Then
    findOrCreate = Trim$(Mid$(MsgIn, 4))
Else
    findOrCreate = MsgIn
End If

End Function

Function createNewPermanet(ByVal constantName As String)
    createNewPermanet = makeCycConstant(constantName)
End Function
'-----------------------------------------------------------
' AUX FUNCTIONS
'-----------------------------------------------------------
Public Sub File_writeImage(FileName As String)
Dim Command$, Reply$, FN$
FN$ = FileName$
FN$ = Chr$(34) + FN$ + Chr$(34)
Command$ = "(write-image " + FN$ + " )"
Reply$ = Direct(Command$)

End Sub
Public Sub File_loadImage(FileName As String)
Dim Command$, Reply$, FN$
FN$ = FileName$
FN$ = Chr$(34) + FN$ + Chr$(34)
Command$ = "(load-image " + FN$ + " )"
Reply$ = Direct(Command$)

End Sub

Public Function ListMicrotheory(Mt As String) As String
'From Yepster and jzhuk on how to list a microtheroy contents
Dim Command$, Reply$
Command$ = "(mapcar #'assertion-el-formula (gather-mt-index " + Mt + "))"
Reply$ = Direct(Command$)
ListMicrotheory = MsgIn
End Function

'-----------------------------------------------------------
' PLANNER FUNCTIONS
'-----------------------------------------------------------
' (#$preconditionFor-Props CONDITION ACTION)
'
'ex:       (#$preconditionFor-Props
'             (#$and (#$isa ?CLEANSER #$CleaningSubstance)
'                    (#$possesses ?AGT ?CLEANSER)
'                    (#$possesses ?AGT ?OBJECT))
'             (#$cleans ?AGT ?OBJECT))

'
' (#$effectOFAction-Props ACTION EFFECTS)
' ex:   (#$effectOfAction-Props (#$cleans ?AGT ?OBJ) (#$not (#$dirtinessOfObject ?OBJ #$ALittleDirty))

'
' (#$effectOfActionIf-Props ACTION CONDITION EFFECTS)
' ex: (#$effectOfActionIf-Props (#$cleans ?AGT ?OBJ)
'       (#$and (#$dirtinessOfObject ?OBJ ?OLD-DIRTINESS)
'               (#$followingValue ?NEW-DIRTYNESS ?OLD-DIRTYNESS))
'       (#$and (#$not (#$dirtynessOfObject ?OBJ ?OLD-DIRTYNESS))
'                      (#$dirtynessOfObject ?OBJ ?NEW-DIRTYNESS)))
'
' (#$methodForAction ....)
'
' decompostion:     (#$implies FORMULA
'                       (#$methodForAction (COMPLEXACTIONPRED . ARGS)
'                           (#$actionSequence
'                               (#$TheList
'                                   (SUBACTION1 )
'                                   (SUBACTION2 )
'                                   (SUBACTION3 )))))
'
'(#$sufficientFor-Props CONDITION-FORMULA ACTION-SENTENCE)
' ex:          (#$sufficientFor-Props
'                   (#$dirtynessOfObject ?OBJECT #$Sterile)
'                   (#$cleans ?AGT ?OBJECT))

'
' #$PlanningDomainMicrotheory as genlMt of target planning MT
'
'
'The OpenCyc Planner is easy to use, it can be accessed with one function: SHOP-FIND-PLANS.
'
'function SHOP-FIND-PLANS: (task mt &optional (verbose 0) number time depth backchain)
'   Returns a list of action sequences each of which are a plan for TASK in the context of MT.
'
'TASK
'   a formula with an instance of #$ActionSequence as its first argument.
'mt
'   a microtheory that gives context to the planning problem.
'VERBOSE
'   an integer between 0 and 9, that controls how much logging information shop should send to standard output.
'Number
'   the maximum number of plans to return.
'Time
'   the maximum amount of time allocated to the planner.
'Depth
'   the maximum depth the planner can reach searching for plans.
'Backchain
'   the maximum number of backchains allowed when querying the KB when matching rule conditions.

Public Sub Planner_Precondition(Condition As String, Action As String, Mt As String)
Dim Formulam As String
'"A binary predicate that relates instances of ELSentence-Assertible to
'instances of ELSentence-Assertible. preconditionFor-Props is used to state
'that one formula expresses a necessary precondition for the truth of another.
'(preconditionFor-Props COND PROP) means that PROP isn't true unless COND is true.
'Preconditions of various types are distinguished by the more specialized predicates
'#$legalPreconditionFor and #$causalPreconditionFor.
'See also sufficientFor-Props."

Formulam = "(#$preconditionFor-Props " + Condition + " " + Action + ")"
assertGafInMt2 Formulam, Mt
End Sub
Public Sub Planner_PreconditionForMethod(Condition As String, Method As String, Mt As String)
Dim Formulam As String
'"A binary predicate that relates instances of ELTemplate to instances of ELTemplate.
'preconditionForMethod is used to state that one formula expresses a necessary precondition
'for the truth of another sentence that expresses a way to do something.
'(preconditionForMethod COND METHOD) means that METHOD does not express a suitable
'   decomposition for an action unless COND is true."
Formulam = "(#$preconditionForMethod " + Condition + " " + Method + ")"
assertGafInMt2 Formulam, Mt
End Sub

Public Sub Planner_effectOfAction(Action As String, Effects As String, Mt As String)
Dim Formulam As String
Formulam = "(#$effectsOfAction-Props " + Action + " " + Effects + ")"
assertGafInMt2 Formulam, Mt
End Sub
Public Sub Planner_effectOfActionIf(Action As String, Condition As String, Effects As String, Mt As String)
Dim Formulam As String
Formulam = "(#$effectsOfActionIf-Props " + Action + " " + Condition + " " + Effects + ")"
assertGafInMt2 Formulam, Mt
End Sub

Public Sub Planner_methodForAction(Formula As String, ComplexActionPred As String, Args As String, SubActionList As String, Mt As String)
Dim Formulam As String
Formulam = "(#$implies " + Formula
Formulam = Formulam + " (methodForAction " + ComplexActionPred + " " + Args + ")"
Formulam = Formulam + " (#$actionSequence (#$TheList " + SubActionList + "))"
Formulam = Formulam + "))"
assertGafInMt2 Formulam, Mt
End Sub

Public Sub Planner_sufficientFor(ConditionFormula As String, ActionSentence As String, Mt As String)
Dim Formulam As String
Formulam = "(#$sufficientFor-Props " + ConditionFormula + " " + ActionSentence + " )"
assertGafInMt2 Formulam, Mt
End Sub
Public Function Planner_createPlanningMt(PlanningMt As String, comment As String) As String
Planner_createPlanningMt = createMicrotheoryInMt(PlanningMt, comment, "#$PlanningDomainMicrotheory", "")
End Function
Public Sub Planner_assertSimpleActionPredicate(Action As String, comment As String, Mt As String)
Dim Result As String
Result = createBinaryPredicate(Action, "", comment, "", "", "", "", "#$SimpleActionPredicate", "", "")
End Sub
Public Sub Planner_assertSimpleBinaryActionPredicate(Action As String, comment As String, arg1Isa As String, arg2Isa As String, Mt As String)
' arg1Isa As String, arg2Isa As String, arg1Format As String, arg2Format As String, genlsPred As String, genFormatString As String, genFormatList As String)
Dim Result As String
Dim l_arg1Isa As String
Dim l_arg2Isa As String

l_arg1Isa = arg1Isa
l_arg2Isa = arg2Isa
If l_arg1Isa = "" Then l_arg1Isa = "#$Agent"
If l_arg2Isa = "" Then l_arg1Isa = "#$Thing"
Result = createBinaryPredicate(Action, "#$BinaryPredicate", comment, l_arg1Isa, l_arg2Isa, "", "", "#$SimpleActionPredicate", "", "")
End Sub

Public Sub Planner_assertComplexActionPredicate(Action As String, comment As String, Mt As String)

Dim Result As String
Result = createBinaryPredicate(Action, "", comment, "", "", "", "", "#$ComplexActionPredicate", "", "")
End Sub

'The OpenCyc Planner is easy to use, it can be accessed with one function: SHOP-FIND-PLANS.
'
'function SHOP-FIND-PLANS: (task mt &optional (verbose 0) number time depth backchain)
'   Returns a list of action sequences each of which are a plan for TASK in the context of MT.
'
'TASK
'   a formula with an instance of #$ActionSequence as its first argument.
'mt
'   a microtheory that gives context to the planning problem.
'VERBOSE
'   an integer between 0 and 9, that controls how much logging information shop should send to standard output.
'Number
'   the maximum number of plans to return.
'Time
'   the maximum amount of time allocated to the planner.
'Depth
'   the maximum depth the planner can reach searching for plans.
'Backchain
'   the maximum number of backchains allowed when querying the KB when matching rule conditions.
'
' for example:
'CYC(1): (csetq plans (shop-find-plans '(#$doDefineProgramFunctionFromAlgorithm #$Thing #$Thing #$MaxElementComputation) #$CProgrammingTestMt)
'CYC(2): (punless (null plans) (csetq actions (shop-plan-simple-actions (first plans))))
'
Public Function Planner_createPlans(Task As String, Mt As String, Verbose As Integer, _
                                   NumberOfPlans As Integer, Time As Integer, Depth As Integer, BackChain As Integer) As String

Dim Formulam As String
Dim Reply As String
Dim secondp As Integer

'The csetq requires multi-interactions per session
DirectOpen
DirectSend "(csetq vbplans (shop-find-plans " + Task + " " + Mt + Str$(Verbose) + " " + Str$(NumberOfPlans) + " " + Str$(Time) + " " + Str$(Depth) + " " + Str$(BackChain) + " ))"
MsgIn = "" 'clear the results unless we wish to parse them latter
DirectSend "(mapcar #'shop-plan-simple-actions vbplans)"
DirectClose

'If the system returns double responses, use the second one
secondp = InStr(5, MsgIn, "200 (((")
If secondp > 0 Then
    MsgIn = Mid$(MsgIn, secondp + 4)
End If
If Val(MsgIn) > 0 Then
    strCreatedPlans = Trim$(Mid$(MsgIn, 4))

Else
    strCreatedPlans = MsgIn
End If

Planner_createPlans = strCreatedPlans
End Function
Public Property Get Planner_lastplan() As String
  Planner_lastplan = strCreatedPlans
End Property

